Package: deldir
Version: 2.0-4
Date: 2024-02-27
Title: Delaunay Triangulation and Dirichlet (Voronoi) Tessellation
Author: Rolf Turner
Maintainer: Rolf Turner <rolfturner@posteo.net>
Depends: R (>= 3.5.0)
Suggests: polyclip
Imports: graphics, grDevices
Description: Calculates the Delaunay triangulation and the Dirichlet
	or Voronoi tessellation (with respect to the entire plane) of
	a planar point set. Plots triangulations and tessellations in
	various ways.  Clips tessellations to sub-windows. Calculates
	perimeters of tessellations.  Summarises information about
	the tiles of the tessellation.	Calculates the centroidal
	Voronoi (Dirichlet) tessellation using Lloyd's algorithm.
LazyData: true
ByteCompile: true
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2024-02-27 02:48:30 UTC; rolf
Repository: CRAN
Date/Publication: 2024-02-28 04:00:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 09:44:01 UTC; unix
Archs: deldir.so.dSYM

# Export everything
exportPattern("*")
S3method(plot,deldir)
S3method(plot,tile.list)
S3method(plot,triang.list)
S3method("[",tile.list)
S3method("[",triang.list)
S3method(divchain,default)
S3method(divchain,deldir)
S3method(plot,divchain)
S3method(print,tileInfo)
S3method(print,deldir)
importFrom("grDevices", "col2rgb", "rgb")
importFrom("graphics", "axis", "box", "par", "plot", "points",
             "polygon", "rect", "segments", "text", "title")
importFrom("utils","packageVersion")
useDynLib(deldir)

 
 This package computes and plots the Dirichlet (Voronoi) tesselation
 and the Delaunay triangulation of a set of of data points and
 possibly a superimposed ``grid'' of dummy points.

 The tesselation is constructed with respect to the whole plane
 by suspending it from ideal points at infinity.

 ORIGINALLY PROGRAMMED BY: Rolf Turner in 1987/88, while with the
 Division of Mathematics and Statistics, CSIRO, Sydney, Australia.
 Re-programmed by Rolf Turner to adapt the implementation from a
 stand-alone Fortran program to an S function, while visiting the
 University of Western Australia, May 1995.  Further revised
 December 1996, October 1998, April 1999, and February 2002.
 Adapted to an R package 21 February 2002.

 This R package continues to be revised and updated from time to time.

 Current address of the author:

		Department of Statistics
                University of Auckland
                Private Bag 92019
                Auckland 1142
                New Zealand
 Email:
                r.turner@auckland.ac.nz

 The author gratefully acknowledges the contributions, assistance,
 and guidance of Mark Berman, of D.M.S., CSIRO, in collaboration with
 whom this project was originally undertaken.  The author also
 acknowledges much useful advice from Adrian Baddeley, formerly of
 D.M.S. CSIRO (now Professor of Statistics at Curtin University in
 Western Australia).  Daryl Tingley of the Department of Mathematics
 and Statistics, University of New Brunswick provided some helpful
 insight.  Special thanks are extended to Alan Johnson, of the Alaska
 Fisheries Science Centre, who supplied two data sets which were
 extremely valuable in tracking down some errors in the code.

 Don MacQueen, of Lawrence Livermore National Lab, wrote an Splus
 driver function for the old stand-alone version of this software.
 That driver, which was available on Statlib, is now deprecated in
 favour of this current package.  Don also collaborated in the
 preparation of this current package.

 Bill Dunlap of MathSoft Inc. tracked down a bug which was making
 the deldir() function crash on some systems, and pointed out some
 other improvements to be made.

 Berwin Turlach of the Department of Maths and Stats at the
 University of Western Australia pointed out a bug in the procedure
 for eliminating duplicated points.

 Many others have contributed to the package over the years by
 pointing out bugs and suggesting fixes.  Most of these contributors
 are acknowledged in the ChangeLog and possibly in the help files.
 I apologise to those whom I have overlooked or neglected to include.
 It's just ineptitude, not malice!

 The Fortran code contained in the src directory, is ponderous
 --- it was automatically generated from Ratfor code.  This code
 can be found in the directory inst/ratfor.  The Ratfor code
 was pretty ponderous to start with.   It is quite possibly very
 kludgy as well --- i.e. a good programmer could make it ***much***
 more efficient I'm sure.  It contains all sorts of checking for
 anomalous situations most of which probably can/will never occur.
 These checks basically reflect my pessimism and fervent belief in
 Murphy's Law.

 The program  was also designed with a particular application
 in mind, in which Mark Berman and I wished to superimpose a
 grid of dummy points onto the actual data points which we were
 triangulating.  This fact adds slightly to the complication of
 the code.

                       *****************************

 Here follows a brief description of the package:

 (1) The function deldir computes the Delaunay Triangulation (and
 hence the Dirichlet Tesselation) of a planar point set according to
 the second (iterative) algorithm of Lee and Schacter, International
 Journal of Computer and Information Sciences, Vol. 9, No. 3, 1980,
 pages 219 to 242.

 The tesselation/triangulation is made to be

             **** with respect to the whole plane ****

 by `suspending' it from `ideal' points (-Inf,-Inf), (Inf,-Inf)
 (Inf,Inf), and (-Inf,Inf).

 (2) The tesselation/triangulation is also enclosed in a finite
 rectangle with corners

          (xmin,ymax) * ------------------------ * (xmax,ymax)
                      |                          |
                      |                          |
                      |                          |
                      |                          |
                      |                          |
          (xmin,ymin) * ------------------------ * (xmax,ymin)

 The boundaries of this rectangle truncate some Dirichlet tiles, in
 particular any infinite ones. This rectangle is referred to
 elsewhere as `the' rectangular window.
               ===

 Version 0.0-9 (??? 2 June 2009)

 Added a new function tile.centroids() --- which does the obvious.
 Motivated by an inquiry from Leandro Moreira.

 Version 0.0-8 (4 April 2009)

 Removed the labels from the x and y vectors in the tile descriptions
 produced by tile.list.  These labels (which were the row numbers in
 the dirsgs data frame returned by deldir()) served no useful purpose
 and were potentially confusing.

                       *****************************

 Versions 0.0-2 through 0.0-7 were not tracked here. :-( Simply forgot
 about doing this.  I thouroughly *intend* [ :-) ] to get the archives
 from CRAN and try to document the changes.  Recent ones involved
 fixing bugs in and adding features to the tile.list() and
 plot.tile.list() functions.

                       *****************************

 Version 0.0-1 (21 February 2002)
 This version is simply an adaptation of the Splus version
 of the package to R.

                       *****************************

 Version date: 14 February 2002.
 This version supercedes the version dated 24 April 1999.

                       *****************************

 The changes from the version dated 24 April 1999 to the
 version dated 14 February 2002 were:

	A bug in the procedure for eliminating duplicated points was
	fixed.  Thanks go to Dr. Berwin Turlach of the Department of
	Maths and Stats at the University of Western Australia, for
	spotting this bug.

                       *****************************

 The changes from the version dated 26 October 1998 to the
 version dated 24 April 1999 were:

	(1) The function mipd(), stored in mipd.sf, and the
	corresponding Fortran subroutine mipd, stored in mipd.r, have
	been replaced by mnnd() in mnnd.sf and mnnd in mnnd.r.  The
	function mipd calculated the mean interpoint distance, to be
	used in constructing dummy point structures of a certain
	type.  After some reflection it became apparent that the mean
	interpoint distance was much too large for the intended
	purpose, and that a more appropriate value was the ``mean
	nearest neighbour distance'' which is calculated by the new
	function.  This new value is now used in constructing dummy
	point structures.

	Note that the operative result is that the resulting dummy
	point structures contain many more points than before.  The
	old value caused large numbers of the dummy points to fall
	outside the data window and therefore to be clipped.

                       *****************************

 The changes from the version dated 6 December 1996 to the
 version dated 26 October 1998 were:

	(1) A ratfor/Fortran routine named ``inside'' has been
	renamed ``dldins'' to avoid conflict with a name built in to
	some versions of Splus.

	(2) Some minor corrections have been made to dangerous
	infelicities in a piece of the ratfor/Fortran code.

	(3) The dynamic loading procedure has been changed to use
	dyn.load.shared so that the package is easily usable on
	IRIX systems as well as under SunOS/Solaris.

	(4) The package has been adjusted slightly so that it
	can easily be installed as a section of a library.  In
	particular, the dynamic loading is now done by the
	.First.lib() function rather than from within deldir()
	itself; reference to an environment variable DYN_LOAD_LIB
	is no longer needed.

                       *****************************

 This package computes and plots the Dirichlet (Voronoi) tesselation
 and the Delaunay triangulation of a set of of data points and
 possibly a superimposed ``grid'' of dummy points.

 The tesselation is constructed with respect to the whole plane
 by suspending it from ideal points at infinity.

 ORIGINALLY PROGRAMMED BY: Rolf Turner in 1987/88, while with the
 Division of Mathematics and Statistics, CSIRO, Sydney, Australia.
 Re-programmed by Rolf Turner to adapt the implementation from a
 stand-alone Fortran program to an S function, while visiting the
 University of Western Australia, May 1995.  Further revised
 December 1996, October 1998, April 1999, and February 2002.
 Adapted to an R package 21 February 2002.

 Current address of the author:
		Department of Mathematics and Statistics,
                University of New Brunswick,
                P.O. Box 4400, Fredericton, New Brunswick,
                Canada E3B 5A3
 Email:
		rolf@math.unb.ca

 The author gratefully acknowledges the contributions, assistance,
 and guidance of Mark Berman, of D.M.S., CSIRO, in collaboration with
 whom this project was originally undertaken.  The author also
 acknowledges much useful advice from Adrian Baddeley, formerly of
 D.M.S. CSIRO (now Professor of Statistics at the University of
 Western Australia).  Daryl Tingley of the Department of Mathematics
 and Statistics, University of New Brunswick provided some helpful
 insight.  Special thanks are extended to Alan Johnson, of the Alaska
 Fisheries Science Centre, who supplied two data sets which were
 extremely valuable in tracking down some errors in the code.

 Don MacQueen, of Lawrence Livermore National Lab, wrote an Splus
 driver function for the old stand-alone version of this software.
 That driver, which was available on Statlib, is now deprecated in
 favour of this current package.  Don also collaborated in the
 preparation of this current package.

 Bill Dunlap of MathSoft Inc. tracked down a bug which was making
 the deldir() function crash on some systems, and pointed out some
 other improvements to be made.

 Berwin Turlach of the Department of Maths and Stats at the
 University of Western Australia pointed out a bug in the procedure
 for eliminating duplicated points.

                       *****************************

 The man directory, contains, in addition to the R documentation
 files deldir.Rd and plot.deldir.Rd:

	(a) This READ_ME file.
	(b) A file err.list, containing a list of meanings of possible
	    error numbers which could be returned.  NONE of these
	    errors should ever actually happen except for errors 4, 14,
	    and 15.  These relate to insufficient dimensioning, and
	    if they occur, the driver increases the dimensions and
	    tries again (informing you of this fact).
	(c) A file ex.out containing a printout of the object returned
	    by running the example given in the help file for deldir.

 The src directory contains many, many *.f (Fortran) files, which
 get compiled and dynamically loaded.

 The Fortran code is ponderous --- it was automatically generated
 from Ratfor code, which was pretty ponderous to start with.   It is
 quite possibly very kludgy aw well --- i.e. a good programmer could
 make it ***much*** more efficient I'm sure.  It contains all sorts
 of checking for anomalous situations which probably can/will never
 occur.  These checks basically reflect my pessimism and fervent
 belief in Murphy's Law.

 The program  was also designed with a particular application in mind,
 in which we wished to superimpose a grid of dummy points onto the
 actual data points which we were triangulating.  This fact adds
 slightly to the complication of the code.

                       *****************************

 Here follows a brief description of the package:

 (1) The function deldir computes the Delaunay Triangulation (and
 hence the Dirichlet Tesselation) of a planar point set according to
 the second (iterative) algorithm of Lee and Schacter, International
 Journal of Computer and Information Sciences, Vol. 9, No. 3, 1980,
 pages 219 to 242.

 The tesselation/triangulation is made to be

             **** with respect to the whole plane ****

 by `suspending' it from `ideal' points (-Inf,-Inf), (Inf,-Inf)
 (Inf,Inf), and (-Inf,Inf).

 (2) The tesselation/triangulation is also enclosed in a finite
 rectangle with corners

          (xmin,ymax) * ------------------------ * (xmax,ymax)
                      |                          |
                      |                          |
                      |                          |
                      |                          |
                      |                          |
          (xmin,ymin) * ------------------------ * (xmax,ymin)

 The boundaries of this rectangle truncate some Dirichlet tiles, in
 particular any infinite ones. This rectangle is referred to
 elsewhere as `the' rectangular window.
               ===

 (2) The function plot.deldir is a method for plot.  I.e. it may be
 invoked simply by typing ``plot(x)'' provided that ``x'' is an
 object of class ``deldir'' (as produced by the function deldir).
 The plot (by default) consists of the edges of the Delaunay
 triangles (solid lines) and the edges of the Dirichlet tiles (dotted
 lines).  By default the real data points are indicated by circles,
 and the dummy points are indicated by triangles.

collinChk <- function(i,j,k,x,y,eps=NULL) {
xt <- x[c(i,j,k)]
yt <- y[c(i,j,k)]
xx <- .Fortran(
          "cross",
          xt=as.double(xt),
          yt=as.double(yt),
          ijk=as.integer(0),
          cprd=double(1),
          PACKAGE='deldir'
       )
cprd <- xx$cprd
if(is.null(eps)) eps <- sqrt(.Machine$double.eps)
rslt <- abs(cprd) < eps
attr(rslt,"crossproduct") <- cprd
rslt
}

C Output from Public domain Ratfor, version 1.03
      subroutine collincheck(nadj,madj,npts,x,y,ntot,eps)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot)
      dimension nadj(-3:ntot,0:madj)
      logical collin, changed
      nerror = -1
      changed = .false.
23000 continue
      do23003 j = 1,npts 
      nj = nadj(j,0)
      do23005 k = 1,nj 
      k1 = nadj(j,k)
      call succ(k2,j,k1,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      call intpr("Error number =",-1,nerror,1)
      call rexit("Error in succ, called from collincheck.")
      endif
      call crossutil(j,k1,k2,x,y,ntot,eps,collin)
      if(collin)then
      changed = .true.
      sd1 = (x(k1) - x(j))**2 + (y(k1) - y(j))**2
      sd2 = (x(k2) - x(j))**2 + (y(k2) - y(j))**2
      if(sd1 .lt. sd2)then
      kr = k2
      else
      kr = k1
      endif
      call delet(j,kr,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      call intpr("Error number =",-1,nerror,1)
      call rexit("Error in collincheck.")
      endif
      goto 23006
      endif
23005 continue
23006 continue
      if(changed)then
      goto 23004
      endif
23003 continue
23004 continue
23001 if(.not.(.not.changed))goto 23000
23002 continue
      return
      end

C Output from Public domain Ratfor, version 1.03
      subroutine xsucc(ksc,i,j,nadj,madj,ntot,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      dimension junk(20)
      nerror = -1
      n = nadj(i,0)
      if(n.eq.0)then
      nerror = 9
      return
      endif
      do23002 k = 1,n 
      junk(k) = nadj(i,k)
23002 continue
23003 continue
      call intpr("i =",-1,i,1)
      call intpr("adj. list of i:",-1,junk,n)
      do23004 k = 1,n 
      if(j.eq.nadj(i,k))then
      kp = k+1
      if(kp.gt.n)then
      kp = 1
      endif
      ksc = nadj(i,kp)
      call intpr("k =",-1,k,1)
      call intpr("kp =",-1,kp,1)
      call intpr("ksc =",-1,ksc,1)
      call intpr("junk(k) =",-1,junk(k),1)
      call intpr("junk(kp) =",-1,junk(kp),1)
      return
      endif
23004 continue
23005 continue
      nerror = 10
      return
      end

ind.dup <- function(x,y,rw=NULL,frac=0.0001) {
#
# Function ind.dup to calculate the indices of data pairs 
# which duplicate earlier ones.  (Returns a logical vector;
# true for such indices, false for the rest.)
#

if(is.null(rw)) rw <- c(0,1,0,1)
n <- length(x)
rslt <- .Fortran(
		'inddup',
		x=as.double(x),
		y=as.double(y),
		n=as.integer(n),
		rw=as.double(rw),
		frac=as.double(frac),
		dup=logical(n),
		PACKAGE='deldir'
	)

rslt$dup
}

subroutine collincheck(nadj,madj,npts,x,y,ntot,eps)

# Collinearity check --- experimental.  Runs through the adjacency
# list to see if any of the putative triangles in the triangulation
# that has so far been created are "degenerate", i.e. are actually
# just three points lying on a straight line.

implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot)
dimension nadj(-3:ntot,0:madj)
logical collin, changed

nerror  = -1
changed = .false.
repeat {
    do j = 1,npts {
       nj = nadj(j,0)
       do k = 1,nj {
           k1 = nadj(j,k)
           call succ(k2,j,k1,nadj,madj,ntot,nerror)
           if(nerror > 0) {
               call intpr("Error number =",-1,nerror,1)
               call rexit("Error in succ, called from collincheck.")
           }

# Check whether triangle j, k1, k2 is really a triangle.
           call crossutil(j,k1,k2,x,y,ntot,eps,collin)

# If collinear, remove the triangle from the mix.
           if(collin) {
               changed = .true.
# First determine which of k1 and k2 is closer to j.  It
# *should* be k1, but y'never know in these chaotic
# circumstances.
           sd1 = (x(k1) - x(j))**2 + (y(k1) - y(j))**2
           sd2 = (x(k2) - x(j))**2 + (y(k2) - y(j))**2
           if(sd1 < sd2) {
               kr = k2
           } else {
               kr = k1
           }
# Delete kr ("r" for "remove") from the adjacency list of j and j
# from the adjacency list of kr.
               call delet(j,kr,nadj,madj,ntot,nerror)
               if(nerror > 0) {
                   call intpr("Error number =",-1,nerror,1)
                   call rexit("Error in collincheck.")
               }
               break
           }
       }
       if(changed) break
    }
}
until(!changed)
return
end

subroutine inddup(x,y,n,rw,frac,dup)
implicit double precision(a-h,o-z)
logical dup(n)
dimension x(n), y(n), rw(4)

xtol = frac*(rw(2)-rw(1))
ytol = frac*(rw(4)-rw(3))

dup(1) = .false.
do i = 2,n {
	dup(i) = .false.
	do j = 1,i-1 {
		dx = abs(x(i)-x(j))
		dy = abs(y(i)-y(j))
		if(dx < xtol & dy < ytol) {
			dup(i) = .true.
			break
		}
	}
}

return
end

C Output from Public domain Ratfor, version 1.0
      subroutine delet(i,j,nadj,madj,ntot,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      logical adj
      call adjchk(i,j,adj,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(adj)then
      call delet1(i,j,nadj,madj,ntot)
      call delet1(j,i,nadj,madj,ntot)
      endif
      return
      end

# Fast version of trigraf assuming that 
#           ie(m) < je(m)
#           ie[is in ascending order
#           je is in ascending order within ie,
# that is, je(ie==i) is in ascending order for each fixed i.
# Code adapted from C code in trigraf.c, from the spatstat package
# by Adrian Baddeley.
#

subroutine trigraf(nv, ne, ie, je, nt, it, jt, kt)
#
# nv --- number of points being triangulated.
# ne --- number of triangle edges
# ie and je --- vectors of indices of ends of each edge
# nt --- number of triangles assumed to be at most ne
# it, jt, kt --- vectors of indices of vertices of triangles
#
integer firstedge, lastedge;
dimension ie(1), je(1), it(1), jt(1), kt(1)

# Initialise output.
nt = 1
lastedge = 0
while(lastedge < ne) {
# Consider next vertex i.
# The edges (i,j) with i < j appear contiguously in the edge list.
 firstedge = lastedge + 1
 i = ie(firstedge)
 do m = firstedge+1,ne {
  if ( ie(m) != i ) break
 }
  lastedge = m-1
# Consider each pair j, k of neighbours of i, where i < j < k. 
# Scan entire edge list to determine whether j, k are joined by an edge.
# If so, save triangle (i,j,k) 
  if(lastedge > firstedge) {
   do mj = firstedge,lastedge-1 {
    j = je(mj)
    do mk = firstedge+1,lastedge {
     k = je(mk)
# Run through edges to determine whether j, k are neighbours.
     do m = 1,ne {
      if(ie(m) >= j) break
     }
      while(m <= ne & ie(m) == j) {
       if(je(m) == k) {
# Add (i, j, k) to list of triangles.
        it(nt) = i;
        jt(nt) = j;
        kt(nt) = k;
        nt = nt+1
       }
      m = m+1
      }
     }
    }
   }
  }

return
end

subroutine insrt1(i,j,kj,nadj,madj,ntot,nerror)

# Insert j into the adjacency list of i.
# Called by insrt.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj)

nerror = -1

# Variable  kj is the index which j ***will***
# have when it is inserted into the adjacency list of i in
# the appropriate position.

# If the adjacency list of i had no points just stick j into the list.
n = nadj(i,0)
if(n==0) {
        nadj(i,0) = 1
        nadj(i,1) = j
        return
}

# If the adjacency list had some points, move everything ahead of the
# kj-th place one place forward, and put j in position kj.
kk = n+1

if(kk>madj) { # Watch out for over-writing!!!
	nerror = 4
	return
}
while(kk>kj) {
        nadj(i,kk) = nadj(i,kk-1)
        kk = kk-1
}
nadj(i,kj) = j
nadj(i,0)  = n+1

return
end

C Output from Public domain Ratfor, version 1.0
      subroutine mnnd(x,y,n,dminbig,dminav)
      implicit double precision(a-h,o-z)
      dimension x(n), y(n)
      dminav = 0.d0
      do23000 i = 1,n 
      dmin = dminbig
      do23002 j = 1,n 
      if(i.ne.j)then
      d = (x(i)-x(j))**2 + (y(i)-y(j))**2
      if(d .lt. dmin)then
      dmin = d
      endif
      endif
23002 continue
23003 continue
      dminav = dminav + sqrt(dmin)
23000 continue
23001 continue
      dminav = dminav/n
      return
      end

subroutine initad(j,nadj,madj,x,y,ntot,eps,nerror)

# Initial adding-in of a new point j.
# Called by addpt.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
integer tau(3)

# Find the triangle containing vertex j.
call trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,nerror)
if(nerror > 0) return

# If the new point is on the edge of a triangle, detach the two
# vertices of that edge from each other.  Also join j to the vertex
# of the triangle on the reverse side of that edge from the `found'
# triangle (defined by tau) -- given that there ***is*** such a triangle.
if(nedge!=0) {
        ip = nedge
        i  = ip-1
        if(i==0) i = 3 # Arithmetic modulo 3.
        call pred(k,tau(i),tau(ip),nadj,madj,ntot,nerror)
	if(nerror > 0) return
        call succ(kk,tau(ip),tau(i),nadj,madj,ntot,nerror)
	if(nerror > 0) return
        call delet(tau(i),tau(ip),nadj,madj,ntot,nerror)
	if(nerror > 0) return
        if(k==kk) call insrt(j,k,nadj,madj,x,y,ntot,nerror,eps)
	if(nerror > 0) return
}

# Join the new point to each of the three vertices.
do i = 1,3 {
	call insrt(j,tau(i),nadj,madj,x,y,ntot,nerror,eps)
	if(nerror > 0) return
}

return
end

subroutine delet(i,j,nadj,madj,ntot,nerror)
# Delete i and j from each other's adjacency lists.
# Called by initad, swap.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj)
logical adj

# First check that they're IN each other's lists.
call adjchk(i,j,adj,nadj,madj,ntot,nerror)
if(nerror > 0) return

# Then do the actual deletion if they are.
if(adj) {
        call delet1(i,j,nadj,madj,ntot)
        call delet1(j,i,nadj,madj,ntot)
}

return
end

C Output from Public domain Ratfor, version 1.0
      subroutine qtest(h,i,j,k,shdswp,x,y,ntot,eps,nerror)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot)
      integer h
      logical shdswp
      nerror = -1
      if(i.le.0)then
      ii = 1
      else
      ii = 0
      endif
      if(j.le.0)then
      jj = 1
      else
      jj = 0
      endif
      if(k.le.0)then
      kk = 1
      else
      kk = 0
      endif
      ijk = ii*4+jj*2+kk
      if(ijk.eq.7)then
      shdswp = .true.
      return
      endif
      if(ijk.eq.6)then
      xh = x(h)
      yh = y(h)
      xk = x(k)
      yk = y(k)
      ss = 1 - 2*mod(-j,2)
      test = (xh*yk+xk*yh-xh*yh-xk*yk)*ss
      if(test.gt.0.d0)then
      shdswp = .true.
      else
      shdswp = .false.
      endif
      if(shdswp)then
      call acchk(j,k,h,shdswp,x,y,ntot,eps)
      endif
      return
      endif
      if(ijk.eq.5)then
      shdswp = .true.
      return
      endif
      if(ijk.eq.4)then
      call acchk(j,k,h,shdswp,x,y,ntot,eps)
      return
      endif
      if(ijk.eq.3)then
      xi = x(i)
      yi = y(i)
      xh = x(h)
      yh = y(h)
      ss = 1 - 2*mod(-j,2)
      test = (xh*yi+xi*yh-xh*yh-xi*yi)*ss
      if(test.gt.0.d0)then
      shdswp = .true.
      else
      shdswp = .false.
      endif
      if(shdswp)then
      call acchk(h,i,j,shdswp,x,y,ntot,eps)
      endif
      return
      endif
      if(ijk.eq.2)then
      shdswp = .false.
      return
      endif
      if(ijk.eq.1)then
      call acchk(h,i,j,shdswp,x,y,ntot,eps)
      return
      endif
      if(ijk.eq.0)then
      call qtest1(h,i,j,k,x,y,ntot,eps,shdswp,nerror)
      return
      endif
      nerror = 7
      return
      end

C Output from Public domain Ratfor, version 1.0
      subroutine delout(delsum,nadj,madj,x,y,ntot,npd,ind,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      dimension delsum(npd,4), ind(npd)
      do23000 i1 = 1,npd 
      area = 0.
      i = ind(i1)
      np = nadj(i,0)
      xi = x(i)
      yi = y(i)
      npt = np
      do23002 k = 1,np 
      kp = k+1
      if(kp.gt.np)then
      kp = 1
      endif
      if(nadj(i,k).le.0.or.nadj(i,kp).le.0)then
      npt = npt-1
      endif
23002 continue
23003 continue
      do23008 j1 = 1,np 
      j = nadj(i,j1)
      if(j.le.0)then
      goto 23008
      endif
      xj = x(j)
      yj = y(j)
      call succ(k,i,j,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(k.le.0)then
      goto 23008
      endif
      xk = x(k)
      yk = y(k)
      call triar(xi,yi,xj,yj,xk,yk,tmp)
      area = area+tmp/3.
23008 continue
23009 continue
      delsum(i1,1) = xi
      delsum(i1,2) = yi
      delsum(i1,3) = npt
      delsum(i1,4) = area
23000 continue
23001 continue
      return
      end

C Output from Public domain Ratfor, version 1.0
      subroutine acchk(i,j,k,anticl,x,y,ntot,eps)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot), xt(3), yt(3)
      logical anticl
      if(i.le.0)then
      i1 = 1
      else
      i1 = 0
      endif
      if(j.le.0)then
      j1 = 1
      else
      j1 = 0
      endif
      if(k.le.0)then
      k1 = 1
      else
      k1 = 0
      endif
      ijk = i1*4+j1*2+k1
      xt(1) = x(i)
      yt(1) = y(i)
      xt(2) = x(j)
      yt(2) = y(j)
      xt(3) = x(k)
      yt(3) = y(k)
      call cross(xt,yt,ijk,cprd)
      if(cprd .gt. eps)then
      anticl = .true.
      else
      anticl = .false.
      endif
      return
      end

subroutine triar(x0,y0,x1,y1,x2,y2,area)

! Calculate the area of a triangle with given vertices.  Called
! by delout (so that the vertices are presented in the anticlockwise
! direction).

implicit double precision(a-h,o-z)
half = 0.5d0

area = half*((x1-x0)*(y2-y0)-(x2-x0)*(y1-y0))
end subroutine triar

subroutine intri(x,y,u,v,n,okay)
#
# Test whether any of the points (u(i),v(i)) are inside the triangle
# whose vertices are specified by the vectors x and y.
# Called by .Fortran() from triang.list.R.
#

implicit double precision(a-h,o-z)
dimension x(3), y(3), u(n), v(n)
logical okay, inside

zero = 0.d0

# Check on order (clockwise or anticlockwise).
s = 1.d0
a = x(2) - x(1)
b = y(2) - y(1)
c = x(3) - x(1)
d = y(3) - y(1)
cp = a*d - b*c
if(cp < 0) s = -s
do i = 1,n {
	inside = .true.
	do j = 1,3 {
        	jp = j+1
        	if(jp==4) jp = 1 # Take addition modulo 3.
		a  = x(jp) - x(j)
		b  = y(jp) - y(j)
		c  = u(i)  - x(j)
		d  = v(i)  - y(j)
		cp = s*(a*d - b*c)
		if(cp <= zero) {
			inside = .false.
			break
		}
	}
	if(inside) {
		okay = .false.
		return
	}
	
}
okay = .true.
return
end

subroutine master(x,y,rw,nn,ntot,nadj,madj,eps,delsgs,ndel,delsum,&
                  dirsgs,ndir,dirsum,incAdj,incSeg)

! Master subroutine:
! One subroutine to rule them all,
! One subroutine to find them.
! One subroutine to bring them all in,
! And in the darkness bind them.

! Note: "incAdj" <--> increase size of adjacency list.
!       "incSeg" <--> increase size of storage for segments.

implicit double precision(a-h,o-z)
dimension :: x(-3:ntot), y(-3:ntot)
dimension :: nadj(-3:ntot,0:madj)
dimension :: rw(4)
dimension :: delsgs(6,ndel), dirsgs(10,ndir)
dimension :: delsum(nn,4), dirsum(nn,3)

! Define one.
one = 1.d0

! Initialize the adjacency list; counts to 0, other entries to -99.
do i = -3,ntot
    nadj(i,0) = 0
    do j = 1,madj
        nadj(i,j) = -99
    enddo
enddo

! Put the four ideal points into x and y and the adjacency list.
! The ideal points are given pseudo-coordinates
! (-1,-1), (1,-1), (1,1), and (-1,1).  They are numbered as
!    0       -1      -2         -3
! i.e. the numbers decrease anticlockwise from the
! `bottom left corner'.
x(-3) = -one
y(-3) =  one
x(-2) =  one
y(-2) =  one
x(-1) =  one
y(-1) = -one
x(0)  = -one
y(0)  = -one

do i = 1,4
    j = i-4
    k = j+1
    if(k>0) k = -3
    call insrt(j,k,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
enddo

! Put in the first of the point set into the adjacency list.
do i = 1,4
    j = i-4
    call insrt(1,j,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
enddo
ntri = 4

! Now add the rest of the point set
do j = 2,nn
    call addpt(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)
    if(incAdj==1) return
    ntri = ntri + 3
enddo

! Obtain the description of the triangulation.
call delseg(delsgs,ndel,nadj,madj,nn,x,y,ntot,incSeg)
if(incSeg==1) return

call delout(delsum,nadj,madj,x,y,ntot,nn)

call dirseg(dirsgs,ndir,nadj,madj,nn,x,y,ntot,rw,eps,ntri,incAdj,incSeg)
if(incAdj==1 .or. incSeg==1) return
call dirout(dirsum,nadj,madj,x,y,ntot,nn,rw,eps)
end subroutine master

insideRect <- function(x,y,rect,rw) {
# Check that rect is a rectangle.
if(!(is.numeric(rect) &  length(rect) == 4)) {
    whinge <- paste0("Argument \"rect\", if not NULL, must",
                     " be a numeric vector of length 4.\n")
    stop(whinge)
}

# Check that rect is a subset of rw and satifies rect[1] <= rect[2]
# and rect[3] <= rect[4].
ok1  <- rw[1] <= rect[1] & rect[1] <= rect[2] & rect[2] <= rw[2]
ok2  <- rw[3] <= rect[3] & rect[3] <= rect[4] & rect[4] <= rw[4]
if(!(ok1 & ok2)) {
    whinge <- paste0("Argument \"rect\" must determine a subset of",
                     " the rectangular\n  window with respect to which",
                     "  the points were triangulated/tessellated.\n")
    stop(whinge)
}

# All is as it should be; determine which points are inside "rect".
okx  <- rect[1] <= x & x <= rect[2]
oky  <- rect[3] <= y & y <= rect[4]
okx & oky
}

subroutine master(x,y,rw,npd,ntot,nadj,madj,eps,delsgs,ndel,delsum,
                  dirsgs,ndir,dirsum,incAdj,incSeg)

# Master subroutine:
# One subroutine to rule them all,
# One subroutine to find them.
# One subroutine to bring them all in,
# And in the darkness bind them.

# Note: "incAdj" <--> increase size of adjacency list.
#       "incSeg" <--> increase size of storage for segments.

implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot)
dimension nadj(-3:ntot,0:madj)
dimension rw(4)
dimension delsgs(6,ndel), dirsgs(10,ndir)
dimension delsum(npd,4), dirsum(npd,3)

# Define one.
one = 1.d0

# Initialize the adjacency list; counts to 0, other entries to -99.
do i = -3,ntot {
    nadj(i,0) = 0
    do j = 1,madj {
        nadj(i,j) = -99
    }
}

# Put the four ideal points into x and y and the adjacency list.
# The ideal points are given pseudo-coordinates
# (-1,-1), (1,-1), (1,1), and (-1,1).  They are numbered as
#    0       -1      -2         -3
# i.e. the numbers decrease anticlockwise from the
# `bottom left corner'.
x(-3) = -one
y(-3) =  one
x(-2) =  one
y(-2) =  one
x(-1) =  one
y(-1) = -one
x(0)  = -one
y(0)  = -one

do i = 1,4 {
    j = i-4
    k = j+1
    if(k>0) k = -3
    call insrt(j,k,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
}

# Put in the first of the point set into the adjacency list.
do i = 1,4 {
    j = i-4
    call insrt(1,j,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
}
ntri = 4

# Now add the rest of the point set
do j = 2,npd {
    call addpt(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)
    if(incAdj==1) return
    ntri = ntri + 3
}

# Obtain the description of the triangulation.
call delseg(delsgs,ndel,nadj,madj,npd,x,y,ntot,incSeg)
if(incSeg==1) return

call delout(delsum,nadj,madj,x,y,ntot,npd)

call dirseg(dirsgs,ndir,nadj,madj,npd,x,y,ntot,rw,eps,ntri,incAdj,incSeg)
if(incAdj==1 | incSeg==1) return
call dirout(dirsum,nadj,madj,x,y,ntot,npd,rw,eps)
return
end

C Output from Public domain Ratfor, version 1.0
      subroutine locn(i,j,kj,nadj,madj,x,y,ntot,eps)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      logical before
      n = nadj(i,0)
      if(n.eq.0)then
      kj = 1
      return
      endif
      do23002 ks = 1,n 
      kj = ks
      k = nadj(i,kj)
      call acchk(i,j,k,before,x,y,ntot,eps)
      if(before)then
      km = kj-1
      if(km.eq.0)then
      km = n
      endif
      k = nadj(i,km)
      call acchk(i,j,k,before,x,y,ntot,eps)
      if(before)then
      goto 23002
      endif
      if(kj.eq.1)then
      kj = n+1
      endif
      return
      endif
23002 continue
23003 continue
      if(before)then
      kj = 1
      else
      kj = n+1
      endif
      return
      end

subroutine dirout(dirsum,nadj,madj,x,y,ntot,nn,rw,eps)

! Output the description of the Dirichlet tile centred at point
! i for i = 1, ..., nn.  Do this in the original order of the
! points, not in the order into which they have been bin-sorted.
! Called by master.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension :: dirsum(nn,3), rw(4)
dimension :: ndi(1)
logical :: collin, intfnd, bptab, bptcd, rwu

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! Note that at this point some Delaunay neighbours may be
! `spurious'; they are the corners of a `large' rectangle in which
! the rectangular window of interest has been suspended.  This
! large window was brought in simply to facilitate output concerning
! the Dirichlet tesselation.  They were added to the triangulation
! in the routine `dirseg' which ***must*** therefore be called before
! this routine (`dirout') is called.  (Likewise `dirseg' must be called
! ***after*** `delseg' and `delout' have been called.)

! Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

do i = 1,nn
    area = 0.d0 ! Initialize the area of the ith tile to zero.
    nbpt = 0    ! Initialize the number of boundary points of
                ! the ith tile to zero.
    npt  = 0    ! Initialize the number of tile boundaries to zero.
    np   = nadj(i,0)

! Output the point number, its coordinates, and the number of
! its Delaunay neighbours == the number of boundary segments in
! its Dirichlet tile.
! For each Delaunay neighbour, find the circumcentres of the
! triangles on each side of the segment joining point i to that
! neighbour.
    !call dblepr("rw:",-1,rw,4)
    do j1 = 1,np
        j = nadj(i,j1)
        call pred(k,i,j,nadj,madj,ntot)
        call succ(l,i,j,nadj,madj,ntot)
        call circen(i,k,j,a,b,x,y,ntot,eps,collin)
        if(collin) then
            call intpr("Vertices of triangle are collinear.",-1,ndi,0)
            call rexit("Bailing out of dirout.")
        endif
        call circen(i,j,l,c,d,x,y,ntot,eps,collin)
        if(collin) then
            call intpr("Vertices of triangle are collinear.",-1,ndi,0)
            call rexit("Bailing out of dirout.")
        endif

! Increment the area of the current Dirichlet
! tile (intersected with the rectangular window) by applying
! Stokes' Theorem to the segment of tile boundary joining
! (a,b) to (c,d).  (Note that the direction is anti-clockwise.)
        call stoke(a,b,c,d,rw,tmp,sn,eps)
        area = area+sn*tmp

! If a circumcentre is outside the rectangular window, replace
! it with the intersection of the rectangle boundary with the
! line joining the two circumcentres.  Then output
! the number of the current Delaunay neighbour and
! the two circumcentres (or the points with which
! they have been replaced).
! Note: rwu = "right way up".
        xi = x(i)
        xj = x(j)
        yi = y(i)
        yj = y(j)
        if(yi .ne. yj) then
            slope = (xi - xj)/(yj - yi)
            rwu = .true.
        else
            slope = 0.d0
            rwu = .false.
        endif
        call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab,nedge)
        if(intfnd) then
            call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd,nedge)
            if(.not.intfnd) then
                call intpr("Line from midpoint to circumcenter",-1,ndi,0)
                call intpr("does not intersect rectangle boundary!",-1,ndi,0)
                call intpr("But it HAS to!!!",-1,ndi,0)
                call rexit("Bailing out of dirout.")
            endif
            if(bptab .and. bptcd) then
                xm = 0.5*(ai+ci)
                ym = 0.5*(bi+di)
                if(xmin<xm .and. xm<xmax .and. ymin<ym .and. ym<ymax) then
                    nbpt = nbpt+2
                    npt  = npt+1
                endif
            else
                npt = npt + 1
                if(bptab .or. bptcd) nbpt = nbpt+1
            endif
        endif
    enddo
    dirsum(i,1) = npt
    dirsum(i,2) = nbpt
    dirsum(i,3) = area
enddo

end subroutine dirout

C Output from Public domain Ratfor, version 1.0
      subroutine delet1(i,j,nadj,madj,ntot)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      n = nadj(i,0)
      do23000 k = 1,n 
      if(nadj(i,k).eq.j)then
      do23004 kk = k,n-1 
      nadj(i,kk) = nadj(i,kk+1) 
23004 continue
23005 continue
      nadj(i,n) = -99
      nadj(i,0) = n-1
      return
      endif
23000 continue
23001 continue
      end

subroutine dirout(dirsum,nadj,madj,x,y,ntot,npd,rw,eps)

# Output the description of the Dirichlet tile centred at point
# i for i = 1, ..., npd.  Do this in the original order of the
# points, not in the order into which they have been bin-sorted.
# Called by master.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension dirsum(npd,3), rw(4)
dimension ndi(1)
logical collin, intfnd, bptab, bptcd, rwu

# Set dummy integer for call to intpr(...).
ndi(1) = 0

# Note that at this point some Delaunay neighbours may be
# `spurious'; they are the corners of a `large' rectangle in which
# the rectangular window of interest has been suspended.  This
# large window was brought in simply to facilitate output concerning
# the Dirichlet tesselation.  They were added to the triangulation
# in the routine `dirseg' which ***must*** therefore be called before
# this routine (`dirout') is called.  (Likewise `dirseg' must be called
# ***after*** `delseg' and `delout' have been called.)

# Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

do i = 1,npd {
    area = 0. # Initialize the area of the ith tile to zero.
    nbpt = 0  # Initialize the number of boundary points of
              # the ith tile to zero.
    npt  = 0  # Initialize the number of tile boundaries to zero.
    np   = nadj(i,0)

# Output the point number, its coordinates, and the number of
# its Delaunay neighbours == the number of boundary segments in
# its Dirichlet tile.
# For each Delaunay neighbour, find the circumcentres of the
# triangles on each side of the segment joining point i to that
# neighbour.
    do j1 = 1,np {
        j = nadj(i,j1)
        call pred(k,i,j,nadj,madj,ntot)
        call succ(l,i,j,nadj,madj,ntot)
        call circen(i,k,j,a,b,x,y,ntot,eps,collin)
        if(collin) {
            call intpr("Vertices of triangle are collinear.",-1,ndi,0)
            call rexit("Bailing out of dirout.")
        }
        call circen(i,j,l,c,d,x,y,ntot,eps,collin)
        if(collin) {
            call intpr("Vertices of triangle are collinear.",-1,ndi,0)
            call rexit("Bailing out of dirout.")
        }

# Increment the area of the current Dirichlet
# tile (intersected with the rectangular window) by applying
# Stokes' Theorem to the segment of tile boundary joining
# (a,b) to (c,d).  (Note that the direction is anti-clockwise.)
        call stoke(a,b,c,d,rw,tmp,sn,eps)
        area = area+sn*tmp

# If a circumcentre is outside the rectangular window, replace
# it with the intersection of the rectangle boundary with the
# line joining the two circumcentres.  Then output
# the number of the current Delaunay neighbour and
# the two circumcentres (or the points with which
# they have been replaced).
# Note: rwu = "right way up".
        xi = x(i)
        xj = x(j)
        yi = y(i)
        yj = y(j)
        if(yi!=yj) {
            slope = (xi - xj)/(yj - yi)
            rwu = .true.
        } else {
            slope = 0.d0
            rwu = .false.
        }
        call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab,nedge)
        if(intfnd) {
            call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd,nedge)
            if(!intfnd) {
                call intpr("Line from midpoint to circumcenter",-1,ndi,0)
                call intpr("does not intersect rectangle boundary!",-1,ndi,0)
                call intpr("But it HAS to!!!",-1,ndi,0)
                call rexit("Bailing out of dirout.")
            }
            if(bptab & bptcd) {
                xm = 0.5*(ai+ci)
                ym = 0.5*(bi+di)
                if(xmin<xm&xm<xmax&ymin<ym&ym<ymax) {
                    nbpt = nbpt+2
                    npt  = npt+1
                }
            }
            else {
                npt = npt + 1
                if(bptab | bptcd) nbpt = nbpt+1
            }
        }
    }
    dirsum(i,1) = npt
    dirsum(i,2) = nbpt
    dirsum(i,3) = area
}

return
end

acw <- function(xxx) {
xbar    <- sum(xxx$x)/length(xxx$x)
ybar    <- sum(xxx$y)/length(xxx$y)
theta   <- atan2(xxx$y - ybar,xxx$x-xbar)
theta   <- ifelse(theta > 0, theta, theta + 2 * pi)
theta.0 <- sort(unique(theta))
iii     <- match(theta.0, theta)
xxx$x   <- xxx$x[iii]
xxx$y   <- xxx$y[iii]
xxx$bp  <- xxx$bp[iii]
xxx
}

subroutine delseg(delsgs,ndel,nadj,madj,nn,x,y,ntot,incSeg)

! Output the endpoints of the line segments joining the
! vertices of the Delaunay triangles.
! Called by master.

implicit double precision(a-h,o-z)
logical :: value
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension :: delsgs(6,ndel)

! Initialise incSeg
incSeg = 0

! For each distinct pair of points i and j, if they are adjacent
! then put their endpoints into the output array.
nn = ntot-4
kseg = 0
do i = 2,nn
    do j = 1,i-1
        call adjchk(i,j,value,nadj,madj,ntot)
        if(value) then
            kseg = kseg+1
            if(kseg > ndel) then
                incSeg = 1
                return
            endif
            delsgs(1,kseg) = x(i)
            delsgs(2,kseg) = y(i)
            delsgs(3,kseg) = x(j)
            delsgs(4,kseg) = y(j)
            delsgs(5,kseg) = i
            delsgs(6,kseg) = j
        endif
    enddo
enddo
ndel = kseg

end subroutine delseg

C Output from Public domain Ratfor, version 1.0
      subroutine swap(j,k1,k2,shdswp,nadj,madj,x,y,ntot,eps,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      logical shdswp
      call adjchk(k1,k2,shdswp,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(.not.shdswp)then
      return
      endif
      call pred(k,k1,k2,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call succ(kk,k2,k1,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(kk.ne.k)then
      shdswp = .false.
      return
      endif
      call qtest(j,k1,k,k2,shdswp,x,y,ntot,eps,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(shdswp)then
      call delet(k1,k2,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call insrt(j,k,nadj,madj,x,y,ntot,nerror,eps)
      if(nerror .gt. 0)then
      return
      endif
      endif
      return
      end

subroutine trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,ntri)

! Find the triangle of the extant triangulation in which
! lies the point currently being added.
! Called by initad.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot), xt(3), yt(3)
dimension :: ndi(1)
integer :: tau(3)
logical :: adjace, anticl

! The first point must be added to the triangulation before
! calling trifnd.
if(j==1) then
    call intpr("No triangles to find.",-1,ndi,0)
    call rexit("Bailing out of trifnd.")
endif

! Get the previous triangle:
j1     = j-1
tau(1) = j1
tau(3) = nadj(j1,1)
call pred(tau(2),j1,tau(3),nadj,madj,ntot)
call adjchk(tau(2),tau(3),adjace,nadj,madj,ntot)
if(.not.adjace) then
    tau(3) = tau(2)
    call pred(tau(2),j1,tau(3),nadj,madj,ntot)
endif

! Move to the adjacent triangle in the direction of the new
! point, until the new point lies in this triangle.
ktri = 0

do
! Check that the vertices of the triangle listed in tau are
! in anticlockwise order.  (If they aren't then reverse the order;
! if they are *still*  not in anticlockwise order, theh alles
! upgefucken ist; throw an error.)
call acchk(tau(1),tau(2),tau(3),anticl,x,y,ntot,eps)
if(.not.anticl) then
    call acchk(tau(3),tau(2),tau(1),anticl,x,y,ntot,eps)
    if(.not.anticl) then
        ndi(1) = j
        call intpr("Point number =",-1,ndi,1)
        call intpr("Previous triangle:",-1,tau,3)
        call intpr("Both vertex orderings are clockwise.",-1,ndi,0)
        call intpr("See help for deldir.",-1,ndi,0)
        call rexit("Bailing out of trifnd.")
    else
        ivtmp  = tau(3)
        tau(3) = tau(1)
        tau(1) = ivtmp
    endif
endif

ntau  = 0 ! This number will identify the triangle to be moved to.
nedge = 0 ! If the point lies on an edge, this number will identify that edge.
do i = 1,3
    ip = i+1
    if(ip==4) ip = 1 ! Take addition modulo 3.

! Get the coordinates of the vertices of the current side,
! and of the point j which is being added:
    xt(1) = x(tau(i))
    yt(1) = y(tau(i))
    xt(2) = x(tau(ip))
    yt(2) = y(tau(ip))
    xt(3) = x(j)
    yt(3) = y(j)

! Create indicator telling which of tau(i), tau(ip), and j
! are ideal points.  (The point being added, j, is ***never*** ideal.)
    if(tau(i)<=0) then
        i1 = 1
    else
        i1 = 0
    endif
    if(tau(ip)<=0) then
        j1 = 1
    else
        j1 = 0
    endif
    k1 = 0
    ijk = i1*4+j1*2+k1

! Calculate the ``normalized'' cross product; if this is positive
! then the point being added is to the left (as we move along the
! edge in an anti-clockwise direction).  If the test value is positive
! for all three edges, then the point is inside the triangle.  Note
! that if the test value is very close to zero, we might get negative
! values for it on both sides of an edge, and hence go into an
! infinite loop.
    call cross(xt,yt,ijk,cprd)
    if(cprd >=  eps) then
        continue
    else
        if(cprd > -eps) then
            nedge = ip
        else
            ntau = ip
            exit
        endif
    endif
enddo

! We've played ring-around-the-triangle; now figure out the
! next move:

! case 0: All tests >= 0.; the point is inside; return.
if(ntau==0) return

! The point is not inside; work out the vertices of the triangle to which
! to move.  Notation: Number the vertices of the current triangle from 1 to 3,
! anti-clockwise. Then "triangle i+1" is adjacent to the side from vertex i to
! vertex i+1, where i+1 is taken modulo 3 (i.e. "3+1 = 1").

! case 1: Move to "triangle 1"
if(ntau==1) then
    tau(2)  = tau(3)
    call succ(tau(3),tau(1),tau(2),nadj,madj,ntot)
endif

! case 2: Move to "triangle 2"
if(ntau==2) then
    tau(3)  = tau(2)
    call pred(tau(2),tau(1),tau(3),nadj,madj,ntot)
endif

! case 3: Move to "triangle 3"
if(ntau==3) then
    tau(1)  = tau(3)
    call succ(tau(3),tau(1),tau(2),nadj,madj,ntot)
endif

! We've moved to a new triangle; check if the point being added lies
! inside this one.
ktri = ktri + 1
if(ktri > ntri) then
    ndi(1) = j
    call intpr("Point being added:",-1,ndi,1)
    call intpr("Cannot find an enclosing triangle.",-1,ndi,0)
    call intpr("See help for deldir.",-1,ndi,0)
    call rexit("Bailing out of trifnd.")
endif
enddo

end subroutine trifnd

subroutine locn(i,j,kj,nadj,madj,x,y,ntot,eps)

# Find the appropriate location for j in the adjacency list
# of i.  This is the index which j ***will*** have when
# it is inserted into the adjacency list of i in the
# appropriate place.  Called by insrt.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical before

n = nadj(i,0)

# If there is nothing already adjacent to i, then j will have place 1.
if(n==0) {
        kj = 1
        return
}

# Run through i's list, checking if j should come before each element
# of that list.  (I.e. if i, j, and k are in anti-clockwise order.)
# If j comes before the kj-th item, but not before the (kj-1)-st, then
# j should have place kj.
do ks = 1,n {
	kj = ks
        k = nadj(i,kj)
        call acchk(i,j,k,before,x,y,ntot,eps)
        if(before) {
                km = kj-1
                if(km==0) km = n
                k = nadj(i,km)
                call acchk(i,j,k,before,x,y,ntot,eps)
                if(before) next
                # If j is before 1 and after n, then it should
                # have place n+1.
                if(kj==1) kj = n+1
                return
        }
}

# We've gone right through the list and haven't been before
# the kj-th item ***and*** after the (kj-1)-st on any occasion.
# Therefore j is before everything (==> place 1) or after
# everything (==> place n+1).
if(before) kj = 1
else kj = n+1

return
end

plot.divchain <- function (x, add = FALSE, ...) 
{
    dotargs <- list(...)
    bty <- dotargs$bty
    bxc <- dotargs$boxcol
    dotargs$boxcol <- NULL
    if (!add) {
        rw <- attr(x, "rw")
        plot(0, 0, type = "n", ann = FALSE, axes = FALSE, xlim = rw[1:2], 
            ylim = rw[3:4])
        if(is.null(bty)) bty <- "n"
        box(bty = bty, col=bxc)
        do.call(title,dotargs)
    }
    lapply(1:nrow(x), function(i, x) {
        do.call(segments, c(as.list(unname(x[i, 1:4])), dotargs))
    }, x = x)
    invisible()
}

tile.list <- local({
edgeLengths <- function(x,y) {
    n <- length(x)
    el <- numeric(n) 
    for(i in 1:n) {
        ii <- if(i < n) i+1 else 1
        el[i] <- sqrt((x[i] - x[ii])^2 + (y[i] - y[ii])^2)
    } 
    el 
}

function (object,minEdgeLength=NULL,clipp=NULL) {
  if (!inherits(object, "deldir"))
    stop("Argument \"object\" is not of class \"deldir\".\n")
  rw <- object$rw
  if(is.null(minEdgeLength)) {
    drw <- sqrt((rw[2] - rw[1])^2 + (rw[4] - rw[3])^2)
    minEdgeLength <- drw*sqrt(.Machine$double.eps)
  }
  x.crnrs <- rw[c(1, 2, 2, 1)]
  y.crnrs <- rw[c(3, 3, 4, 4)]
  ddd <- object$dirsgs
  sss <- object$summary
  npts <- nrow(sss)
  x <- sss[["x"]]
  y <- sss[["y"]]
  z <- sss[["z"]]
  id <- sss[["id"]]
  noid <- is.null(id)
  if(noid) id <- 1:nrow(sss)
  noz <- is.null(z)
  i.crnr <- get.cnrind(x, y, rw)
  ind.orig <- object$ind.orig
  rslt <- vector("list",npts)
  for (i in 1:npts) {
    filter1 <- ddd$ind1 == id[i]
    filter2 <- ddd$ind2 == id[i]
    subset  <- ddd[which(filter1 | filter2),,drop=FALSE]
    m <- matrix(unlist(subset[, 1:4]), ncol = 4)
    bp1 <- subset[, 7]
    bp2 <- subset[, 8]
    m1 <- cbind(m[, 1:2, drop = FALSE], 0 + bp1)
    m2 <- cbind(m[, 3:4, drop = FALSE], 0 + bp2)
    m <- rbind(m1, m2)
    pt <- c(x = sss$x[i], y = sss$y[i])
    theta <- atan2(m[, 2] - pt[2], m[, 1] - pt[1])
    theta.0 <- sort(unique(theta))
    mm <- m[match(theta.0, theta),,drop=FALSE]
    xx <- mm[, 1]
    yy <- mm[, 2]
    bp <- as.logical(mm[, 3])
    ii <- i.crnr %in% i
    xx <- c(xx, x.crnrs[ii])
    yy <- c(yy, y.crnrs[ii])
    bp <- c(bp, rep(TRUE, sum(ii)))
    tmp <- list(ptNum = ind.orig[i],
                pt    = pt,
                x     = unname(xx),
                y     = unname(yy),
                bp    = bp,
                area  = sss$dir.area[i])
    tmp    <- acw(tmp)
    bird   <- edgeLengths(tmp$x,tmp$y)
    ok     <- bird >= minEdgeLength
    tmp$x  <- tmp$x[ok]
    tmp$y  <- tmp$y[ok]
    tmp$bp <- tmp$bp[ok]
    rslt[[i]] <-acw(tmp)
    if(!noz) {
        rslt[[i]]["z"] <- z[i]
    }
    if(is.null(clipp)) {
        attr(rslt[[i]],"ncomp") <- 1
    }
}
if(!is.null(clipp)) {
    if(requireNamespace("polyclip",quietly=TRUE)) {
        rslt <- lapply(rslt,doClip,clipp=clipp,rw=rw)
    } else {
        stop("Cannot clip the tiles; package \"polyclip\" not available.\n")
    }
}
    ok <- !sapply(rslt,is.null)
    rslt <- rslt[ok]
    if(noid) {
        id <- paste0("pt.",id)
    }
    names(rslt) <- id[ok]
    class(rslt) <- "tile.list"
    attr(rslt, "rw") <- object$rw
    attr(rslt,"clipp") <- clipp
    return(rslt)
}

})

"[.tile.list" <- function(x,i,...){
    y <- unclass(x)[i]
    class(y) <- "tile.list"
    attr(y,"rw") <- attr(x,"rw")
    y
}

C Output from Public domain Ratfor, version 1.0
      subroutine intri(x,y,u,v,n,okay)
      implicit double precision(a-h,o-z)
      dimension x(3), y(3), u(n), v(n)
      logical okay, inside
      zero = 0.d0
      s = 1.d0
      a = x(2) - x(1)
      b = y(2) - y(1)
      c = x(3) - x(1)
      d = y(3) - y(1)
      cp = a*d - b*c
      if(cp .lt. 0)then
      s = -s
      endif
      do23002 i = 1,n 
      inside = .true.
      do23004 j = 1,3 
      jp = j+1
      if(jp.eq.4)then
      jp = 1
      endif
      a = x(jp) - x(j)
      b = y(jp) - y(j)
      c = u(i) - x(j)
      d = v(i) - y(j)
      cp = s*(a*d - b*c)
      if(cp .le. zero)then
      inside = .false.
      goto 23005
      endif
23004 continue
23005 continue
      if(inside)then
      okay = .false.
      return
      endif
23002 continue
23003 continue
      okay = .true.
      return
      end

subroutine dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bpt,nedge)

! Get a point ***inside*** the rectangular window on the ray from
! one circumcentre to the next one.  I.e. if the `next one' is
! inside, then that's it; else find the intersection of this ray with
! the boundary of the rectangle.
! Called by dirseg, dirout.

implicit double precision(a-h,o-z)
dimension :: rw(4)
logical :: intfnd, bpt, rwu

! Note that (a,b) is the circumcentre of a Delaunay triangle,
! and that slope is the slope of the ray joining (a,b) to the
! corresponding circumcentre on the opposite side of an edge of that
! triangle.  When `dldins' is called by `dirout' it is possible
! for the ray not to intersect the window at all.  (The Delaunay
! edge between the two circumcentres might be connected to a `fake
! outer corner', added to facilitate constructing a tiling that
! completely covers the actual window.)  The variable `intfnd' acts
! as an indicator as to whether such an intersection has been found.

! The variable `bpt' acts as an indicator as to whether the returned
! point (ai,bi) is a true circumcentre, inside the window (bpt == .false.),
! or is the intersection of a ray with the boundary of the window
! (bpt = .true.).


intfnd = .true.
bpt = .true.

! Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

! Check if (a,b) is inside the rectangle.
if(xmin<=a .and. a<=xmax .and. ymin<=b .and. b<=ymax) then
    ai = a
    bi = b
    bpt = .false.
    nedge = 0
    return
endif

! Look for appropriate intersections with the four lines forming
! the sides of the rectangular window.

! If not "the right way up" then the line joining the two
! circumcentres is vertical.

if(.not.rwu) then
    if(b < ymin) then
        ai = a
        bi = ymin
        nedge = 1
        if(xmin<=ai .and. ai<=xmax) return
    endif
    if(b > ymax) then
        ai = a
        bi = ymax
        nedge = 3
        if(xmin<=ai .and. ai<=xmax) return
    endif
    intfnd = .false.
    return
endif

! Line 1: x = xmin.
if(a<xmin) then
    ai = xmin
    bi = b + slope*(ai-a)
    nedge = 2
    if(ymin<=bi .and. bi<=ymax) return
endif

! Line 2: y = ymin.
if(b<ymin) then
    bi = ymin
    ai = a + (bi-b)/slope
    nedge = 1
    if(xmin<=ai .and. ai<=xmax) return
endif

! Line 3: x = xmax.
if(a>xmax) then
    ai = xmax
    bi = b + slope*(ai-a)
    nedge = 4
    if(ymin<=bi .and. bi<=ymax) return
endif

! Line 4: y = ymax.
if(b>ymax) then
    bi = ymax
    ai = a + (bi-b)/slope
    nedge = 3
    if(xmin<=ai .and. ai<=xmax) return
endif

intfnd = .false.
end subroutine dldins

getNbrs <- function(object,interior=NULL) {
    ddd  <- object$dirsgs
    id   <- object$summary[["id"]]
    noid <- is.null(id)
    if(noid) id <- 1:nrow(object$summary)
    if(is.null(interior)) {
        npts <- nrow(object$summary)
    } else {
        x <- object$summary[["x"]]
        y <- object$summary[["y"]]
        if(inherits(interior,"list")) { # "interior" is/should be a polygon
            ok <- insidePoly(x,y,interior)
        } else {
            rw   <- object[["rw"]]
            ok <- insideRect(x,y,interior,rw)
        }
        id   <- id[ok]
        npts <- length(id)
    }
    nbrs <- vector("list",npts)
    for(i in seq(along=id)) {
        filter1   <- ddd$ind1 == id[i]
        filter2   <- ddd$ind2 == id[i]
        subset    <- ddd[which(filter1 | filter2),,drop=FALSE]
        nbrs[[i]] <- unname(apply(subset[,c("ind1","ind2")],1,
                                  function(x){x[x!=id[i]]}))
    }
    if(noid) {
        names(nbrs) <- paste0("pt.",id)
    } else {
        names(nbrs) <- id
    }
    nbrs
}

C Output from Public domain Ratfor, version 1.0
      subroutine cross(x,y,ijk,cprd)
      implicit double precision(a-h,o-z)
      dimension x(3), y(3)
      zero = 0.d0
      one = 1.d0
      two = 2.d0
      four = 4.d0
      if(ijk.eq.0)then
      smin = -one
      do23002 i = 1,3 
      ip = i+1
      if(ip.eq.4)then
      ip = 1
      endif
      a = x(ip) - x(i)
      b = y(ip) - y(i)
      s = a*a+b*b
      if(smin .lt. zero .or. s .lt. smin)then
      smin = s
      endif
23002 continue
23003 continue
      endif
      if(ijk.eq.1)then
      x(2) = x(2) - x(1)
      y(2) = y(2) - y(1)
      x(1) = zero
      y(1) = zero
      cn = sqrt(x(2)**2+y(2)**2)
      x(2) = x(2)/cn
      y(2) = y(2)/cn
      smin = one
      endif
      if(ijk.eq.2)then
      x(3) = x(3) - x(1)
      y(3) = y(3) - y(1)
      x(1) = zero
      y(1) = zero
      cn = sqrt(x(3)**2+y(3)**2)
      x(3) = x(3)/cn
      y(3) = y(3)/cn
      smin = one
      endif
      if(ijk.eq.3)then
      x(1) = zero
      y(1) = zero
      smin = 2
      endif
      if(ijk.eq.4)then
      x(3) = x(3) - x(2)
      y(3) = y(3) - y(2)
      x(2) = zero
      y(2) = zero
      cn = sqrt(x(3)**2+y(3)**2)
      x(3) = x(3)/cn
      y(3) = y(3)/cn
      smin = one
      endif
      if(ijk.eq.5)then
      x(2) = zero
      y(2) = zero
      smin = two
      endif
      if(ijk.eq.6)then
      x(3) = zero
      y(3) = zero
      smin = two
      endif
      if(ijk.eq.7)then
      smin = four
      endif
      a = x(2)-x(1)
      b = y(2)-y(1)
      c = x(3)-x(1)
      d = y(3)-y(1)
      cprd = (a*d - b*c)/smin
      return
      end

subroutine delseg(delsgs,ndel,nadj,madj,npd,x,y,ntot,incSeg)

# Output the endpoints of the line segments joining the
# vertices of the Delaunay triangles.
# Called by master.

implicit double precision(a-h,o-z)
logical value
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension delsgs(6,ndel)

# Initialise incSeg
incSeg = 0

# For each distinct pair of points i and j, if they are adjacent
# then put their endpoints into the output array.
npd = ntot-4
kseg = 0
do i = 2,npd {
    do j = 1,i-1 {
        call adjchk(i,j,value,nadj,madj,ntot)
        if(value) {
            kseg = kseg+1
            if(kseg > ndel) {
                incSeg = 1
                return
            }
            delsgs(1,kseg) = x(i)
            delsgs(2,kseg) = y(i)
            delsgs(3,kseg) = x(j)
            delsgs(4,kseg) = y(j)
            delsgs(5,kseg) = i
            delsgs(6,kseg) = j
        }
    }
}
ndel = kseg

return
end

subroutine circen(i,j,k,x0,y0,x,y,ntot,eps,collin)
! Find the circumcentre (x0,y0) of the triangle with
! vertices (x(i),y(i)), (x(j),y(j)), (x(k),y(k)).
! Called by qtest1, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension :: x(-3:ntot), y(-3:ntot), xt(3), yt(3)
dimension :: indv(3) ! To facillitate a lucid error message.
dimension :: xtmp(1)
dimension :: ndi(1)
logical :: collin

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! Get the coordinates.
xt(1) = x(i)
yt(1) = y(i)
xt(2) = x(j)
yt(2) = y(j)
xt(3) = x(k)
yt(3) = y(k)

! Check for collinearity
ijk = 0
call cross(xt,yt,ijk,cprd)
if(abs(cprd) < eps) then
    collin = .true.
else
    collin = .false.
endif

! Form the vector u from i to j, and the vector v from i to k,
! and normalize them.
a  = x(j) - x(i)
b  = y(j) - y(i)
c  = x(k) - x(i)
d  = y(k) - y(i)
c1 = sqrt(a*a+b*b)
c2 = sqrt(c*c+d*d)
a  = a/c1
b  = b/c1
c  = c/c2
d  = d/c2

! If the points are collinear, make sure that they're in the right
! order --- i between j and k.
if(collin) then
    alpha = a*c+b*d
! If they're not in the right order, bring things to
! a shuddering halt.
    if(alpha>0) then
        indv(1) = i
        indv(2) = j
        indv(3) = k
        call intpr("Point numbers:",-1,indv,3)
        xtmp(1) = alpha
        call dblepr("Test value:",-1,xtmp,1)
        call intpr("Points are collinear but in the wrong order.",-1,ndi,0)
        call rexit("Bailing out of circen.")
    endif
! Collinear, but in the right order; think of this as meaning
! that the circumcircle in question has infinite radius.
return
endif

! Not collinear; go ahead, make my circumcentre.  (First, form
! the cross product of the ***unit*** vectors, instead of the
! ``normalized'' cross product produced by ``cross''.)
crss = a*d - b*c
x0   = x(i) + 0.5*(c1*d - c2*b)/crss
y0   = y(i) + 0.5*(c2*a - c1*c)/crss

end subroutine circen

subroutine swap(j,k1,k2,shdswp,nadj,madj,x,y,ntot,eps,nerror)

# The segment k1->k2 is a diagonal of a quadrilateral
# with a vertex at j (the point being added to the
# triangulation).  If the LOP is not satisfied, swap
# it for the other diagonal.
# Called by addpt.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension ntadj(1000)
logical shdswp, anticl


# If vertices k1 and k2 are not connected there is no diagonal to swap.
# This could happen if vertices j, k1, and k2 were colinear, but shouldn't.
call adjchk(k1,k2,shdswp,nadj,madj,ntot,nerror)
if(nerror > 0) {
    return
}
if(!shdswp) return

# Get the other vertex of the quadrilateral.
call pred(k,k1,k2,nadj,madj,ntot,nerror) # If these aren't the same, then
if(nerror > 0) return
call succ(kk,k2,k1,nadj,madj,ntot,nerror) # there is no other vertex.
if(nerror > 0) return
if(kk!=k) {
#    if(j==580) call intpr("no other vertex",-1,1,0)
        shdswp = .false.
        return
}

# Check whether the LOP is satisified; i.e. whether
# vertex k is outside the circumcircle of vertices j, k1, and k2
if(k==580) {
    call intpr("From swap; point being added =",-1,j,1)
# Adj. list of k1 ("now").
    nk1 = nadj(k1,0)
    do jc = 1,nk1 {
            ntadj(jc) = nadj(k1,jc)
    }
    call intpr("now =",-1,k1,1)
    call intpr("adjacency list of now:",-1,ntadj,nk1)
# Adj. list of k1 ("now").
    nk2 = nadj(k2,0)
    do jc = 1,nk2 {
            ntadj(jc) = nadj(k2,jc)
    }
    call intpr("nxt =",-1,k2,1)
    call intpr("adjacency list of nxt:",-1,ntadj,nk2)
# Adj. list of j ("point being added").
    nj = nadj(j,0)
    do jc = 1,nj {
            ntadj(jc) = nadj(j,jc)
    }
    call intpr("point being added =",-1,j,1)
    call intpr("adjacency list of point being added:",-1,ntadj,nj)
# j, now, nxt should be in anticlockwise order.
    call acchk(j,k1,k2,anticl,x,y,ntot,eps)
    if(anticl) {
        call intpr("anticlockwise",-1,1,0)
    } else {
        call intpr("clockwise",-1,1,0)
    }
#
# i = now = k1, k = nxt = k2, and j = other vertex = k:
}
call qtest(j,k1,k,k2,shdswp,x,y,ntot,eps,nerror)
if(nerror > 0) return

# Do the actual swapping.
if(shdswp) {
        call delet(k1,k2,nadj,madj,ntot,nerror)
	if(nerror > 0) return
	call insrt(j,k,nadj,madj,x,y,ntot,nerror,eps)
	if(nerror > 0) return
}
return
end

subroutine cross(x,y,ijk,cprd)
implicit double precision(a-h,o-z)
dimension x(3), y(3)
# Calculates a ``normalized'' cross product of the vectors joining
# [x(1),y(1)] to [x(2),y(2)] and [x(3),y(3)] respectively.
# The normalization consists in dividing by the square of the
# shortest of the three sides of the triangle.  This normalization is
# for the purposes of testing for collinearity; if the result is less
# than epsilon, the smallest of the sines of the angles is less than
# epsilon.

# Set constants
zero = 0.d0
one  = 1.d0
two  = 2.d0
four = 4.d0

# Adjust the coordinates depending upon which points are ideal,
# and calculate the squared length of the shortest side.

# case 0: No ideal points; no adjustment necessary.
if(ijk==0) {
	smin = -one
	do i = 1,3 {
		ip = i+1
		if(ip==4) ip = 1
		a = x(ip) - x(i)
		b = y(ip) - y(i)
		s = a*a+b*b
		if(smin < zero | s < smin) smin = s
	}
}

# case 1: Only k ideal.
if(ijk==1) {
	x(2) = x(2) - x(1)
	y(2) = y(2) - y(1)
	x(1) = zero
	y(1) = zero
	cn   = sqrt(x(2)**2+y(2)**2)
	x(2) = x(2)/cn
	y(2) = y(2)/cn
	smin  = one
}

# case 2: Only j ideal.
if(ijk==2) {
	x(3) = x(3) - x(1)
	y(3) = y(3) - y(1)
	x(1) = zero
	y(1) = zero
	cn   = sqrt(x(3)**2+y(3)**2)
	x(3) = x(3)/cn
	y(3) = y(3)/cn
	smin = one
}

# case 3: Both j and k ideal (i not).
if(ijk==3) {
		x(1) = zero
		y(1) = zero
		smin  = 2
}

# case 4: Only i ideal.
if(ijk==4) {
	x(3) = x(3) - x(2)
	y(3) = y(3) - y(2)
	x(2) = zero
	y(2) = zero
	cn   = sqrt(x(3)**2+y(3)**2)
	x(3) = x(3)/cn
	y(3) = y(3)/cn
	smin = one
}

# case 5: Both i and k ideal (j not).
if(ijk==5) {
	x(2) = zero
	y(2) = zero
	smin = two
}

# case 6: Both i and j ideal (k not).
if(ijk==6) {
	x(3) = zero
	y(3) = zero
	smin = two
}

# case 7: All three points ideal; no adjustment necessary.
if(ijk==7) {
	smin = four
}

a = x(2)-x(1)
b = y(2)-y(1)
c = x(3)-x(1)
d = y(3)-y(1)

cprd = (a*d - b*c)/smin
return
end

subroutine qtest1(h,i,j,k,x,y,ntot,eps,shdswp)

! The Lee-Schacter test for the LOP (all points are real,
! i.e. non-ideal).  If the LOP is ***not*** satisfied (i.e. if
! vertex j is inside the circumcircle of vertices h, i, and k) then the
! diagonals should be swapped, i.e. shdswp ("should-swap") is true.
! Called by qtest.

implicit double precision(a-h,o-z)
dimension :: x(-3:ntot), y(-3:ntot), xt(3), yt(3), indv(3)
dimension :: itmp(1)
dimension :: xtmp(1)
dimension :: ndi(1)
integer :: h
logical :: shdswp, collin

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! The vertices of the quadrilateral are labelled
! h, i, j, k in the anticlockwise direction, h
! being the point of central interest.

! Make sure the quadrilateral is convex, so that
! it makes sense to swap the diagonal.
! call acchk(i,j,k,shdswp,x,y,ntot,eps)
! if(!shdswp) return
!
! 23 July 2011:
! The foregoing test is a load of dingoes' kidneys.  (1) It is
! unnecessary, and (2) it is wrong!  (1) If the LOP is not satisfied
! (the only circumstance under which there should be a swap) then the
! quadrilateral ***must*** be convex, and so swapping can sensibly
! take place.  (2) The vertices i, j, k in will ***always*** be in
! anticlockwise order, since the vertices h, i, j, k of the quadrilateral
! are in such order and i is connected to k, whence j can't be inside
! the triangle ihk.  So the test does nothing.  But then it didn't need
! to do anything.

! Check for collinearity of points h, i and k.
xt(1) = x(h)
yt(1) = y(h)
xt(2) = x(i)
yt(2) = y(i)
xt(3) = x(k)
yt(3) = y(k)
nid = 0  ! nid = number of ideal points.
call cross(xt,yt,nid,cprd)
collin = (abs(cprd) < eps) ! Does this work???

! If the points are collinear, make sure that they're in the right
! order --- h between i and k.
if(collin) then
! Form the vector u from h to i, and the vector v from h to k,
! and normalize them.
    a  = xt(2) - xt(1)
    b  = yt(2) - yt(1)
    c  = xt(3) - xt(1)
    d  = yt(3) - yt(1)
    c1 = sqrt(a*a+b*b)
    c2 = sqrt(c*c+d*d)
    a  = a/c1
    b  = b/c1
    c  = c/c2
    d  = d/c2
    alpha = a*c+b*d
! If they're not in the right order, bring things to
! a shuddering halt.
    if(alpha>0) then
        itmp(1) = 1
        indv(1) = i
        indv(2) = j
        indv(3) = k
        itmp(1) = h
        call intpr("Point being added, h:",-1,itmp,1)
        call intpr("now, other vertex, nxt:",-1,indv,3)
        xtmp(1) = alpha
        call dblepr("Test value:",-1,xtmp,1)
        call intpr("Points are collinear but h is not between i and k.",-1,ndi,0)
        call rexit("Bailing out of qtest1.")
    endif
! Collinear, and in the right order; think of this as meaning
! that the circumcircle in question has infinite radius.
    shdswp = .true.
endif

! Get the coordinates of vertices h and j.
xh = x(h)
yh = y(h)
xj = x(j)
yj = y(j)

! Find the centre of the circumcircle of vertices h, i, k.
call circen(h,i,k,x0,y0,x,y,ntot,eps,shdswp)
if(shdswp) return ! The points h, i, and k are colinear, so
                  ! the circumcircle has `infinite radius', so
                  ! (xj,yj) is definitely inside!

! Check whether (xj,yj) is inside the circle of centre
! (x0,y0) and radius r = dist[(x0,y0),(xh,yh)]

a  = x0-xh
b  = y0-yh
r2 = a*a+b*b
a  = x0-xj
b  = y0-yj
ch = a*a + b*b
if(ch<r2) then
    shdswp = .true.
else
    shdswp = .false.
endif
end subroutine qtest1

subroutine dirseg(dirsgs,ndir,nadj,madj,npd,x,y,ntot,rw,eps,ind,nerror)

# Output the endpoints of the segments of boundaries of Dirichlet
# tiles.  (Do it economically; each such segment once and only once.)
# Called by master.

implicit double precision(a-h,o-z)
logical collin, adjace, intfnd, bptab, bptcd, goferit, rwu
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension dirsgs(8,ndir), rw(4), ind(npd)

nerror = -1

# Add in some dummy corner points, outside the actual window.
# Far enough out so that no resulting tile boundaries intersect the
# window.

# Note that these dummy corners are needed by the routine `dirout'
# but will screw things up for `delseg' and `delout'.  Therefore
# this routine (`dirseg') must be called ***before*** dirout, and
# ***after*** delseg and delout.

# Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

a = xmax-xmin
b = ymax-ymin
c = sqrt(a*a+b*b)

npd  = ntot-4
nstt = npd+1
i = nstt
x(i) = xmin-c
y(i) = ymin-c
i = i+1
x(i) = xmax+c
y(i) = ymin-c
i = i+1
x(i) = xmax+c
y(i) = ymax+c
i = i+1
x(i) = xmin-c
y(i) = ymax+c

do j = nstt,ntot {
	call addpt(j,nadj,madj,x,y,ntot,eps,nerror)
	if(nerror > 0) return
}

# Put the segments into the array dirsgs.

# For each distinct pair of (genuine) data points, find out if they are
# adjacent.  If so, find the circumcentres of the triangles lying on each
# side of the segment joining them.
kseg = 0
do i1 = 2,npd {
	i = ind(i1)
        do j1 = 1,i1-1 {
		j = ind(j1)
                call adjchk(i,j,adjace,nadj,madj,ntot,nerror)
		if(nerror > 0) return
                if(adjace) {
                        call pred(k,i,j,nadj,madj,ntot,nerror)
			if(nerror > 0) return
                        call circen(i,k,j,a,b,x,y,ntot,eps,collin,nerror)
			if(nerror > 0) return
                        if(collin) {
				nerror = 12
				return
			}
                        call succ(l,i,j,nadj,madj,ntot,nerror)
			if(nerror > 0) return
                        call circen(i,j,l,c,d,x,y,ntot,eps,collin,nerror)
			if(nerror > 0) return
                        if(collin) {
				nerror = 12
				return
			}
                        # If a circumcentre is outside the rectangular window
                        # of interest, draw a line joining it to the other
                        # circumcentre.  Find the intersection of this line with
                        # the boundary of the window; for (a,b) and call the point
                        # of intersection (ai,bi).  For (c,d), call it (ci,di).
                        # Note: rwu = "right way up".
                        xi = x(i)
                        xj = x(j)
                        yi = y(i)
                        yj = y(j)
                        if(yi!=yj) {
                            slope = (xi - xj)/(yj - yi)
                            rwu   = .true.
                        } else {
                            slope = 0.d0
                            rwu = .false.
                        }
                        call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab)
			if(!intfnd) {
				nerror = 16
				return
			}
                        call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd)
			if(!intfnd) {
				nerror = 16
				return
			}
			goferit = .false.
			if(bptab & bptcd) {
				xm = 0.5*(ai+ci)
				ym = 0.5*(bi+di)
				if(xmin<xm&xm<xmax&ymin<ym&ym<ymax) {
					goferit = .true.
				}
			}
			if((!bptab)|(!bptcd)) goferit = .true.
			if(goferit) {
				kseg = kseg + 1
				if(kseg > ndir) {
					nerror = 15
					return
				}
				dirsgs(1,kseg) = ai
				dirsgs(2,kseg) = bi
				dirsgs(3,kseg) = ci
				dirsgs(4,kseg) = di
				dirsgs(5,kseg) = i1
				dirsgs(6,kseg) = j1
				if(bptab) dirsgs(7,kseg) = 1.d0
				else dirsgs(7,kseg) = 0.d0
				if(bptcd) dirsgs(8,kseg) = 1.d0
				else dirsgs(8,kseg) = 0.d0
			}
                }
        }
}
ndir = kseg

return
end

subroutine acchk(i,j,k,anticl,x,y,ntot,eps)
! Check whether vertices i, j, k, are in anti-clockwise order.
! Called by locn, qtest, qtest1.

implicit double precision(a-h,o-z)
dimension :: x(-3:ntot), y(-3:ntot), xt(3), yt(3)
logical :: anticl

! Create indicator telling which of i, j, and k are ideal points.
if(i<=0) then
    i1 = 1
else
    i1 = 0
endif
if(j<=0) then
    j1 = 1
else
    j1 = 0
endif
if(k<=0) then
    k1 = 1
else
    k1 = 0
endif
ijk = i1*4+j1*2+k1

! Get the coordinates of vertices i, j, and k. (Pseudo-coordinates for
! any ideal points.)
xt(1) = x(i)
yt(1) = y(i)
xt(2) = x(j)
yt(2) = y(j)
xt(3) = x(k)
yt(3) = y(k)

! Get the ``normalized'' cross product.
call cross(xt,yt,ijk,cprd)

! If cprd is positive then (ij-cross-ik) is directed ***upwards*** 
! and so i, j, k, are in anti-clockwise order; else not.
if(cprd > eps) then
    anticl = .true.
else
    anticl = .false.
endif
end subroutine acchk

subroutine triar(x0,y0,x1,y1,x2,y2,area)

# Calculate the area of a triangle with given
# vertices, in anti clockwise direction.
# Called by delout.

implicit double precision(a-h,o-z)
half = 0.5d0

area = half*((x1-x0)*(y2-y0)-(x2-x0)*(y1-y0))
return
end

getCol <- function (x,warn=FALSE) {
if(!inherits(x,"tile.list"))
    stop("Argument \"x\" must be of class \"tile.list\".\n")
ccc <- unlist(sapply(x,function(u){u[["z"]]}))
if(is.null(ccc)) return(NA)
ccc <- try(apply(col2rgb(ccc, TRUE), 2,
             function(x){do.call(rgb, as.list(x/255))}),silent=TRUE)
if(inherits(ccc,"try-error")){
    if(warn) warning(paste("Cannot interpret the z-components of",
                        "argument \"x\" as colours.\n"))
    return(NA)
}
ccc
}

lawSummary <- function(object) {
#
# Function to produce a summary of a Dirichlet (Voronoi)
# tessellation in terms of parameters relevant to Lewis's law
# and Aboav-Weaire's law.  Note that "law" in the function name
# corresponds to "Lewis-Aboav-Weaire.
#
# The parameters of interest are:
# * the areas of each of the interior Dirichlet tiles
# * the number of edges of each of the interior Dirichlet tiles
# * the number of edges of all neighbouring tiles of
#   each of the interior Dirichlet tiles.
#
# This function was created at the request of Kai Xu
# (Fisheries College, Jimei University, Xiamen, Fujian, China 361021).
#

dnbrs <- function(dsgs) {
# Delaunay neighbours.
    iii <- dsgs[,c("ind1","ind2")]
    uind <- with(iii,sort(unique(c(ind1,ind2))))
    rslt <- lapply(uind,function(i,m){sort(c(m[m[,1]==i,2],m[m[,2]==i,1]))},m=iii)
    names(rslt) <- uind
    rslt
}

dsgs <- object$dirsgs
nbrs <- dnbrs(dsgs)

# Layer 1; tiles whose edges have vertices on the boundary.
ex1   <- apply(dsgs[,c("bp1","bp2")],1,any)
dout1 <- dsgs[ex1,]
iout1 <- as.character(unique(c(dout1[,"ind1"],dout1[,"ind2"])))

# Layer 2: tiles having vertices that are Delaunay neighbours
# of vertices of tiles in Layer 1.
nb1 <- as.character(unique(unlist(nbrs[iout1])))

# Layer 3: tiles having vertices that are Delaunay neighbours
# of vertices of tiles in Layer 2.
iout2 <- setdiff(nb1,iout1)
nb2   <- as.character(unique(unlist(nbrs[iout2])))
iout3 <- setdiff(nb2,union(iout1,iout2))

# Keepers.
smry     <- object$summary
nms.all  <- rownames(object$summary)
iout.12  <- union(iout1,iout2)
iout.123 <- union(iout.12,iout3)
nms.12   <- setdiff(nms.all,iout.12)
nms.123  <- setdiff(nms.all,iout.123)
if(!length(nms.123)) return(NULL)

smry.123 <- smry[nms.123,]
smry.12 <- smry[nms.12,]

tile.areas        <- smry.123$dir.area
names(tile.areas) <- nms.123
tile.tags         <- smry.123$z
if(!is.null(tile.tags)) {
    names(tile.tags)  <- nms.123
}
num.edges         <- smry.12$n.tside
names(num.edges)  <- nms.12
i.12              <- as.numeric(nms.12)
i.123             <- as.numeric(nms.123)
nbrs.12           <- lapply(nbrs,function(x,iok){intersect(x,iok)},iok=i.12)
nbrs.123          <- lapply(nbrs.12[i.123],as.character)
num.nbr.edges     <- lapply(nbrs.123,function(k,x){x[k]},x=num.edges)
totnum.nbr.edges  <- sapply(num.nbr.edges,sum)
num.edges         <- num.edges[nms.123]

tl        <- tile.list(object)[i.123]
tv        <- lapply(tl,function(x){data.frame(x=x$x,y=x$y)})
names(tv) <- nms.123
rslt <- list(tile.vertices=tv,tile.areas=tile.areas)
if(!is.null(tile.tags)) {
    rslt <- c(rslt,list(tile.tags=tile.tags))
}
rslt <- c(rslt,list(num.edges=num.edges,num.nbr.edges=num.nbr.edges,
                    totnum.nbr.edges=totnum.nbr.edges))
attr(rslt,"i1") <- as.numeric(iout1)
attr(rslt,"i2") <- as.numeric(iout2)
attr(rslt,"i3") <- as.numeric(iout3)
attr(rslt,"i.kept") <- i.123
rslt
}

duplicatedxy <- function(x,y) {
    if(is.list(x)) {
        if(all(!is.na(match(c('x','y'),names(x))))) {
            return(duplicated(as.data.frame(x)))
        }
        stop("Argument \"x\" is a list but lacks x and/or y components.\n")
    }
    duplicated(data.frame(x=x,y=y))
}

C Output from Public domain Ratfor, version 1.03
      subroutine binsrt(x,y,rw,npd,ind,rind,tx,ty,ilst)
      implicit double precision(a-h,o-z)
      dimension x(npd), y(npd), tx(npd), ty(npd)
      integer rind(npd)
      dimension ind(npd), ilst(npd)
      dimension rw(4)
      dimension ndi(1)
      ndi(1) = 0
      kdiv = int(1+dble(npd)**0.25)
      xkdiv = dble(kdiv)
      xmin = rw(1)
      xmax = rw(2)
      ymin = rw(3)
      ymax = rw(4)
      w = xmax-xmin
      h = ymax-ymin
      dw = w/xkdiv
      dh = h/xkdiv
      kx = 1
      ky = 1
      ink = 1
      k = 0
      do23000 i = 1,npd 
      ilst(i) = 0 
23000 continue
23001 continue
23002 if(ky.le.kdiv)then
      do23004 i = 1,npd 
      if(ilst(i).eq.1)then
      goto 23004
      endif
      xt = x(i)
      yt = y(i)
      ix = int(1+(xt-xmin)/dw)
      if(ix.gt.kdiv)then
      ix = kdiv
      endif
      jy = int(1+(yt-ymin)/dh)
      if(jy.gt.kdiv)then
      jy = kdiv
      endif
      if(ix.eq.kx.and.jy.eq.ky)then
      k = k+1
      ind(i) = k
      rind(k) = i
      tx(k) = xt
      ty(k) = yt
      ilst(i) = 1
      endif
23004 continue
23005 continue
      kc = kx+ink
      if((1.le.kc).and.(kc.le.kdiv))then
      kx = kc
      else
      ky = ky+1
      ink = -ink
      endif
      goto 23002
      endif
23003 continue
      if(k.ne.npd)then
      call intpr("Mismatch between number of points",-1,ndi,0)
      call intpr("and number of sorted points.",-1,ndi,0)
      call rexit("Bailing out of binsrt.")
      endif
      do23018 i = 1,npd 
      x(i) = tx(i)
      y(i) = ty(i)
23018 continue
23019 continue
      return
      end

doClip <- function(object,clipp,rw) {
    pgon <- polyclip::polyclip(object,clipp)
    n    <- length(pgon)
    if(n) {
        rslt  <- object[c("ptNum","pt")]
        cmps  <- vector("list",n)
        xold  <- object$x
        yold  <- object$y
        bpold <- object$bp
        for(ii in 1:n) {
            xnew <- pgon[[ii]]$x
            ynew <- pgon[[ii]]$y
            imtch <- findNewInOld(xnew,xold,ynew,yold)
            bp         <- rep(FALSE,length(imtch))
            bp[imtch!=0]  <- bpold[imtch]
            area       <- tileArea(xnew,ynew,rw)
            cmps[[ii]] <- list(x=xnew,y=ynew,bp=bp,area=area)
        }
        if(n==1) {
            rslt <- c(rslt,cmps[[1]])
        } else {
            rslt <- c(rslt,list(tileParts=cmps))
        }
        attr(rslt,"ncomp") <- n
    } else rslt <- NULL
    rslt
}

subroutine trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,nerror)

# Find the triangle of the extant triangulation in which
# lies the point currently being added.
# Called by initad.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot), xt(3), yt(3)
integer tau(3), temp(21)
logical adjace

nerror = -1

# The first point must be added to the triangulation before
# calling trifnd.
if(j==1) {
	nerror = 11
	return
}

# Get the previous triangle:
j1     = j-1
tau(1) = j1
tau(3) = nadj(j1,1)
call pred(tau(2),j1,tau(3),nadj,madj,ntot,nerror)
if(nerror > 0) return
call adjchk(tau(2),tau(3),adjace,nadj,madj,ntot,nerror)
if(nerror>0) return
if(!adjace) {
        tau(3) = tau(2)
	call pred(tau(2),j1,tau(3),nadj,madj,ntot,nerror)
	if(nerror > 0) return
}

# Move to the adjacent triangle in the direction of the new
# point, until the new point lies in this triangle.
1       continue
ntau  = 0 # This number will identify the triangle to be moved to.
nedge = 0 # If the point lies on an edge, this number will identify that edge.
do i = 1,3 {
        ip = i+1
        if(ip==4) ip = 1 # Take addition modulo 3.

# Get the coordinates of the vertices of the current side,
# and of the point j which is being added:
	xt(1) = x(tau(i))
	yt(1) = y(tau(i))
	xt(2) = x(tau(ip))
	yt(2) = y(tau(ip))
	xt(3) = x(j)
	yt(3) = y(j)

# Create indicator telling which of tau(i), tau(ip), and j
# are ideal points.  (The point being added, j, is ***never*** ideal.)
	if(tau(i)<=0) i1 = 1
	else i1 = 0
	if(tau(ip)<=0) j1 = 1
	else j1 = 0
	k1 = 0
	ijk = i1*4+j1*2+k1

# Calculate the ``normalized'' cross product; if this is positive
# then the point being added is to the left (as we move along the
# edge in an anti-clockwise direction).  If the test value is positive
# for all three edges, then the point is inside the triangle.  Note
# that if the test value is very close to zero, we might get negative
# values for it on both sides of an edge, and hence go into an
# infinite loop.
	call cross(xt,yt,ijk,cprd)
	if(cprd >= eps) continue
	else if(cprd > -eps) nedge = ip
	else {
		ntau = ip
		break
	}
}

# We've played ring-around-the-triangle; now figure out the
# next move:

# case 0: All tests >= 0.; the point is inside; return.
if(ntau==0) return

# The point is not inside; work out the vertices of the triangle to which
# to move.  Notation: Number the vertices of the current triangle from 1 to 3,
# anti-clockwise. Then "triangle i+1" is adjacent to the side from vertex i to
# vertex i+1, where i+1 is taken modulo 3 (i.e. "3+1 = 1").

# case 1: Move to "triangle 1"
if(ntau==1) {
	#tau(1) = tau(1)
	tau(2)  = tau(3)
	call succ(tau(3),tau(1),tau(2),nadj,madj,ntot,nerror)
	if(nerror > 0) return
}

# case 2: Move to "triangle 2"
if(ntau==2) {
	#tau(1) = tau(1)
	tau(3)  = tau(2)
	call pred(tau(2),tau(1),tau(3),nadj,madj,ntot,nerror)
	if(nerror > 0) return
}

# case 3: Move to "triangle 3"
if(ntau==3) {
	tau(1)  = tau(3)
	#tau(2) = tau(2)
	call succ(tau(3),tau(1),tau(2),nadj,madj,ntot,nerror)
	if(nerror > 0) return
}

# We've moved to a new triangle; check if the point being added lies
# inside this one.
go to 1

end

plot.triang.list <- function(x,showrect=FALSE,add=FALSE,xlab="x",ylab="y",
                             main="",asp=1,rectcol="black",...) {
stopifnot(inherits(x,"triang.list"))
rw <- attr(x,"rw")
if(!add) {
	plot(0,0,type="n",xlim=rw[1:2],ylim=rw[3:4],
             xlab=xlab,ylab=ylab,main=main,asp=asp)
}
for(tri in x) {
	polygon(as.list(tri),...)
}
if(showrect) do.call(rect,c(as.list(rw)[c(1,3,2,4)],border=rectcol))
invisible()
}

tilePerim <- function(object,inclbdry=TRUE) {
    if(!inherits(object,"tile.list"))
        stop("Argument \"object\" must be of class \"tile.list\".\n")
    perims   <- lapply(object,tilePerim0,inclbdry=inclbdry)
    perComps <- lapply(perims,function(x){attr(x,"perComps")})
    perims   <- unlist(perims)
    rslt     <- list(perimeters=perims,totalPerim=sum(perims),
                     meanPerim=mean(perims),perComps=perComps)
    rslt
}

C Output from Public domain Ratfor, version 1.0
      subroutine insrt(i,j,nadj,madj,x,y,ntot,nerror,eps)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      logical adj
      call adjchk(i,j,adj,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(adj)then
      return
      endif
      call locn(i,j,kj,nadj,madj,x,y,ntot,eps)
      call locn(j,i,ki,nadj,madj,x,y,ntot,eps)
      call insrt1(i,j,kj,nadj,madj,ntot,nerror)
      if(nerror .gt.0)then
      return
      endif
      call insrt1(j,i,ki,nadj,madj,ntot,nerror)
      if(nerror .gt.0)then
      return
      endif
      return
      end

subroutine swap(j,k1,k2,shdswp,nadj,madj,x,y,ntot,eps,incAdj)

! The segment k1->k2 is a diagonal of a quadrilateral
! with a vertex at j (the point being added to the
! triangulation).  If the LOP is not satisfied, swap
! it for the other diagonal.
! Called by addpt.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical :: shdswp


! If vertices k1 and k2 are not connected there is no diagonal to swap.
! This could happen if vertices j, k1, and k2 were colinear, but shouldn't.
call adjchk(k1,k2,shdswp,nadj,madj,ntot)
if(.not.shdswp) return

! Get the other vertex of the quadrilateral.
call pred(k,k1,k2,nadj,madj,ntot)  ! If these aren't the same, then
call succ(kk,k2,k1,nadj,madj,ntot) ! there is no other vertex.
if(kk .ne. k) then
    shdswp = .false.
    return
endif

! Check whether the LOP is satisified; i.e. whether
! vertex k is outside the circumcircle of vertices j, k1, and k2
call qtest(j,k1,k,k2,shdswp,x,y,ntot,eps)

! Do the actual swapping.
if(shdswp) then
    call delet(k1,k2,nadj,madj,ntot)
    call insrt(j,k,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
endif
end subroutine swap

print.tileInfo <- function(x,digits=4,npl=6,...) {
#
# Matrix of edge lengths:
lel <- lapply(x$indivTiles,function(u){u$edgeLengths})
nel <- sapply(lel,length)
pNs  <- names(x$indivTiles)
m   <- length(nel)
n   <- max(nel)
ld  <- ceiling(log10(max(unlist(lel)))) + digits + 1
fmt <- paste0("%",ld,".",digits,"f")
nms <- paste0("point ",sub("pt.","",pNs),": ")
npad <- max(nchar(nms))
pad  <- paste(rep(" ",npad),collapse="")
cat("\nEdge lengths:\n")
cat("=============\n")
for(i in 1:m) {
    xxx <- sprintf(fmt,lel[[i]])
    irpt <- 0
    repeat{
       buff <- rep(" ",nchar(pad) - nchar(nms[i]))
       buff <- paste(buff,collapse="")
       lhe  <- paste0(nms[i],buff)
       if(irpt==0) cat(lhe ) else cat(pad)
       ibit <- min(npl,length(xxx))
       yyy <- xxx[1:ibit]
       xxx <- xxx[-(1:ibit)]
       cat(yyy,"\n")
       irpt <- 1
       if(length(xxx)==0) break
    }
}

# Table of edgecounts:
tec <- x$tabEdgeCounts
names(attr(tec,"dimnames")) <- ""
mode(tec) <- "character"
tec <- c("  ",tec)
cat("\nTable of edge counts:\n")
cat("=====================\n\n")
print(tec,quote=FALSE)

# Areas:
cat("\nTile areas:\n")
cat("===========\n\n")
print(round(x$Areas,digits=digits))
cat("\n")

# Perimeters:
cat("\nTile perimeters:\n")
cat("================\n\n")
print(round(x$perimeters$perimeters,digits=digits))
cat("\n")

# Neighbours:
cat("\nDelaunay neighbours of tile centres:\n")
cat("=====================================\n\n")
nbrs <- x$nbrs
nms  <- names(nbrs)
nms  <- sub("pt.","",nms)
for(i in 1:length(nbrs)) {
    cat("point ",nms[i]," has neighbours: ",paste(nbrs[[i]],collapse=" "),"\n",sep="")
}
cat("\n")

invisible()
}

subroutine mnnd(x,y,n,dminbig,dminav)
#
# Mean nearest neighbour distance.  Called by .Fortran()
# from mnnd.R.
#
implicit double precision(a-h,o-z)
dimension x(n), y(n)

dminav = 0.d0
do i = 1,n {
	dmin = dminbig
	do j = 1,n {
		if(i!=j) {
			d = (x(i)-x(j))**2 + (y(i)-y(j))**2
			if(d < dmin) dmin = d
		}
	}
	dminav = dminav + sqrt(dmin)
}

dminav = dminav/n

return
end

C Output from Public domain Ratfor, version 1.0
      subroutine addpt(j,nadj,madj,x,y,ntot,eps,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      logical didswp
      call initad(j,nadj,madj,x,y,ntot,eps,nerror)
      if(nerror .gt. 0)then
      return
      endif
      now = nadj(j,1)
      nxt = nadj(j,2)
      ngap = 0
23002 continue
      call swap(j,now,nxt,didswp,nadj,madj,x,y,ntot,eps,nerror)
      if(nerror .gt. 0)then
      return
      endif
      n = nadj(j,0)
      if(.not.didswp)then
      now = nxt
      ngap = ngap+1
      endif
      call succ(nxt,j,now,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
23003 if(.not.(ngap.eq.n))goto 23002
23004 continue
      return
      end

subroutine adjchk(i,j,adj,nadj,madj,ntot)
! Check if vertices i and j are adjacent.
! Called by insrt, delet, trifnd, swap, delseg, dirseg.

dimension :: nadj(-3:ntot,0:madj)
logical :: adj
dimension :: ndi(1)

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! Check if j is in the adjacency list of i.
adj = .false.
ni  = nadj(i,0)
if(ni>0) then
    do k = 1,ni
        if(j==nadj(i,k)) then
            adj = .true.
            exit
        endif
    enddo
endif

! Check if i is in the adjacency list of j.
nj = nadj(j,0)
if(nj>0) then
    do k = 1,nj
        if(i==nadj(j,k)) then
            if(adj) then
                return ! Have j in i's list and i in j's.
            else
                call intpr("Contradictory adjacency lists.",-1,ndi,0)
                call rexit("Bailing out of adjchk.")
            endif
        endif
    enddo
endif

! If we get to here i is not in j's list.
if(adj) then ! If adj is true, then j IS in i's list.
    call intpr("Contradictory adjacency lists.",-1,ndi,0)
    call rexit("Bailing out of adjchk.")
endif

end subroutine adjchk

get.cnrind <- function(x,y,rw) {
x.crnrs <- rw[c(1,2,2,1)]
y.crnrs <- rw[c(3,3,4,4)]
M1 <- outer(x,x.crnrs,function(a,b){(a-b)^2})
M2 <- outer(y,y.crnrs,function(a,b){(a-b)^2})
MM <- M1 + M2
apply(MM,2,which.min)
}

subroutine testeq(a,b,eps,value)

# Test for the equality of a and b in a fairly
# robust way.
# Called by trifnd, circen, stoke.

implicit double precision(a-h,o-z)
logical value

# Define constants.
one = 1.d0
ten = 1.d10

# If b is essentially 0, check whether a is essentially zero also.
# The following is very sloppy!  Must fix it!
if(abs(b)<=eps) {
        if(abs(a)<=eps) value = .true.
        else value = .false.
        return
}

# Test if a is a `lot different' from b.  (If it is
# they're obviously not equal.)  This avoids under/overflow
# problems in dividing a by b.
if(abs(a)>ten*abs(b)|abs(a)<one*abs(b)) {
        value = .false.
        return
}

# They're non-zero and fairly close; compare their ratio with 1.
c = a/b
if(abs(c-1.d0)<=eps) value = .true.
else value = .false.

return
end

tile.centroids <- function(tl){
#
# "tl" <--> "tile list".
#
coit <- function (x,y) {
#
# "coit" <--> "centroid of individual tile".
#
	x <- c(x,x[1])
	y <- c(y,y[1])
	n <- length(x)
	u <- x[-n]*y[-1]
	v <- x[-1]*y[-n]
	w <- x[-n]+x[-1]
	z <- y[-n]+y[-1]
	A <- 3*(sum(u)-sum(v))
	Cx <- sum(w*(u-v))/A
	Cy <- sum(z*(u-v))/A
	c(Cx,Cy)
}
ccc <- lapply(tl,function(x){coit(x$x,x$y)})
ccc <- as.data.frame(matrix(unlist(ccc),ncol=2,byrow=TRUE))
names(ccc) <- c("x","y")
ccc
}

subroutine mnnd(x,y,n,dminbig,dminav)
!
! Mean nearest neighbour distance.  Called by .Fortran()
! from mnnd.R.
!
implicit double precision(a-h,o-z)
dimension :: x(n), y(n)

dminav = 0.d0
do i = 1,n
    dmin = dminbig
    do j = 1,n
        if(i .ne. j) then
            d = (x(i)-x(j))**2 + (y(i)-y(j))**2
            if(d < dmin) dmin = d
        endif
    enddo
    dminav = dminav + sqrt(dmin)
enddo

dminav = dminav/n

return
end

subroutine circen(i,j,k,x0,y0,x,y,ntot,eps,collin)
# Find the circumcentre (x0,y0) of the triangle with
# vertices (x(i),y(i)), (x(j),y(j)), (x(k),y(k)).
# Called by qtest1, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot), xt(3), yt(3)
dimension indv(3) # To facillitate a lucid error message.
dimension xtmp(1)
dimension ndi(1)
logical collin

# Set dummy integer for call to intpr(...).
ndi(1) = 0

# Get the coordinates.
xt(1) = x(i)
yt(1) = y(i)
xt(2) = x(j)
yt(2) = y(j)
xt(3) = x(k)
yt(3) = y(k)

# Check for collinearity
ijk = 0
call cross(xt,yt,ijk,cprd)
if(abs(cprd) < eps) collin = .true.
else collin = .false.

# Form the vector u from i to j, and the vector v from i to k,
# and normalize them.
a  = x(j) - x(i)
b  = y(j) - y(i)
c  = x(k) - x(i)
d  = y(k) - y(i)
c1 = sqrt(a*a+b*b)
c2 = sqrt(c*c+d*d)
a  = a/c1
b  = b/c1
c  = c/c2
d  = d/c2

# If the points are collinear, make sure that they're in the right
# order --- i between j and k.
if(collin) {
    alpha = a*c+b*d
# If they're not in the right order, bring things to
# a shuddering halt.
    if(alpha>0) {
        indv(1) = i
        indv(2) = j
        indv(3) = k
        call intpr("Point numbers:",-1,indv,3)
        xtmp(1) = alpha
        call dblepr("Test value:",-1,xtmp,1)
        call intpr("Points are collinear but in the wrong order.",-1,ndi,0)
        call rexit("Bailing out of circen.")
    }
# Collinear, but in the right order; think of this as meaning
# that the circumcircle in question has infinite radius.
return
}

# Not collinear; go ahead, make my circumcentre.  (First, form
# the cross product of the ***unit*** vectors, instead of the
# ``normalized'' cross product produced by ``cross''.)
crss = a*d - b*c
x0   = x(i) + 0.5*(c1*d - c2*b)/crss
y0   = y(i) + 0.5*(c2*a - c1*c)/crss

return
end

tileInfo <- function(object,bndry=FALSE,clipp=NULL) {
#
# Function to provide a summary of information about the tiles
# of a Dirichlet (Voronoi) tessellation.
#
# First check that we really are looking at a tessellation/triangulation.
    if (!inherits(object, "deldir")) 
        stop("Argument \"object\" is not of class \"deldir\".\n")
# List the (possibly clipped) tiles in the tessellation.
    tl <- tile.list(object,clipp=clipp)

# Required info:
# * for each tile, the number of edges
# * for each tile, a vector of the lengths of the edges
# * for each tile, the vector of indices of the Delaunay neighbours
#   of the centre of the tile
# * a tabulation of the numbers of edges of tiles
# * a vector of all lengths of edges (with repetitions)
# * a vector of lengths of _unique_ edges
# * the area of each tile

    getEdges <- function(tile){
        ncomp <- attr(tile,"ncomp")
        if(ncomp==1) {
            cmps <- list(tile)
        } else {
            cmps <- tile$tileParts
        }
        edges <- vector("list",ncomp)
        for(i in 1:ncomp) {
            tP <- cmps[[i]]
            x  <- tP$x
            y  <- tP$y
            x1 <- c(x,x[1])
            y1 <- c(y,y[1])
            hedges <- cbind(x1[-1],x,y1[-1],y)
            edges[[i]] <- t(apply(hedges,1,function(x){
                                o <- order(x[1:2],x[3:4])
                                c(x[1:2][o],x[3:4][o])
                                }))
       }
       edges <- do.call(rbind,edges)
       ledge <- apply(edges,1,function(x){sqrt((x[1]-x[2])^2 + (x[3]-x[4])^2)})
       areas <- sapply(cmps,function(x){x$area})
       list(edges=edges,edgeLengths=ledge,area=sum(areas),ptNum=tile$ptNum)
    }

    cnob <- function(tile) {
    # Check not on boundary.
        if(attr(tile,"ncomp")==1) {
            cmps <- list(tile)
        } else {
            cmps <- tile$tileParts
        }
        all(sapply(cmps,function(x){!any(x$bp)}))
    }

    ok <- sapply(tl,if(bndry) function(x){TRUE} else cnob)
    if(sum(ok)==0) {
        whinge <- paste0("All tiles are boundary tiles.  To get a non-vacuous\n",
                         "  result, set bndry=TRUE.\n")
        stop(whinge)
    }
    xxx   <- lapply(tl[ok],getEdges)
    ptNms <- object$summary[["id"]]
    if(is.null(ptNms)) {
        ptNums <- unname(sapply(xxx,function(x){x$ptNum}))
        ptNms  <- paste0("pt.",1:nrow(object$summary))
    }
    nms <- ptNms[ptNms %in% names(ok)][ok]
    names(xxx) <- nms

# Extract and tabulate the edge counts.
    allnedge <- sapply(xxx,function(x){nrow(x$edges)})
    tabnedge <- table(allnedge)

# Extract and combine the edge lengths.  Note that there
# will be duplication since many edges are edges of *two* tiles.
    all.lengths <- unname(unlist(lapply(xxx,function(x){x$edgeLengths})))

# Extract the tile areas into a single vector.
    areas <- sapply(xxx,function(x){x$area})

# The lengths of unique edges.
    all.edges <- do.call(rbind,lapply(xxx,function(x){x$edges}))
    edupe     <- duplicated(all.edges)
    ue        <- all.lengths[!edupe]

# Tile perimeters.
  perims <- tilePerim(tl[ok],inclbdry=bndry)
  names(perims$perimeters) <- nms

# Delaunay neighbours of tile centres.
nbrs   <- getNbrs(object,interior=clipp)
nms.ok <- intersect(nms,names(nbrs))
nbrs   <- nbrs[nms.ok]

# Pack up and go home.
    rslt <- list(indivTiles=xxx,allEdgeCounts=allnedge,tabEdgeCounts=tabnedge,
                 allEdgeLengths=all.lengths,Areas=areas,uniqueEdgeLengths=ue,
                 perimeters=perims,nbrs=nbrs)
    class(rslt) <- "tileInfo"
    rslt
}

# Utility file to add ".Last.make.date" to the list of global
# variables, so as to avoid the "no visible binding" problem in
# make.fun() that shows up if .Last.make.date does not exist.

if(getRversion() >= "2.15.1")
    utils::globalVariables("polyclip")

C Output from Public domain Ratfor, version 1.0
      subroutine insrt1(i,j,kj,nadj,madj,ntot,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      nerror = -1
      n = nadj(i,0)
      if(n.eq.0)then
      nadj(i,0) = 1
      nadj(i,1) = j
      return
      endif
      kk = n+1
      if(kk.gt.madj)then
      nerror = 4
      return
      endif
23004 if(kk.gt.kj)then
      nadj(i,kk) = nadj(i,kk-1)
      kk = kk-1
      goto 23004
      endif
23005 continue
      nadj(i,kj) = j
      nadj(i,0) = n+1
      return
      end

subroutine delet1(i,j,nadj,madj,ntot)
! Delete j from the adjacency list of i.
! Called by delet.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj)

n    = nadj(i,0)
do k = 1,n
    if(nadj(i,k)==j) then ! Find j in the list;
                          ! then move everything back one notch.
        do kk = k,n-1
             nadj(i,kk) = nadj(i,kk+1)
        enddo
        nadj(i,n) = -99   ! Changed from the confusing 0 value 25/7/2011.
        nadj(i,0) = n-1
        return
    endif
enddo

end subroutine delet1

C Output from Public domain Ratfor, version 1.03
      subroutine initad(j,nadj,madj,x,y,ntot,eps,ntri,incadj)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      integer tau(3)
      call trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,ntri)
      if(nedge.ne.0)then
      ip = nedge
      i = ip-1
      if(i.eq.0)then
      i = 3
      endif
      call pred(k,tau(i),tau(ip),nadj,madj,ntot)
      call succ(kk,tau(ip),tau(i),nadj,madj,ntot)
      call delet(tau(i),tau(ip),nadj,madj,ntot)
      if(k.eq.kk)then
      call insrt(j,k,nadj,madj,x,y,ntot,eps,incadj)
      endif
      if(incadj.eq.1)then
      return
      endif
      endif
      do23008 i = 1,3 
      call insrt(j,tau(i),nadj,madj,x,y,ntot,eps,incadj)
23008 continue
23009 continue
      return
      end

subroutine addpt(j,nadj,madj,x,y,ntot,eps,nerror)
# Add point j to the triangulation.
# Called by master, dirseg.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical didswp

# Put the new point in, joined to the vertices of its
# enclosing triangle.
call initad(j,nadj,madj,x,y,ntot,eps,nerror)
if(nerror > 0) return

# Look at each `gap', i.e. pair of adjacent segments
# emanating from the new point; they form two sides of a
# quadrilateral; see whether the extant diagonal of this
# quadrilateral should be swapped with its alternative
# (according to the LOP: local optimality principle).
now = nadj(j,1)
nxt = nadj(j,2)
ngap = 0

repeat {
	call swap(j,now,nxt,didswp,nadj,madj,x,y,ntot,eps,nerror)
	if(nerror > 0) return
        n = nadj(j,0)
        if(!didswp) {         # If no swap of diagonals
                now  = nxt    # move to the next gap.
                ngap = ngap+1
        }
        call succ(nxt,j,now,nadj,madj,ntot,nerror)
	if(nerror > 0) return
}
until(ngap==n)

return
end

subroutine delout(delsum,nadj,madj,x,y,ntot,nn)

! Put a summary of the Delaunay triangles with a vertex at point i,
! for i = 1, ..., nn, into the array delsum.  Do this in the original
! order of the points, not the order into which they have been
! bin-sorted.
! Called by master.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension :: delsum(nn,4)

do i = 1,nn
    area = 0.d0 ! Initialize area of polygon consisting of triangles
                ! with a vertex at point i.
! Get the coordinates of the point and the number of
! (real) triangles emanating from it.
    np = nadj(i,0)
    xi = x(i)
    yi = y(i)
    npt = np
    do k = 1,np
        kp = k+1
        if(kp>np) kp = 1
        if(nadj(i,k)<=0 .or. nadj(i,kp)<=0) npt = npt-1
    enddo

! For each point in the adjacency list of point i, find its
! successor, and the area of the triangle determined by these
! three points.
    do j1 = 1,np
        j = nadj(i,j1)
        if(j<=0) cycle
        xj = x(j)
        yj = y(j)
        call succ(k,i,j,nadj,madj,ntot)
        if(k<=0) cycle
        xk = x(k)
        yk = y(k)
        call triar(xi,yi,xj,yj,xk,yk,tmp)
! Downweight the area by 1/3, since each
! triangle eventually appears 3 times over.
        area = area+tmp/3.d0
    enddo
    delsum(i,1) = xi
    delsum(i,2) = yi
    delsum(i,3) = npt
    delsum(i,4) = area
enddo

end subroutine delout

C Output from Public domain Ratfor, version 1.0
      subroutine stoke(x1,y1,x2,y2,rw,area,s1,eps,nerror)
      implicit double precision(a-h,o-z)
      dimension rw(4)
      logical value
      zero = 0.d0
      nerror = -1
      call testeq(x1,x2,eps,value)
      if(value)then
      area = 0.
      s1 = 0.
      return
      endif
      if(x1.lt.x2)then
      xl = x1
      yl = y1
      xr = x2
      yr = y2
      s1 = -1.
      else
      xl = x2
      yl = y2
      xr = x1
      yr = y1
      s1 = 1.
      endif
      xmin = rw(1)
      xmax = rw(2)
      ymin = rw(3)
      ymax = rw(4)
      slope = (yl-yr)/(xl-xr)
      x = max(xl,xmin)
      y = yl+slope*(x-xl)
      xl = x
      yl = y
      x = min(xr,xmax)
      y = yr+slope*(x-xr)
      xr = x
      yr = y
      if(xr.le.xmin.or.xl.ge.xmax)then
      area = 0.
      return
      endif
      ybot = min(yl,yr)
      ytop = max(yl,yr)
      if(ymax.le.ybot)then
      area = (xr-xl)*(ymax-ymin)
      return
      endif
      if(ymin.le.ybot.and.ymax.le.ytop)then
      call testeq(slope,zero,eps,value)
      if(value)then
      w1 = 0.
      w2 = xr-xl
      else
      xit = xl+(ymax-yl)/slope
      w1 = xit-xl
      w2 = xr-xit
      if(slope.lt.0.)then
      tmp = w1
      w1 = w2
      w2 = tmp
      endif
      endif
      area = 0.5*w1*((ybot-ymin)+(ymax-ymin))+w2*(ymax-ymin)
      return
      endif
      if(ybot.le.ymin.and.ymax.le.ytop)then
      xit = xl+(ymax-yl)/slope
      xib = xl+(ymin-yl)/slope
      if(slope.gt.0.)then
      w1 = xit-xib
      w2 = xr-xit
      else
      w1 = xib-xit
      w2 = xit-xl
      endif
      area = 0.5*w1*(ymax-ymin)+w2*(ymax-ymin)
      return
      endif
      if(ymin.le.ybot.and.ytop.le.ymax)then
      area = 0.5*(xr-xl)*((ytop-ymin)+(ybot-ymin))
      return
      endif
      if(ybot.le.ymin.and.ymin.le.ytop)then
      call testeq(slope,zero,eps,value)
      if(value)then
      area = 0.
      return
      endif
      xib = xl+(ymin-yl)/slope
      if(slope.gt.0.)then
      w = xr-xib
      else
      w = xib-xl
      endif
      area = 0.5*w*(ytop-ymin)
      return
      endif
      if(ytop.le.ymin)then
      area = 0.
      return
      endif
      nerror = 8
      return
      end

subroutine cross(x,y,ijk,cprd)
implicit double precision(a-h,o-z)
dimension :: x(3), y(3)
! Calculates a ``normalized'' cross product of the vectors joining
! [x(1),y(1)] to [x(2),y(2)] and to [x(3),y(3)] respectively.
! The normalization consists in dividing by the square of the
! shortest of the three sides of the triangle.  This normalization is
! for the purposes of testing for collinearity; if the result is less
! than epsilon, then the smallest of the sines of the angles is less than
! epsilon.

! Set constants
zero = 0.d0
one  = 1.d0
two  = 2.d0
four = 4.d0

! Adjust the coordinates depending upon which points are ideal,
! and calculate the squared length of the shortest side.

! case 0: No ideal points; no adjustment necessary.
if(ijk==0) then
    smin = -one
    do i = 1,3
        ip = i+1
        if(ip==4) ip = 1
        a = x(ip) - x(i)
        b = y(ip) - y(i)
        s = a*a+b*b
        if(smin < zero .or. s < smin) smin = s
    enddo
endif

! case 1: Only k ideal.
if(ijk==1) then
    x(2) = x(2) - x(1)
    y(2) = y(2) - y(1)
    x(1) = zero
    y(1) = zero
    cn   = sqrt(x(2)**2+y(2)**2)
    x(2) = x(2)/cn
    y(2) = y(2)/cn
    smin  = one
endif

! case 2: Only j ideal.
if(ijk==2) then
    x(3) = x(3) - x(1)
    y(3) = y(3) - y(1)
    x(1) = zero
    y(1) = zero
    cn   = sqrt(x(3)**2+y(3)**2)
    x(3) = x(3)/cn
    y(3) = y(3)/cn
    smin = one
endif

! case 3: Both j and k ideal (i not).
if(ijk==3) then
        x(1) = zero
        y(1) = zero
        smin = two
endif

! case 4: Only i ideal.
if(ijk==4) then
    x(3) = x(3) - x(2)
    y(3) = y(3) - y(2)
    x(2) = zero
    y(2) = zero
    cn   = sqrt(x(3)**2+y(3)**2)
    x(3) = x(3)/cn
    y(3) = y(3)/cn
    smin = one
endif

! case 5: Both i and k ideal (j not).
if(ijk==5) then
    x(2) = zero
    y(2) = zero
    smin = two
endif

! case 6: Both i and j ideal (k not).
if(ijk==6) then
    x(3) = zero
    y(3) = zero
    smin = two
endif

! case 7: All three points ideal; no adjustment necessary.
if(ijk==7) then
    smin = four
endif

a = x(2)-x(1)
b = y(2)-y(1)
c = x(3)-x(1)
d = y(3)-y(1)

cprd = (a*d - b*c)/smin
end subroutine cross

plot.tile.list <- function (x, verbose = FALSE, close = FALSE, pch = 1,
                            fillcol = getCol(x,warn=warn), col.pts=NULL,
                            col.lbls=NULL,border=NULL, showpoints = !labelPts,
                            add = FALSE, asp = 1, clipp=NULL, xlab = "x",
                            ylab = "y", main = "", axes=TRUE, warn=TRUE,
                            labelPts=FALSE,adj=NULL,...) {
# Check for use of the defunct argument name "number".
ccc <- match.call()
i   <- match("number",names(ccc))
if(!is.na(i)) {
    if("labelPts" %in% names(ccc)) {
        whinge <- paste0("Both \"labelPts\" and the defunct argument",
                         " \"number\" have been\n  specified.  Do not use",
                         " the defunct argument \"number\".  Use\n",
                         "  \"labelPts\" only.\n")
        stop(whinge)
    }
    whinge <- paste0("The argument name \"number\" is defunct. Please",
                     " use \"labelPts\"\n  instead.\n")
    warning(whinge)
    names(ccc)[i] <- "labelPts"
    return(eval(ccc))
}

# Carry on.
    object <- x
    if (!inherits(object, "tile.list")) 
        stop("Argument \"object\" is not of class tile.list.\n")
    clip  <- !is.null(clipp)
    if(clip) {
        if(!is.null(attr(object,"clipp"))) {
            whinge <- paste0("Argument \"x\" is already clipped.  Re-clip it\n",
                             "  if you want a different clipping polygon.\n")
            stop(whinge)
            if(!requireNamespace("polyclip",quietly=TRUE)) {
                stop("Cannot clip the tiles; package \"polyclip\" not available.\n")
            }
        }
    }
    n     <- length(object)
    rw    <- attr(object, "rw")
    rx    <- rw[1:2]
    ry    <- rw[3:4]
    x.pts <- unlist(lapply(object, function(w) {
        w$pt[1]
    }))
    y.pts <- unlist(lapply(object, function(w) {
        w$pt[2]
    }))
    if (!add) 
        plot(0, 0, type = "n", asp = asp, xlim = rx, ylim = ry, 
            xlab = xlab, ylab = ylab, main = main, axes=axes)
    fillcol <- apply(col2rgb(fillcol, TRUE), 2, function(x) {
        do.call(rgb, as.list(x/255))
    })
    fillcol <- rep(fillcol, length = length(object))
    hexbla <- do.call(rgb, as.list(col2rgb("black", TRUE)/255))
    hexwhi <- do.call(rgb, as.list(col2rgb("white", TRUE)/255))
    if(is.null(col.pts)){
        col.pts <- ifelse(fillcol == hexbla, hexwhi, hexbla)
    } else {
        col.pts <- apply(col2rgb(col.pts, TRUE), 2, function(x) {
            do.call(rgb, as.list(x/255))
        })
        col.pts <- rep(col.pts, length = length(object))
    }
    if(is.null(col.lbls)){
        col.lbls <- ifelse(fillcol == hexbla, hexwhi, hexbla)
    } else {
        col.lbls <- apply(col2rgb(col.lbls, TRUE), 2, function(x) {
            do.call(rgb, as.list(x/255))
        })
        col.lbls <- rep(col.lbls, length = length(object))
    }
    if(is.null(border)) {
        border <- if(all(fillcol == hexbla)) hexwhi else hexbla
    } else if(length(border) > 1) border <- border[1]
    lnwid <- if(all(fillcol == hexbla)) 2 else 1
    ptNms <- names(x)
    Adj <- adj
    if(is.null(Adj)) Adj <- if(showpoints) -1 else 0
    pch <- rep(pch,n)
    pgons <- vector("list",n)
    icol <- 0
    for(i in 1:n) {
        pgon <- if(clip) doClip(object[[i]],clipp,rw) else object[[i]]
        pgons[[i]] <- pgon
        if(is.null(pgon)) next
        icol <- icol+1
        if(is.null(attr(pgon,"ncomp"))) attr(pgon,"ncomp") <- 1
        if(attr(pgon,"ncomp") > 1) {
            pgon <- pgon$tileParts
        } else pgon <- list(pgon)
        for(ii in seq(along=pgon)){
            ptmp <- pgon[[ii]]
            inner <- !any(ptmp$bp)
            polygon(ptmp,col=fillcol[icol],border=NA)
            if (close | inner) { 
                polygon(ptmp,col = NA, border = border, lwd = lnwid)
            } else {
                x <- ptmp$x
                y <- ptmp$y
                ni <- length(x)
                for (j in 1:ni) {
                    jnext <- if (j < ni) j + 1 else 1
                    do.it <- mid.in(x[c(j, jnext)], y[c(j, jnext)], rx, ry)
                    if (do.it) 
                        segments(x[j], y[j], x[jnext], y[jnext],
                                 col = border, lwd = lnwid)
                }
            }
         }
         if(verbose) {
             if(showpoints) points(object[[i]]$pt[1], object[[i]]$pt[2],
                                   pch = pch[i], col = col.pts[i],...)
             if(labelPts) text(object[[i]]$pt[1], object[[i]]$pt[2],
                             labels=ptNms[i], col = col.lbls[i],adj=Adj,...)
             if(i < n) readline(paste("i = ",i,"; Go? ",sep=""))
             if(i == n) cat("i = ",i,"\n",sep="")
         }
    }
    ok <- !sapply(pgons,is.null)
    if(showpoints & !verbose)
        points(x.pts[ok], y.pts[ok], pch = pch[ok], col = col.pts[ok],...)
    if (labelPts & !verbose) 
        text(x.pts[ok], y.pts[ok], labels = ptNms[ok], col = col.lbls[ok],
             adj=Adj,...)
    pgons <- pgons[ok]
    pgons <- if(length(pgons)) pgons else NULL
    invisible(pgons)
}

C Output from Public domain Ratfor, version 1.0
      subroutine testeq(a,b,eps,value)
      implicit double precision(a-h,o-z)
      logical value
      one = 1.d0
      ten = 1.d10
      if(abs(b).le.eps)then
      if(abs(a).le.eps)then
      value = .true.
      else
      value = .false.
      endif
      return
      endif
      if(abs(a).gt.ten*abs(b).or.abs(a).lt.one*abs(b))then
      value = .false.
      return
      endif
      c = a/b
      if(abs(c-1.d0).le.eps)then
      value = .true.
      else
      value = .false.
      endif
      return
      end

insidePoly <- function(x,y,pgon,sanityCheck=FALSE,
                       tolerance=sqrt(.Machine$double.eps)) {
# This code is taken from the spatstat.utils function
# inside.xypolygon() (the "interpreted" method), with minor
# modifications, particularly in respect of the "sanity check".
#
# Also, in respect of determing boundary points, arrangements have
# been made to allow conversion of` "==" to almost.equal() ("%~%";
# see below).  This permits better determination of boundary points.

# Check that pgon is of the appropriate form.
if(inherits(pgon,"list")) {
    ok <- all(c("x","y") %in% names(pgon))
    if(!ok) {
        stop("Argument \"pgon\" must be a list with components \"x\" and \"y\".\n")
    }
    xp <- pgon$x
    yp <- pgon$y
    ok1 <- is.numeric(xp)
    ok2 <- is.numeric(yp)
    ok3 <- length(xp) == length(yp)
    if(!(ok1 & ok2 & ok3)) {
        stop("The components of \"pgon\" are not of the correct form.\n")
    }
} else {
    stop("Argument \"pgon\" must be a list determining a polygon.\n")
}

if(tolerance > 0) {
    almost.equal <- function(x, y)  {
        abs(x - y) < tolerance
    }
    assign("tolerance",tolerance,envir=environment(almost.equal))
    `%~%`  <- function(x,y) almost.equal(x,y)
} else {
    `%~%` <- `==`
}

full.npts <- npts <- length(x)
nedges <- length(xp)   # sic
vx <- x%in%xp
vy <- y%in%yp
vv <- vx & vy
retain <- !vv

# Remove vertices from subsequent consideration; replace them later
if(vertices.present <- !all(retain)) {
  x <- x[retain]
  y <- y[retain]
  npts <- sum(retain)
}

score <- numeric(npts)
on.boundary <- rep.int(FALSE, npts)

if(anyretain <- any(retain)) {
    for(i in 1:nedges) {
        x0 <- xp[i]
        y0 <- yp[i]
        x1 <- if(i == nedges) xp[1] else xp[i+1]
        y1 <- if(i == nedges) yp[1] else yp[i+1]
        dx <- x1 - x0
        dy <- y1 - y0
        if(dx < 0) {
# upper edge
            xcriterion <- (x - x0) * (x - x1)
            consider <- (xcriterion <= 0)
            if(any(consider)) {
                ycriterion <- y[consider] * dx - x[consider] * dy +  x0 * dy - y0 * dx
# closed inequality
                contrib <- (ycriterion >= 0) *
                   ifelse(xcriterion[consider] %~% 0, 1/2, 1)
# positive edge sign
                score[consider] <- score[consider] + contrib
# detect whether any point lies on this segment
                on.boundary[consider] <- on.boundary[consider] | (ycriterion %~% 0)
            }
        } else if(dx > 0) {
# lower edge
            xcriterion <- (x - x0) * (x - x1)
            consider <- (xcriterion <= 0)
            if(any(consider)) {
                ycriterion <- y[consider] * dx - x[consider] * dy + x0 * dy - y0 * dx
# open inequality
                contrib <- (ycriterion < 0) * ifelse(xcriterion[consider] %~% 0, 1/2, 1)
# negative edge sign
                score[consider] <- score[consider] - contrib
# detect whether any point lies on this segment
                on.boundary[consider] <- on.boundary[consider] | (ycriterion %~% 0)
            }
        } else {
# vertical edge
            consider <- (x %~% x0)
            if(any(consider)) {
# zero score
# detect whether any point lies on this segment
                yconsider <- y[consider]
                ycriterion <- (yconsider - y0) * (yconsider - y1)
                on.boundary[consider] <- on.boundary[consider] | (ycriterion <= 0)
            }
       }
    }
}

# replace any polygon vertices that were temporarily removed
if(vertices.present) {
  full.score <- numeric(full.npts)
  full.on.boundary <- rep.int(FALSE, full.npts)
  if(anyretain) {
    full.score[retain] <- score
    full.on.boundary[retain] <- on.boundary
  }
  full.score[vv] <- 1
  full.on.boundary[vv] <- TRUE
  score       <- full.score
  on.boundary <- full.on.boundary
  npts        <- full.npts
  
}
  
# any point recognised as lying on the boundary gets score 1.
score[on.boundary] <- 1

# Sanity Clause.
if(sanityCheck) {
    if(!all((score == 0) | (score == 1)))
        warning("Some \"scores\" are neither equal to 0 nor to 1.\n")
}

# Aw' done!
score <- as.logical(score)
attr(score,"on.boundary") <- on.boundary
score
}

divchain.deldir <- function (x,...) {
#
    z <- x$summary$z 
    if(is.null(z)) {
        xc <- deparse(substitute(x))
        whinge <- paste("The class \"deldir\" object",xc,"was created without\n",
                        "a tag argument \"z\" being supplied.\n")
        stop(whinge)
    }
    z    <- factor(z)
    ddd  <- x$dirsgs
    ddd  <- ddd[z[ddd$ind1] != z[ddd$ind2],]
    id1  <- as.matrix(ddd[,c("ind1","ind2","thirdv1")])
    id2  <- as.matrix(ddd[,c("ind1","ind2","thirdv2")])
    id1  <- t(apply(id1,1,function(x){if(x[3] > 0) sort(x) else c(sort(x[1:2]),x[3])}))
    id2  <- t(apply(id2,1,function(x){if(x[3] > 0) sort(x) else c(sort(x[1:2]),x[3])}))
    rslt <- cbind(ddd[,1:4],id1,id2)
    names(rslt) <- c("x0","y0","x1","y1","v01","v02","v03","v11","v12","v13")
    class(rslt) <- c("divchain","data.frame")
    attr(rslt,"rw") <- x$rw
    rslt
}

subroutine binsrt(x,y,rw,nn,ind,rind,tx,ty,ilst)
! Sort the data points into bins.
! Called by master.

implicit double precision(a-h,o-z)
dimension :: x(nn), y(nn), tx(nn), ty(nn)
integer :: rind(nn)
dimension :: ind(nn), ilst(nn)
dimension :: rw(4)
dimension :: ndi(1)

! Set dummy integer for call to intpr(...).
ndi(1) = 0

kdiv   = int(1+dble(nn)**0.25) ! Round high.
xkdiv  = dble(kdiv)

! Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

w = xmax-xmin
h = ymax-ymin

! Number of bins is to be approx. sqrt(nn); thus number of subdivisions
! on each side of rectangle is approx. nn**(1/4).
dw  = w/xkdiv
dh  = h/xkdiv

! The width of each bin is dw; the height is dh.  We shall move across
! the rectangle from left to right, then up, then back from right to
! left, then up, ....  Note that kx counts the divisions from the left,
! ky counts the divisions from the bottom; kx is incremented by ink, which
! is +/- 1 and switches sign when ky is incremented; ky is always
! incremented by 1.
kx   = 1
ky   = 1
ink  = 1
k    = 0
do i = 1,nn     ! Keeps a list of those points already added
    ilst(i) = 0 ! to the new list.
enddo
do
    do i = 1,nn
        if(ilst(i) .ne. 1) then
! If the i-th point is in the current bin, add it to the list.
            xt = x(i)
            yt = y(i)
            ix = int(1+(xt-xmin)/dw)
            if(ix>kdiv) ix = kdiv
            jy = int(1+(yt-ymin)/dh)
            if(jy>kdiv) jy = kdiv
            if(ix==kx .and. jy==ky) then
                k       = k+1
                ind(i)  = k   ! Index i is the pos'n. of (x,y) in the
                rind(k) = i   ! old list; k is its pos'n. in the new one.
                tx(k)   = xt
                ty(k)   = yt
                ilst(i) = 1   ! Cross the i-th point off the old list.
            endif
        endif
    enddo
! Move to the next bin.
    kc = kx+ink
    if((1<=kc) .and. (kc<=kdiv)) then
        kx = kc
    else
        ky  = ky+1
        ink = -ink
    endif
    if(ky > kdiv) exit
enddo
! Check that all points from old list have been added to the new,
! with no spurious additions.
if(k .ne. nn) then
    call intpr("Mismatch between number of points",-1,ndi,0)
    call intpr("and number of sorted points.",-1,ndi,0)
    call rexit("Bailing out of binsrt.")
endif

! Copy the new sorted vectors back on top of the old ones.
do i = 1,nn
    x(i)   = tx(i)
    y(i)   = ty(i)
enddo

end  subroutine binsrt

cvt <- function(object,stopcrit=c("change","maxit"),tol=NULL,
                maxit=100,verbose=FALSE) {
#
# Centroidal Voronoi Tessellation (by Lloyd's algorithm).
#
if(inherits(object,"deldir")) {
    l <- tile.list(object)
    rw <- object$rw
} else if(inherits(object,"tile.list")) {
    l <- object
    rw <- attr(object,"rw")
} else {
    whinge <- paste0("Argument \"object\" must be of class either\n",
                     "  \"deldir\" or \"tile.list\".\n")
    stop(whinge)
}
stopcrit <- match.arg(stopcrit)
if(stopcrit=="change") {
    if(is.null(tol)) tol <- sqrt(.Machine$double.eps)
}
g <- tile.centroids(l)
K <- 0
repeat {
    K <- K+1
    pts <- lapply(l,function(x){x$pt})
    pts <- as.data.frame(matrix(unlist(pts),byrow=TRUE,ncol=2))
    names(pts) <- c("x","y")
    dv2 <- (pts$x - g$x)^2 + (pts$y - g$y)^2
    dm  <- sqrt(max(dv2))
    if(verbose & K%%10 == 0) {
        cat("iteration:",K,"change:",dm,"\n")
    }
    if(stopcrit=="change") {
        if(dm < tol) break
    } else {
        if(K >= maxit) break
    }
    d <- try(deldir(g,rw=rw,round=FALSE))
    if(inherits(d,"try-error")) browser()
    l <- tile.list(d)
    g <- tile.centroids(l)
}
if(verbose & K%%10 != 0) cat("\n")
list(centroids=g,tiles=l)
}

subroutine insrt1(i,j,kj,nadj,madj,ntot,incAdj)

! Insert j into the adjacency list of i.
! Called by insrt.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj)

! Initialise incAdj.
incAdj = 0

! Variable  kj is the index which j ***will***
! have when it is inserted into the adjacency list of i in
! the appropriate position.

! If the adjacency list of i had no points just stick j into the list.
n = nadj(i,0)
if(n==0) then
    nadj(i,0) = 1
    nadj(i,1) = j
    return
endif

! If the adjacency list had some points, move everything ahead of the
! kj-th place one place forward, and put j in position kj.
kk = n+1

if(kk>madj) then ! Watch out for over-writing!!!
    incAdj = 1
    return
endif

do
    nadj(i,kk) = nadj(i,kk-1)
    kk = kk-1
    if(kk <= kj) exit
enddo

nadj(i,kj) = j
nadj(i,0)  = n+1

end subroutine insrt1

C Output from Public domain Ratfor, version 1.0
      subroutine pred(kpr,i,j,nadj,madj,ntot,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      nerror = -1
      n = nadj(i,0)
      if(n.eq.0)then
      nerror = 5
      return
      endif
      do23002 k = 1,n 
      if(j.eq.nadj(i,k))then
      km = k-1
      if(km.lt.1)then
      km = n
      endif
      kpr = nadj(i,km)
      return
      endif
23002 continue
23003 continue
      nerror = 6
      return
      end

plot.deldir <- local({

fixColours <- function(cmpnt_col) {
    cmpnt_nms <- c("tri","tess","points","labels","rect")
    if(is.null(cmpnt_col)) {
        cmpnt_col <- rep(1,5)
        names(cmpnt_col) <- cmpnt_nms
    } else {
        cmpnt_col <- unlist(cmpnt_col)
        if(length(cmpnt_col) > 5) cmpnt_col <- cmpnt_col[1:5]
        if(!is.null(names(cmpnt_col))) {
            if(!all(names(cmpnt_col) %in% cmpnt_nms)) {
                stop("Argument \"cmpnt_col\" has incorrect names.\n")
            }
            ctmp <- rep(NA,5)
            names(ctmp) <- cmpnt_nms
            ctmp[names(cmpnt_col)] <- cmpnt_col
            cmpnt_col <- ctmp
        } else {
            cmpnt_col <- rep(cmpnt_col,length.out=5)
            names(cmpnt_col) <- cmpnt_nms
        }
        if(any(is.na(cmpnt_col))) {
            mde <- mode(cmpnt_col)
            switch(EXPR=mde,
               character={cmpnt_col[is.na(cmpnt_col)] <- palette()[1]},
               numeric={cmpnt_col[is.na(cmpnt_col)] <- 1},
               stop("Argument \"cmpnt_col\" is of an inappropriate mode.\n")
            )
        }
    }
    cmpnt_col
}

fixLines <- function(cmpnt_lty) {
    lty_nms <- c("tri","tess")
    if(is.null(cmpnt_lty)) {
        cmpnt_lty <- 1:2
        names(cmpnt_lty) <- lty_nms
    } else {
        cmpnt_lty <- unlist(cmpnt_lty)
        if(length(cmpnt_lty) > 2) cmpnt_lty <- cmpnt_lty[1:2]
        if(mode(cmpnt_lty) == "numeric") {
            if(!all(cmpnt_lty %in% 1:6)) {
                whinge <- paste("Numeric values of \"cmpnt_lty\" must",
                                "be integers between 1 and 6.\n")
                stop(whinge)
            }
        } else if(mode(cmpnt_lty) == "character") {
            linetypes <- c("solid","dashed","dotted","dotdash",
                           "longdash","twodash") 
            if(!all(cmpnt_lty %in% linetypes)) {
                whinge <- paste0("Text string values of \"cmpnt_lty\" must ",
                                "be one of the strings\n",paste(linetypes,collapse=", "),
                                ".\n")
                stop(whinge)
            }
        } else {
            whinge <- paste0("Argument \"cmpnt_lty\" must be of mode either",
                            " \"numeric\" or \"character\".\n")
            stop(whinge)
        }
        if(!is.null(names(cmpnt_lty))) {
            if(!all(names(cmpnt_lty) %in% lty_nms)) {
                stop("Argument \"cmpnt_lty\" has incorrect names.\n")
            }
            ltmp <- rep(NA,2)
            names(ltmp) <- lty_nms
            ltmp[names(cmpnt_lty)] <- cmpnt_lty
            cmpnt_lty <- ltmp
            dflt <- if(mode(cmpnt_lty) == "character") "solid" else 1
            if(any(is.na(cmpnt_lty))) {
                cmpnt_lty[is.na(cmpnt_lty)] <- dflt
            }
        } else {
            cmpnt_lty <- rep(cmpnt_lty,length.out=2)
            names(cmpnt_lty) <- lty_nms
        }
    }
    cmpnt_lty
}

function(x,add=FALSE,wlines=c('both','triang','tess'),
                        showpoints=TRUE,labelPts=FALSE,cex=1,lex=1,
                        cmpnt_col=NULL,cmpnt_lty=NULL,pch=1,
                        xlim=NULL,ylim=NULL,axes=FALSE,
                        xlab=if(axes) 'x' else '',
                        ylab=if(axes) 'y' else'',
                        showrect=FALSE,asp=1,...)
{
#
# Function plot.deldir to produce a plot of the Delaunay triangulation
# and Dirichlet tesselation of a point set, as produced by the
# function deldir().
#

# Check for use of the defunct argument name "number".
ccc <- match.call()
i   <- match("number",names(ccc))
if(!is.na(i)) {
    if("labelPts" %in% names(ccc)) {
        whinge <- paste0("Both \"labelPts\" and the defunct argument",
                         " \"number\" have been\n  specified.  Do not use",
                         " the defunct argument \"number\".  Use\n",
                         "  \"labelPts\" only.\n")
        stop(whinge)
    }
    whinge <- paste0("The argument name \"number\" is defunct. Please",
                     " use \"labelPts\"\n  instead.\n")
    warning(whinge)
    names(ccc)[i] <- "labelPts"
    return(eval(ccc))
}

# Carry on.

# Check that x is of the appropriate class.
if(!inherits(x, "deldir")) 
        stop("Argument \"x\" is not of class deldir.\n")

wlines    <- match.arg(wlines)
cmpnt_col <- fixColours(cmpnt_col)
cmpnt_lty <- fixLines(cmpnt_lty)

plot.del <- switch(wlines,both=TRUE,triang=TRUE,tess=FALSE)
plot.dir <- switch(wlines,both=TRUE,triang=FALSE,tess=TRUE)

delsgs <- x$delsgs
dirsgs <- x$dirsgs
n      <- x$n.data
rw     <- x$rw

if(plot.del) {
    x1<-delsgs[,1]
    y1<-delsgs[,2]
    x2<-delsgs[,3]
    y2<-delsgs[,4]
} else {
    x1 <- y1 <- x2 <- y2 <- numeric(0)
}

if(plot.dir) {
    u1<-dirsgs[,1]
    v1<-dirsgs[,2]
    u2<-dirsgs[,3]
    v2<-dirsgs[,4]
} else {
    u1 <- v1 <- u2 <- v2 <- numeric(0)
}

X<-x$summary[,"x"]
Y<-x$summary[,"y"]

if(!add) {
    if(is.null(xlim)) xlim <- rw[1:2]
    if(is.null(ylim)) ylim <- rw[3:4]
        x.all <- c(x1,x2,u1,u2,X)
        y.all <- c(y1,y2,v1,v2,Y)
        pty <- list(...)$pty
        if(!is.null(pty)) {
            OP <- par(pty=pty)
            on.exit(par(OP))
        }
    plot(x.all,y.all,type='n',xlim=xlim,ylim=ylim,
         xlab=xlab,ylab=ylab,axes=axes,asp=asp)
}

if(plot.del) {
    dotargs <- list(...)
    if(is.null(dotargs$col)) dotargs$col <- cmpnt_col[1]
    if(is.null(dotargs$lty)) dotargs$lty <- cmpnt_lty[1]
    arhgs <- c(list(x1,y1,x2,y2),dotargs)
    do.call(segments,arhgs)
}
if(plot.dir) {
    dotargs <- list(...)
    if(is.null(dotargs$col)) dotargs$col <- cmpnt_col[2]
    if(is.null(dotargs$lty)) dotargs$lty <- cmpnt_lty[2]
    arhgs <- c(list(u1,v1,u2,v2),dotargs)
    do.call(segments,arhgs)
}
if(showpoints) {
    dotargs <- list(...)
    dotargs$pch <- NULL
    dotargs$cex <- NULL
    do.call(points,c(list(x=X,y=Y,pch=pch,col=cmpnt_col[3],cex=cex),dotargs))
}
if(labelPts) {
    xoff <- 0.02*diff(range(X))
    yoff <- 0.02*diff(range(Y))
    dotargs <- list(...)
    dotargs$ces <- NULL
    dotargs$col <- NULL
    lbls <- x$summary[["id"]]
    if(is.null(lbls)) lbls <- 1:nrow(x$summary)
    do.call(text,c(list(x=X+xoff,y=Y+yoff,labels=lbls,cex=lex,
            col=cmpnt_col[4]),dotargs))
}
if(showrect) do.call(rect,c(as.list(x$rw)[c(1,3,2,4)],list(border=cmpnt_col[5])))
invisible()
}
})

C Output from Public domain Ratfor, version 1.03
      subroutine delseg(delsgs,ndel,nadj,madj,npd,x,y,ntot,incseg)
      implicit double precision(a-h,o-z)
      logical value
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      dimension delsgs(6,ndel)
      incseg = 0
      npd = ntot-4
      kseg = 0
      do23000 i = 2,npd 
      do23002 j = 1,i-1 
      call adjchk(i,j,value,nadj,madj,ntot)
      if(value)then
      kseg = kseg+1
      if(kseg .gt. ndel)then
      incseg = 1
      return
      endif
      delsgs(1,kseg) = x(i)
      delsgs(2,kseg) = y(i)
      delsgs(3,kseg) = x(j)
      delsgs(4,kseg) = y(j)
      delsgs(5,kseg) = i
      delsgs(6,kseg) = j
      endif
23002 continue
23003 continue
23000 continue
23001 continue
      ndel = kseg
      return
      end

subroutine qtest1(h,i,j,k,x,y,ntot,eps,shdswp,nerror)

# The Lee-Schacter test for the LOP (all points are real,
# i.e. non-ideal).  If the LOP is ***not*** satisfied (i.e. if
# vertex j is inside the circumcircle of vertices h, i, and k) then the
# diagonals should be swapped, i.e. shdswp ("should-swap") is true.
# Called by qtest.

implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot)
integer h
logical shdswp

# The vertices of the quadrilateral are labelled
# h, i, j, k in the anticlockwise direction, h
# being the point of central interest.

# Make sure the quadrilateral is convex, so that
# it makes sense to swap the diagonal.
# call acchk(i,j,k,shdswp,x,y,ntot,eps)
# if(!shdswp) return
#
# 23 July 2011:
# The foregoing test is a load of dingos' kidneys.  (1) It is
# unnecessary, and (2) it is wrong!  (1) If the LOP is not satisfied
# (the only circumstance under which there should be a swap) then the
# quadrilateral ***must*** be convex, and so swapping can sensibly
# take place.  (2) The vertices i, j, k in will ***always*** be in
# anticlockwise order, since the vertices h, i, j, k of the quadrilateral
# are in such order and i is connected to k, whence j can't be inside
# the triangle ihk.  So the test does nothing.  But then it didn't need
# to do anything.

# Get the coordinates of vertices h and j.
xh = x(h)
yh = y(h)
xj = x(j)
yj = y(j)

# Find the centre of the circumcircle of vertices h, i, k.
call circen(h,i,k,x0,y0,x,y,ntot,eps,shdswp,nerror)
if(nerror>0) return
if(shdswp) return # The points h, i, and k are colinear, so
                  # the circumcircle has `infinite radius', so
                  # (xj,yj) is definitely inside.

# Check whether (xj,yj) is inside the circle of centre
# (x0,y0) and radius r = dist[(x0,y0),(xh,yh)]

a  = x0-xh
b  = y0-yh
r2 = a*a+b*b
a  = x0-xj
b  = y0-yj
ch = a*a + b*b
if(ch<r2) shdswp = .true.
else shdswp = .false.

return
end

triMat <- function(object){
    tl <- triang.list(object)
    vl <- lapply(tl,function(x){x[,"ptNum"]})
    vl <- lapply(vl,sort)
    tm <- matrix(unlist(vl),byrow=TRUE,ncol=3)
    return(tm[order(tm[,1]),])
}

C Output from Public domain Ratfor, version 1.0
      subroutine triar(x0,y0,x1,y1,x2,y2,area)
      implicit double precision(a-h,o-z)
      half = 0.5d0
      area = half*((x1-x0)*(y2-y0)-(x2-x0)*(y1-y0))
      return
      end

subroutine intri(x,y,u,v,n,okay)
!
! Test whether any of the points (u(i),v(i)) are inside the triangle
! whose vertices are specified by the vectors x and y.
! Called by .Fortran() from triang.list.R.
!

implicit double precision(a-h,o-z)
dimension :: x(3), y(3), u(n), v(n)
integer :: okay
logical inside

zero = 0.d0

! Check on order (clockwise or anticlockwise).
s = 1.d0
a = x(2) - x(1)
b = y(2) - y(1)
c = x(3) - x(1)
d = y(3) - y(1)
cp = a*d - b*c
if(cp < 0) s = -s
do i = 1,n
    inside = .true.
    do j = 1,3
        jp = j+1
        if(jp==4) jp = 1 ! Take addition modulo 3.
        a  = x(jp) - x(j)
        b  = y(jp) - y(j)
        c  = u(i)  - x(j)
        d  = v(i)  - y(j)
        cp = s*(a*d - b*c)
        if(cp <= zero) then
            inside = .false.
            exit
        endif
    enddo
    if(inside) then
        okay = 0
        return
    endif
enddo
okay = 1
end subroutine intri

C Output from Public domain Ratfor, version 1.0
      subroutine dirseg(dirsgs,ndir,nadj,madj,npd,x,y,ntot,rw,eps,ind,ne
     *rror)
      implicit double precision(a-h,o-z)
      logical collin, adjace, intfnd, bptab, bptcd, goferit, rwu
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      dimension dirsgs(8,ndir), rw(4), ind(npd)
      nerror = -1
      xmin = rw(1)
      xmax = rw(2)
      ymin = rw(3)
      ymax = rw(4)
      a = xmax-xmin
      b = ymax-ymin
      c = sqrt(a*a+b*b)
      npd = ntot-4
      nstt = npd+1
      i = nstt
      x(i) = xmin-c
      y(i) = ymin-c
      i = i+1
      x(i) = xmax+c
      y(i) = ymin-c
      i = i+1
      x(i) = xmax+c
      y(i) = ymax+c
      i = i+1
      x(i) = xmin-c
      y(i) = ymax+c
      do23000 j = nstt,ntot 
      call addpt(j,nadj,madj,x,y,ntot,eps,nerror)
      if(nerror .gt. 0)then
      return
      endif
23000 continue
23001 continue
      kseg = 0
      do23004 i1 = 2,npd 
      i = ind(i1)
      do23006 j1 = 1,i1-1 
      j = ind(j1)
      call adjchk(i,j,adjace,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(adjace)then
      call pred(k,i,j,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call circen(i,k,j,a,b,x,y,ntot,eps,collin,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(collin)then
      nerror = 12
      return
      endif
      call succ(l,i,j,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call circen(i,j,l,c,d,x,y,ntot,eps,collin,nerror)
      if(nerror .gt. 0)then
      return
      endif
      if(collin)then
      nerror = 12
      return
      endif
      xi = x(i)
      xj = x(j)
      yi = y(i)
      yj = y(j)
      if(yi.ne.yj)then
      slope = (xi - xj)/(yj - yi)
      rwu = .true.
      else
      slope = 0.d0
      rwu = .false.
      endif
      call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab)
      if(.not.intfnd)then
      nerror = 16
      return
      endif
      call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd)
      if(.not.intfnd)then
      nerror = 16
      return
      endif
      goferit = .false.
      if(bptab .and. bptcd)then
      xm = 0.5*(ai+ci)
      ym = 0.5*(bi+di)
      if(xmin.lt.xm.and.xm.lt.xmax.and.ymin.lt.ym.and.ym.lt.ymax)then
      goferit = .true.
      endif
      endif
      if((.not.bptab).or.(.not.bptcd))then
      goferit = .true.
      endif
      if(goferit)then
      kseg = kseg + 1
      if(kseg .gt. ndir)then
      nerror = 15
      return
      endif
      dirsgs(1,kseg) = ai
      dirsgs(2,kseg) = bi
      dirsgs(3,kseg) = ci
      dirsgs(4,kseg) = di
      dirsgs(5,kseg) = i1
      dirsgs(6,kseg) = j1
      if(bptab)then
      dirsgs(7,kseg) = 1.d0
      else
      dirsgs(7,kseg) = 0.d0
      endif
      if(bptcd)then
      dirsgs(8,kseg) = 1.d0
      else
      dirsgs(8,kseg) = 0.d0
      endif
      endif
      endif
23006 continue
23007 continue
23004 continue
23005 continue
      ndir = kseg
      return
      end

tilePerim0 <- function (object,inclbdry=TRUE) {
    ncomp <- attr(object,"ncomp")
    if(is.null(ncomp)) ncomp <- 1
    tobj <- if(ncomp==1) list(object) else object$tileParts
    peri <- numeric(ncomp)
    for(i in 1:ncomp) {
        tmp <- tobj[[i]]
        x <- tmp[["x"]]
        y <- tmp[["y"]]
        xx <- c(x,x[1])
        yy <- c(y,y[1])
        if(inclbdry) {
            ok <- rep(TRUE,length(x))
        } else {
            bp1 <- tmp[["bp"]]
            bp2 <- c(bp1,bp1[1])
            bpm <- cbind(bp1,bp2[-1])
            ok  <- !apply(bpm,1,all)
        }
        peri[i] <- sum(sqrt(((xx[-1] - x)[ok])^2 + ((yy[-1] - y)[ok])^2))
    }
    perTot <- sum(peri)
    attr(perTot,"perComps") <- peri
    perTot
}

C Output from Public domain Ratfor, version 1.0
      subroutine adjchk(i,j,adj,nadj,madj,ntot,nerror)
      dimension nadj(-3:ntot,0:madj)
      logical adj
      nerror = -1
      adj = .false.
      ni = nadj(i,0)
      if(ni.gt.0)then
      do23002 k = 1,ni 
      if(j.eq.nadj(i,k))then
      adj = .true.
      goto 23003
      endif
23002 continue
23003 continue
      endif
      nj = nadj(j,0)
      if(nj.gt.0)then
      do23008 k = 1,nj 
      if(i.eq.nadj(j,k))then
      if(adj)then
      return
      else
      nerror = 1
      return
      endif
      endif
23008 continue
23009 continue
      endif
      if(adj)then
      nerror = 1
      return
      endif
      return
      end

subroutine  succ(ksc,i,j,nadj,madj,ntot)

! Find the successor of j in the adjacency list of i.
! Called by addpt, initad, trifnd, swap, delout, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj)
dimension :: ndi(1)

! Set dummy integer for call to intpr(...).
ndi(1) = 0

n = nadj(i,0)

! If the adjacency list of i is empty, then clearly j has no successor
! in this adjacency list.  Something's wrong; stop.
if(n==0) then
    call intpr("Adjacency list of i is empty, and so cannot contain j.",-1,ndi,0)
    call rexit("Bailing out of succ.")
endif

! The adjacency list of i is non-empty; search through it until j is found;
! add 1 to the location of j, and find the contents of this new location.
do k = 1,n
    if(j==nadj(i,k)) then
        kp = k+1
        if(kp>n) kp = 1         ! Take kp modulo n. (The adjacency list
        ksc = nadj(i,kp)        ! is circular.)
        return
    endif
enddo

! The adjacency list doesn't contain j.  Something's wrong.
ndi(1) = i
call intpr("i =",-1,ndi,1)
ndi(1) = j
call intpr("j =",-1,ndi,1)
call intpr("Adjacency list of i does not contain j.",-1,ndi,0)
call rexit("Bailing out of succ.")
end subroutine succ

findNewInOld <- function(xnew,xold,ynew,yold,tolerance=sqrt(.Machine$double.eps)) {
#
# Check that x and y lengths match.
if(length(xnew) != length(ynew) | length(xold) != length(yold))
    stop("Mismatch in lengths of x and y sequences.\n")

# If either the old or new sequence of points is empty, there
# is nothing to find.
if(!(length(xnew) & length(xold))) return(numeric(0))

# Set holder for found indices. 
ind  <- numeric(length(xnew))

# Scale up tolerance if the "old" points are large in modulus.
sfac <- max(1,mean(sqrt(xold^2+yold^2)))
tol  <- tolerance*sfac

# Search for matches.
for(i in seq_along(xnew)) {
    for(j in seq_along(xold)) {
        xok <- abs(xnew[i] - xold[j]) < tol
        yok <- abs(ynew[i] - yold[j]) < tol
        if(xok & yok) {
            ind[i] <- j
            break
        }
    }
}
ind
}

subroutine insrt(i,j,nadj,madj,x,y,ntot,eps,incAdj)
! Insert i and j into each other's adjacency list.
! Called by master, initad, swap.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical :: adj

! Check whether i and j are in each other's adjacency lists.
call adjchk(i,j,adj,nadj,madj,ntot)
if(adj) return

! If not, find where in each list they should respectively be.
call locn(i,j,kj,nadj,madj,x,y,ntot,eps)
call locn(j,i,ki,nadj,madj,x,y,ntot,eps)

! Put them in each other's lists in the appropriate position.
call insrt1(i,j,kj,nadj,madj,ntot,incAdj)
if(incAdj==1) return
call insrt1(j,i,ki,nadj,madj,ntot,incAdj)
if(incAdj==1) return ! This seems unnecessary; check on this.

end subroutine insrt

C Output from Public domain Ratfor, version 1.0
      subroutine dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bpt)
      implicit double precision(a-h,o-z)
      dimension rw(4)
      logical intfnd, bpt, rwu
      intfnd = .true.
      bpt = .true.
      xmin = rw(1)
      xmax = rw(2)
      ymin = rw(3)
      ymax = rw(4)
      if(xmin.le.a.and.a.le.xmax.and.ymin.le.b.and.b.le.ymax)then
      ai = a
      bi = b
      bpt = .false.
      return
      endif
      if(.not.rwu)then
      if(b .lt. ymin)then
      ai = a
      bi = ymin
      if(xmin.le.ai.and.ai.le.xmax)then
      return
      endif
      endif
      if(b .gt. ymax)then
      ai = a
      bi = ymax
      if(xmin.le.ai.and.ai.le.xmax)then
      return
      endif
      endif
      intfnd = .false.
      return
      endif
      if(a.lt.xmin)then
      ai = xmin
      bi = b + slope*(ai-a)
      if(ymin.le.bi.and.bi.le.ymax)then
      return
      endif
      endif
      if(b.lt.ymin)then
      bi = ymin
      ai = a + (bi-b)/slope
      if(xmin.le.ai.and.ai.le.xmax)then
      return
      endif
      endif
      if(a.gt.xmax)then
      ai = xmax
      bi = b + slope*(ai-a)
      if(ymin.le.bi.and.bi.le.ymax)then
      return
      endif
      endif
      if(b.gt.ymax)then
      bi = ymax
      ai = a + (bi-b)/slope
      if(xmin.le.ai.and.ai.le.xmax)then
      return
      endif
      endif
      intfnd = .false.
      return
      end

.onAttach <- function(lib, pkg) {
	ver <- read.dcf(file.path(lib, pkg, "DESCRIPTION"), "Version")
        #nick <- "Nickname: \"Stack Smashing Detected\""
        #nick <- "Nickname: \"Morpheus and Euripides\""
        #nick <- "Nickname: \"Dyslexical Scoping\""
        #nick <- "Nickname: \"Mendacious Cosmonaut\""
        #nick <- "Nickname: \"Partial Distinction\""
        #nick <- "Nickname: \"Mephistophelian Transition\""
        nick <- "Nickname: \"Idol Comparison\""
        #nick <- "Nickname: \"Perspicuous Ambivalence\""
        #nick <- "Nickname: \"Cats are not required to wear seatbelts\""
        #nick <- "Nickname: \"There weren't many available options\""
        packageStartupMessage(paste(pkg, ver, "    ",nick))
        msg <- paste("\n     The syntax of deldir() has changed since version",
                     "\n     0.0-10.  Read the help!!!.\n")
        packageStartupMessage(msg)
}

subroutine dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bpt)

# Get a point ***inside*** the rectangular window on the ray from
# one circumcentre to the next one.  I.e. if the `next one' is
# inside, then that's it; else find the intersection of this ray with
# the boundary of the rectangle.
# Called by dirseg, dirout.

implicit double precision(a-h,o-z)
dimension rw(4)
logical intfnd, bpt, rwu

# Note that (a,b) is the circumcentre of a Delaunay triangle,
# and that slope is the slope of the ray joining (a,b) to the
# corresponding circumcentre on the opposite side of an edge of that
# triangle.  When `dldins' is called by `dirout' it is possible
# for the ray not to intersect the window at all.  (The Delaunay
# edge between the two circumcentres might be connected to a `fake
# outer corner', added to facilitate constructing a tiling that
# completely covers the actual window.)  The variable `intfnd' acts
# as an indicator as to whether such an intersection has been found.

# The variable `bpt' acts as an indicator as to whether the returned
# point (ai,bi) is a true circumcentre, inside the window (bpt == .false.),
# or is the intersection of a ray with the boundary of the window
# (bpt = .true.).


intfnd = .true.
bpt = .true.

# Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

# Check if (a,b) is inside the rectangle.
if(xmin<=a&a<=xmax&ymin<=b&b<=ymax) {
        ai = a
        bi = b
	bpt = .false.
        return
}

# Look for appropriate intersections with the four lines forming
# the sides of the rectangular window.

# If not "the right way up" then the line joining the two
# circumcentres is vertical.

if(!rwu) {
    if(b < ymin) {
            ai = a
            bi = ymin
            if(xmin<=ai&ai<=xmax) return
    }
    if(b > ymax) {
            ai = a
            bi = ymax
            if(xmin<=ai&ai<=xmax) return
    }
    intfnd = .false.
    return
}

# Line 1: x = xmin.
if(a<xmin) {
        ai = xmin
        bi = b + slope*(ai-a)
        if(ymin<=bi&bi<=ymax) return
}

# Line 2: y = ymin.
if(b<ymin) {
        bi = ymin
        ai = a + (bi-b)/slope
        if(xmin<=ai&ai<=xmax) return
}

# Line 3: x = xmax.
if(a>xmax) {
        ai = xmax
        bi = b + slope*(ai-a)
        if(ymin<=bi&bi<=ymax) return
}

# Line 4: y = ymax.
if(b>ymax) {
        bi = ymax
        ai = a + (bi-b)/slope
        if(xmin<=ai&ai<=xmax) return
}

intfnd = .false.
return
end

subroutine delet1(i,j,nadj,madj,ntot)
# Delete j from the adjacency list of i.
# Called by delet.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj)

n    = nadj(i,0)
do k = 1,n {
        if(nadj(i,k)==j) { # Find j in the list;
                           # then move everything back one notch.
                do kk = k,n-1 { nadj(i,kk) = nadj(i,kk+1) }
                nadj(i,n) = -99 # Changed from the confusing 0 value 25/7/2011.
                nadj(i,0) = n-1
                return
        }
}

end

divchain.default <- function (x,y,z,...) {
#
    if(missing(z)) {
        if(inherits(x,"ppp")) z <- x$marks
        else stop("Argument \"z\" was not supplied .\n")
    }
    z  <- factor(z)
    dd <- deldir(x,y,z=z,...)
    divchain(dd)
}

subroutine testeq(a,b,eps,value)

! Test for the equality of a and b in a fairly
! robust way.
! Called by trifnd, circen, stoke.

implicit double precision(a-h,o-z)
logical :: value

! Define constants.
one = 1.d0
ten = 1.d10

! If b is essentially 0, check whether a is essentially zero also.
! The following is very sloppy!  Must fix it!
if(abs(b)<=eps) then
    if(abs(a)<=eps) then
        value = .true.
    else
        value = .false.
    endif
    return
endif

! Test if a is a `lot different' from b.  (If it is
! they're obviously not equal.)  This avoids under/overflow
! problems in dividing a by b.
if(abs(a)>ten*abs(b) .or. abs(a)<one*abs(b)) then
    value = .false.
    return
endif

! They're non-zero and fairly close; compare their ratio with 1.
c = a/b
if(abs(c-1.d0)<=eps) then
    value = .true.
else
    value = .false.
endif
end subroutine testeq

subroutine swap(j,k1,k2,shdswp,nadj,madj,x,y,ntot,eps,nerror)

# The segment k1->k2 is a diagonal of a quadrilateral
# with a vertex at j (the point being added to the
# triangulation).  If the LOP is not satisfied, swap
# it for the other diagonal.
# Called by addpt.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical shdswp


# If vertices k1 and k2 are not connected there is no diagonal to swap.
# This could happen if vertices j, k1, and k2 were colinear, but shouldn't.
call adjchk(k1,k2,shdswp,nadj,madj,ntot,nerror)
if(nerror > 0) return
if(!shdswp) return

# Get the other vertex of the quadrilateral.
call pred(k,k1,k2,nadj,madj,ntot,nerror) # If these aren't the same, then
if(nerror > 0) return
call succ(kk,k2,k1,nadj,madj,ntot,nerror) # there is no other vertex.
if(nerror > 0) return
if(kk!=k) {
        shdswp = .false.
        return
}

# Check whether the LOP is satisified; i.e. whether
# vertex k is outside the circumcircle of vertices j, k1, and k2
call qtest(j,k1,k,k2,shdswp,x,y,ntot,eps,nerror)
if(nerror > 0) return

# Do the actual swapping.
if(shdswp) {
        call delet(k1,k2,nadj,madj,ntot,nerror)
	if(nerror > 0) return
	call insrt(j,k,nadj,madj,x,y,ntot,nerror,eps)
	if(nerror > 0) return
}
return
end

triang.list <- function (object) 
{
    stopifnot(inherits(object,"deldir"))
    io <- object$ind.orig
    tlist <- prelimtlist(object)
    if(nrow(tlist)==0) {
        rslt <- list()
        attr(rslt,"rw") <- object$rw
        class(rslt) <- "triang.list"
        return(rslt)
    }
    x <- object$summary[,"x"]
    y <- object$summary[,"y"]
    if("z" %in% colnames(object$summary)) {
	z <- object$summary[,"z"]
	haveZ <- TRUE
    } else haveZ <- FALSE
    xtri <- matrix(x[tlist], nrow(tlist), 3)
    ytri <- matrix(y[tlist], nrow(tlist), 3)
    if(haveZ) ztri <- matrix(z[tlist], nrow(tlist), 3)
    ctri <- ytri - min(y)
    dx <- cbind(xtri[, 2] - xtri[, 1], xtri[, 3] - xtri[, 2], 
        xtri[, 1] - xtri[, 3])
    zm <- cbind(ctri[, 1] + ctri[, 2], ctri[, 2] + ctri[, 3], 
        ctri[, 3] + ctri[, 1])
    negareas <- apply(dx * zm, 1, sum)
    clockwise <- (negareas > 0)
    if (any(clockwise)) {
        xc <- xtri[clockwise,,drop=FALSE]
        yc <- ytri[clockwise,,drop=FALSE]
        tc <- tlist[clockwise,,drop=FALSE]
        if(haveZ) zc <- ztri[clockwise,,drop=FALSE]
        xtri[clockwise, ] <- xc[, c(1, 3, 2)]
        ytri[clockwise, ] <- yc[, c(1, 3, 2)]
        tlist[clockwise,] <- tc[, c(1, 3, 2)]
        if(haveZ) ztri[clockwise, ] <- zc[, c(1, 3, 2)]
    }
    rslt <- list()
    K <- 0
    for(i in seq(length.out=nrow(xtri))) {
	tmp <- .Fortran(
		"intri",
		x=as.double(xtri[i,]),
		y=as.double(ytri[i,]),
		u=as.double(x),
		v=as.double(y),
		n=as.integer(length(x)),
		okay=integer(1),
		PACKAGE="deldir"
	)
	if(as.logical(tmp$okay)) {
                tmp <- data.frame(ptNum=io[tlist[i,]],x=xtri[i,],y=ytri[i,])
                if(haveZ) tmp <- cbind(tmp,z=ztri[i,])
		K <- K+1
                rslt[[K]] <- tmp
        }
    }
    attr(rslt,"rw") <- object$rw
    class(rslt) <- "triang.list"
    rslt
}
"[.triang.list" <- function(x,i,...){
    y <- unclass(x)[i]
    class(y) <- "triang.list"
    attr(y,"rw") <- attr(x,"rw")
y
}

subroutine pred(kpr,i,j,nadj,madj,ntot)

# Find the predecessor of j in the adjacency list of i.
# Called by initad, trifnd, swap, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj)
dimension ndi(1)

# Set dummy integer for call to intpr(...).
ndi(1) = 0

n = nadj(i,0)

# If the adjacency list of i is empty, then clearly j has no predecessor
# in this adjacency list. Something's wrong; stop.
if(n==0) {
    call intpr("Adjacency list of i is empty, and so cannot contain j.",-1,ndi,0)
    call rexit("Bailing out of pred.")
}

# The adjacency list of i is non-empty; search through it until j is found;
# subtract 1 from the location of j, and find the contents of this new location
do k = 1,n {
    if(j==nadj(i,k)) {
        km = k-1
        if(km<1) km = n         # Take km modulo n. (The adjacency list
        kpr = nadj(i,km)        # is circular.)
        return
    }
}

# The adjacency list for i doesn't contain j.  Something's wrong; stop.
    call intpr("Adjacency list of i does not contain j.",-1,ndi,0)
    call rexit("Bailing out of pred.")
end

binsrtR <- function(x,y,rw) {
    n    <- length(x)
    ind  <- rep(0,n)
    rslt <- .Fortran("binsrt",
                     x=as.double(x),
                     y=as.double(y),
                     rw=as.double(rw),
                     n=as.integer(n),
                     ind=as.integer(ind),
                     rind=as.integer(ind),
                     tx=double(n),
                     ty=double(n),
                     ilst=integer(n),
                     PACKAGE="deldir"
                )
    list(x=rslt$tx,y=rslt$ty,ind=rslt$ind,rind=rslt$rind)
}

subroutine stoke(x1,y1,x2,y2,rw,area,s1,eps,nerror)

# Apply Stokes' theorem to find the area of a polygon;
# we are looking at the boundary segment from (x1,y1)
# to (x2,y2), travelling anti-clockwise.  We find the
# area between this segment and the horizontal base-line
# y = ymin, and attach a sign s1.  (Positive if the
# segment is right-to-left, negative if left to right.)
# The area of the polygon is found by summing the result
# over all boundary segments.

# Just in case you thought this wasn't complicated enough,
# what we really want is the area of the intersection of
# the polygon with the rectangular window that we're using.

# Called by dirout.

implicit double precision(a-h,o-z)
dimension rw(4)
logical value

zero   = 0.d0
nerror = -1

# If the segment is vertical, the area is zero.
call testeq(x1,x2,eps,value)
if(value) {
        area = 0.
        s1   = 0.
        return
}

# Find which is the right-hand end, and which is the left.
if(x1<x2) {
        xl = x1
        yl = y1
        xr = x2
        yr = y2
        s1 = -1.
}
else {
        xl = x2
        yl = y2
        xr = x1
        yr = y1
        s1 = 1.
}

# Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

# Now start intersecting with the rectangular window.
# Truncate the segment in the horizontal direction at
# the edges of the rectangle.
slope = (yl-yr)/(xl-xr)
x  = max(xl,xmin)
y  = yl+slope*(x-xl)
xl = x
yl = y

x  = min(xr,xmax)
y  = yr+slope*(x-xr)
xr = x
yr = y

if(xr<=xmin|xl>=xmax) {
        area = 0.
        return
}

# We're now looking at a trapezoidal region which may or may
# not protrude above or below the horizontal strip bounded by
# y = ymax and y = ymin.
ybot = min(yl,yr)
ytop = max(yl,yr)

# Case 1; ymax <= ybot:
# The `roof' of the trapezoid is entirely above the
# horizontal strip.
if(ymax<=ybot) {
        area = (xr-xl)*(ymax-ymin)
        return
}

# Case 2; ymin <= ybot <= ymax <= ytop:
# The `roof' of the trapezoid intersects the top of the
# horizontal strip (y = ymax) but not the bottom (y = ymin).
if(ymin<=ybot&ymax<=ytop) {
        call testeq(slope,zero,eps,value)
        if(value) {
                w1 = 0.
                w2 = xr-xl
        }
        else {
                xit = xl+(ymax-yl)/slope
                w1 = xit-xl
                w2 = xr-xit
                if(slope<0.) {
                        tmp = w1
                        w1  = w2
                        w2  = tmp
                }
        }
        area = 0.5*w1*((ybot-ymin)+(ymax-ymin))+w2*(ymax-ymin)
        return
}

# Case 3; ybot <= ymin <= ymax <= ytop:
# The `roof' intersects both the top (y = ymax) and
# the bottom (y = ymin) of the horizontal strip.
if(ybot<=ymin&ymax<=ytop) {
        xit = xl+(ymax-yl)/slope
        xib = xl+(ymin-yl)/slope
        if(slope>0.) {
                w1 = xit-xib
                w2 = xr-xit
        }
        else {
                w1 = xib-xit
                w2 = xit-xl
        }
        area = 0.5*w1*(ymax-ymin)+w2*(ymax-ymin)
        return
}

# Case 4; ymin <= ybot <= ytop <= ymax:
# The `roof' is ***between*** the bottom (y = ymin) and
# the top (y = ymax) of the horizontal strip.
if(ymin<=ybot&ytop<=ymax) {
        area = 0.5*(xr-xl)*((ytop-ymin)+(ybot-ymin))
        return
}

# Case 5; ybot <= ymin <= ytop <= ymax:
# The `roof' intersects the bottom (y = ymin) but not
# the top (y = ymax) of the horizontal strip.
if(ybot<=ymin&ymin<=ytop) {
        call testeq(slope,zero,eps,value)
        if(value) {
                area = 0.
                return
        }
        xib = xl+(ymin-yl)/slope
        if(slope>0.) w = xr-xib
        else w = xib-xl
        area = 0.5*w*(ytop-ymin)
        return
}

# Case 6; ytop <= ymin:
# The `roof' is entirely below the bottom (y = ymin), so
# there is no area contribution at all.
if(ytop<=ymin) {
        area = 0.
        return
}

# Default; all stuffed up:
nerror = 8
return

end

C Output from Public domain Ratfor, version 1.03
      subroutine qtest1(h,i,j,k,x,y,ntot,eps,shdswp)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot), xt(3), yt(3), indv(3)
      dimension itmp(1)
      dimension xtmp(1)
      dimension ndi(1)
      integer h
      logical shdswp, collin
      ndi(1) = 0
      xt(1) = x(h)
      yt(1) = y(h)
      xt(2) = x(i)
      yt(2) = y(i)
      xt(3) = x(k)
      yt(3) = y(k)
      nid = 0
      call cross(xt,yt,nid,cprd)
      collin = (abs(cprd) .lt. eps)
      if(collin)then
      a = xt(2) - xt(1)
      b = yt(2) - yt(1)
      c = xt(3) - xt(1)
      d = yt(3) - yt(1)
      c1 = sqrt(a*a+b*b)
      c2 = sqrt(c*c+d*d)
      a = a/c1
      b = b/c1
      c = c/c2
      d = d/c2
      alpha = a*c+b*d
      if(alpha.gt.0)then
      itmp(1) = 1
      indv(1) = i
      indv(2) = j
      indv(3) = k
      itmp(1) = h
      call intpr("Point being added, h:",-1,itmp,1)
      call intpr("now, other vertex, nxt:",-1,indv,3)
      xtmp(1) = alpha
      call dblepr("Test value:",-1,xtmp,1)
      call intpr("Points are collinear but h is not between i and k.",-1
     *,ndi,0)
      call rexit("Bailing out of qtest1.")
      endif
      shdswp = .true.
      endif
      xh = x(h)
      yh = y(h)
      xj = x(j)
      yj = y(j)
      call circen(h,i,k,x0,y0,x,y,ntot,eps,shdswp)
      if(shdswp)then
      return
      endif
      a = x0-xh
      b = y0-yh
      r2 = a*a+b*b
      a = x0-xj
      b = y0-yj
      ch = a*a + b*b
      if(ch.lt.r2)then
      shdswp = .true.
      else
      shdswp = .false.
      endif
      return
      end

tileArea <- function(x,y,rw) {
   n <- length(x)
   eps <- sqrt(.Machine$double.eps)
   area <- 0
   for(i in 1:n) {
       ip <- if(i==n) 1 else i+1
       tmp <- .Fortran(
                  "stoke",
                  x1=as.double(x[i]),
                  y1=as.double(y[i]),
                  x2=as.double(x[ip]),
                  y2=as.double(y[ip]),
                  rw=as.double(rw),
                  area=double(1),
                  s1=double(1),
                  eps=as.double(eps),
                  PACKAGE="deldir"
              )
        area <- area+tmp[["area"]]*tmp[["s1"]]
    }
    area
}

subroutine locn(i,j,kj,nadj,madj,x,y,ntot,eps)

! Find the appropriate location for j in the adjacency list
! of i.  This is the index which j ***will*** have when
! it is inserted into the adjacency list of i in the
! appropriate place.  Called by insrt.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical :: before

n = nadj(i,0)

! If there is nothing already adjacent to i, then j will have place 1.
if(n==0) then
    kj = 1
    return
endif

! Run through i's list, checking if j should come before each element
! of that list.  (I.e. if i, j, and k are in anti-clockwise order.)
! If j comes before the kj-th item, but not before the (kj-1)-st, then
! j should have place kj.
do ks = 1,n
    kj = ks
    k = nadj(i,kj)
    call acchk(i,j,k,before,x,y,ntot,eps)
    if(before) then
        km = kj-1
        if(km==0) km = n
        k = nadj(i,km)
        call acchk(i,j,k,before,x,y,ntot,eps)
! Got here.
        if(.not.before) then
! If j is before 1 and after n, then it should
! have place n+1.
            if(kj==1) kj = n+1
            return
        endif
    endif
enddo

! We've gone right through the list and haven't been before
! the kj-th item ***and*** after the (kj-1)-st on any occasion.
! Therefore j is before everything (==> place 1) or after
! everything (==> place n+1).
if(before) then
    kj = 1
else
    kj = n+1
endif
end subroutine locn

dumpts <- function(x,y,dpl,rw) {
#
# Function dumpts to append a sequence of dummy points to the
# data points.
#

ndm   <- 0
xd    <- NULL
yd    <- NULL
xmin  <- rw[1]
xmax  <- rw[2]
ymin  <- rw[3]
ymax  <- rw[4]

# Points on radii of circles emanating from data points:
if(!is.null(dpl$nrad)) {
	nrad  <- dpl$nrad # Number of radii from each data point.
	nper  <- dpl$nper # Number of dummy points per radius.
	fctr  <- dpl$fctr # Length of each radius = fctr * mean
                             # interpoint distance.
	lrad  <- fctr*mnnd(x,y)/nper
	theta <- 2*pi*(1:nrad)/nrad
	cs    <- cos(theta)
	sn    <- sin(theta)
	xt    <- c(lrad*(1:nper)%o%cs)
	yt    <- c(lrad*(1:nper)%o%sn)
	xd    <- c(outer(x,xt,'+'))
	yd    <- c(outer(y,yt,'+'))
}

# Ad hoc points passed over as part of dpl:
if(!is.null(dpl$x)) {
	xd <- c(xd,dpl$x)
	yd <- c(yd,dpl$y)
}

# Delete dummy points outside the rectangular window.
ndm  <- length(xd)
if(ndm >0) {
	drop <- (1:ndm)[xd<xmin|xd>xmax|yd<ymin|yd>ymax]
	if(length(drop)>0) {
		xd  <- xd[-drop]
		yd  <- yd[-drop]
	}
}

# Rectangular grid:
ndx <- dpl$ndx
okx <- !is.null(ndx) && ndx > 0
ndy <- dpl$ndy
oky <- !is.null(ndy) && ndy > 0
if(okx & oky) {
	xt  <- if(ndx>1) seq(xmin,xmax,length=ndx) else 0.5*(xmin+xmax)
	yt  <- if(ndy>1) seq(ymin,ymax,length=ndy) else 0.5*(ymin+ymax)
	xy <- expand.grid(x=xt,y=yt)
	xd  <- c(xd,xy$x)
	yd  <- c(yd,xy$y)
}

ndm <- length(xd)
list(x=c(x,xd),y=c(y,yd),ndm=ndm)
}

subroutine  succ(ksc,i,j,nadj,madj,ntot)

# Find the successor of j in the adjacency list of i.
# Called by addpt, initad, trifnd, swap, delout, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj)
dimension ndi(1)

# Set dummy integer for call to intpr(...).
ndi(1) = 0

n = nadj(i,0)

# If the adjacency list of i is empty, then clearly j has no successor
# in this adjacency list.  Something's wrong; stop.
if(n==0) {
    call intpr("Adjacency list of i is empty, and so cannot contain j.",-1,ndi,0)
    call rexit("Bailing out of succ.")
}

# The adjacency list of i is non-empty; search through it until j is found;
# add 1 to the location of j, and find the contents of this new location.
do k = 1,n {
    if(j==nadj(i,k)) {
        kp = k+1
        if(kp>n) kp = 1         # Take kp modulo n. (The adjacency list
        ksc = nadj(i,kp)        # is circular.)
        return
    }
}

# The adjacency list doesn't contain j.  Something's wrong.
ndi(1) = i
call intpr("i =",-1,ndi,1)
ndi(1) = j
call intpr("j =",-1,ndi,1)
call intpr("Adjacency list of i does not contain j.",-1,ndi,0)
call rexit("Bailing out of succ.")
end

subroutine stoke(x1,y1,x2,y2,rw,area,s1,eps)

! Apply Stokes' theorem to find the area of a polygon;
! we are looking at the boundary segment from (x1,y1)
! to (x2,y2), travelling anti-clockwise.  We find the
! area between this segment and the horizontal base-line
! y = ymin, and attach a sign s1.  (Positive if the
! segment is right-to-left, negative if left to right.)
! The area of the polygon is found by summing the result
! over all boundary segments.

! Just in case you thought this wasn't complicated enough,
! what we really want is the area of the intersection of
! the polygon with the rectangular window that we're using.

! Called by dirout.

implicit double precision(a-h,o-z)
dimension :: rw(4)
dimension :: ndi(1)
logical :: value

! Set dummy integer for call to intpr(...).
ndi(1) = 0

zero   = 0.d0

! If the segment is vertical, the area is zero.
call testeq(x1,x2,eps,value)
if(value) then
    area = 0.d0
    s1   = 0.d0
    return
endif

! Find which is the right-hand end, and which is the left.
if(x1<x2) then
    xl = x1
    yl = y1
    xr = x2
    yr = y2
    s1 = -1.d0
else
    xl = x2
    yl = y2
    xr = x1
    yr = y1
    s1 = 1.d0
endif

! Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

! Now start intersecting with the rectangular window.
! Truncate the segment in the horizontal direction at
! the edges of the rectangle.
slope = (yl-yr)/(xl-xr)
x  = max(xl,xmin)
y  = yl+slope*(x-xl)
xl = x
yl = y

x  = min(xr,xmax)
y  = yr+slope*(x-xr)
xr = x
yr = y

if(xr<=xmin .or. xl>=xmax) then
    area = 0.d0
    return
endif

! We're now looking at a trapezoidal region which may or may
! not protrude above or below the horizontal strip bounded by
! y = ymax and y = ymin.
ybot = min(yl,yr)
ytop = max(yl,yr)

! Case 1; ymax <= ybot:
! The `roof' of the trapezoid is entirely above the
! horizontal strip.
if(ymax<=ybot) then
    area = (xr-xl)*(ymax-ymin)
    return
endif

! Case 2; ymin <= ybot <= ymax <= ytop:
! The `roof' of the trapezoid intersects the top of the
! horizontal strip (y = ymax) but not the bottom (y = ymin).
if(ymin<=ybot .and. ymax<=ytop) then
    call testeq(slope,zero,eps,value)
    if(value) then
        w1 = 0.d0
        w2 = xr-xl
    else
        xit = xl+(ymax-yl)/slope
        w1 = xit-xl
        w2 = xr-xit
        if(slope<0.d0) then
            tmp = w1
            w1  = w2
            w2  = tmp
        endif
    endif
    area = 0.5*w1*((ybot-ymin)+(ymax-ymin))+w2*(ymax-ymin)
    return
endif

! Case 3; ybot <= ymin <= ymax <= ytop:
! The `roof' intersects both the top (y = ymax) and
! the bottom (y = ymin) of the horizontal strip.
if(ybot<=ymin .and. ymax<=ytop) then
    xit = xl+(ymax-yl)/slope
    xib = xl+(ymin-yl)/slope
    if(slope>0.d0) then
            w1 = xit-xib
            w2 = xr-xit
    else
        w1 = xib-xit
        w2 = xit-xl
    endif
    area = 0.5d0*w1*(ymax-ymin)+w2*(ymax-ymin)
    return
endif

! Case 4; ymin <= ybot <= ytop <= ymax:
! The `roof' is ***between*** the bottom (y = ymin) and
! the top (y = ymax) of the horizontal strip.
if(ymin<=ybot .and. ytop<=ymax) then
    area = 0.5d0*(xr-xl)*((ytop-ymin)+(ybot-ymin))
    return
endif

! Case 5; ybot <= ymin <= ytop <= ymax:
! The `roof' intersects the bottom (y = ymin) but not
! the top (y = ymax) of the horizontal strip.
if(ybot<=ymin .and. ymin<=ytop) then
    call testeq(slope,zero,eps,value)
    if(value) then
        area = 0.
        return
    endif
    xib = xl+(ymin-yl)/slope
    if(slope>0.d0) then
        w = xr-xib
    else
        w = xib-xl
    endif
    area = 0.5*w*(ytop-ymin)
    return
endif

! Case 6; ytop <= ymin:
! The `roof' is entirely below the bottom (y = ymin), so
! there is no area contribution at all.
if(ytop<=ymin) then
        area = 0.
        return
endif

! Default; all stuffed up:
call intpr("Fell through all six cases.",-1,ndi,0)
call intpr("Something is totally stuffed up!",-1,ndi,0)
call intpr("Chaos and havoc in stoke.",-1,ndi,0)
call rexit("Bailing out of stoke.")
end subroutine stoke

print.deldir <- function(x,digits=NULL,...) {
    cat("\n")
    cat("Delaunay triangulation and Dirchlet tessellation\n",
        "of",x$n.data," points.\n")
    cat("\n")
    if(is.null(digits)) {
        rw <- x$rw
        dirA <- x$dir.area
        delA <- x$del.area
    } else {
        rw <- round(x$rw,digits)
        dirA <- round(x$dir.area,digits)
        delA <- round(x$del.area,digits)
    }
    RW <- paste0("[",rw[1],",",rw[2],"]"," x ",
                 "[",rw[3],",",rw[4],"]")
    cat("Enclosing rectangular window:\n")
    cat(RW,"\n")
    cat("\n")
    cat("Area of rectangular window (total area of\n")
    cat("Dirichlet tiles):\n")
    cat(dirA,"\n")
    cat("\n")
    cat("Area of convex hull of points (total area of\n")
    cat("Delaunay triangles):\n")
    cat(delA,"\n")
    cat("\n")
    invisible()
}

C Output from Public domain Ratfor, version 1.0
      subroutine circen(i,j,k,x0,y0,x,y,ntot,eps,collin,nerror)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot), xt(3), yt(3)
      logical collin
      nerror = -1
      xt(1) = x(i)
      yt(1) = y(i)
      xt(2) = x(j)
      yt(2) = y(j)
      xt(3) = x(k)
      yt(3) = y(k)
      ijk = 0
      call cross(xt,yt,ijk,cprd)
      if(abs(cprd) .lt. eps)then
      collin = .true.
      else
      collin = .false.
      endif
      a = x(j) - x(i)
      b = y(j) - y(i)
      c = x(k) - x(i)
      d = y(k) - y(i)
      c1 = sqrt(a*a+b*b)
      c2 = sqrt(c*c+d*d)
      a = a/c1
      b = b/c1
      c = c/c2
      d = d/c2
      if(collin)then
      alpha = a*c+b*d
      if(alpha.gt.0)then
      nerror = 3
      return
      endif
      return
      endif
      crss = a*d - b*c
      x0 = x(i) + 0.5*(c1*d - c2*b)/crss
      y0 = y(i) + 0.5*(c2*a - c1*c)/crss
      return
      end

subroutine qtest(h,i,j,k,shdswp,x,y,ntot,eps,nerror)

# Test whether the LOP is satisified; i.e. whether vertex j
# is outside the circumcircle of vertices h, i, and k of the
# quadrilateral.  Vertex h is the vertex being added; i and k are
# the vertices of the quadrilateral which are currently joined;
# j is the vertex which is ``opposite'' the vertex being added.
# If the LOP is not satisfied, then shdswp ("should-swap") is true,
# i.e. h and j should be joined, rather than i and k.  I.e. if j
# is outside the circumcircle of h, i, and k then all is well as-is;
# *don't* swap ik for hj.  If j is inside the circumcircle of h,
# i, and k then change is needed so swap ik for hj.
# Called by swap.

implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot)
integer h
logical shdswp

nerror = -1

# Look for ideal points.
if(i<=0) ii = 1
else ii = 0
if(j<=0) jj = 1
else jj = 0
if(k<=0) kk = 1
else kk = 0
ijk = ii*4+jj*2+kk

# All three corners other than h (the point currently being
# added) are ideal --- so h, i, and k are co-linear; so 
# i and k shouldn't be joined, and h should be joined to j.
# So swap.  (But this can't happen, anyway!!!)
# case 7:
if(ijk==7) {
	shdswp = .true.
	return
}

# If i and j are ideal, find out which of h and k is closer to the
# intersection point of the two diagonals, and choose the diagonal
# emanating from that vertex.  (I.e. if h is closer, swap.)
# Unless swapping yields a non-convex quadrilateral!!!
# case 6:
if(ijk==6) {
	xh = x(h)
	yh = y(h)
	xk = x(k)
	yk = y(k)
	ss = 1 - 2*mod(-j,2)
	test = (xh*yk+xk*yh-xh*yh-xk*yk)*ss
	if(test>0.d0) shdswp = .true.
	else shdswp = .false.
# Check for convexity:
	if(shdswp) call acchk(j,k,h,shdswp,x,y,ntot,eps)
	return
}

# Vertices i and k are ideal --- can't happen, but if it did, we'd
# increase the minimum angle ``from 0 to more than 2*0'' by swapping ...
#
# 24/7/2011 --- I now think that the forgoing comment is misleading,
# although it doesn't matter since it can't happen anyway.  The
# ``2*0'' is wrong.  The ``new minimum angle would be min{alpha,beta}
# where alpha and beta are the angles made by the line joining h
# to j with (any) line with slope = -1.  This will be greater than
# 0 unless the line from h to j has slope = - 1.  In this case h,
# i, j, and k are all co-linear, so i and k should not be joined
# (and h and j should be) so swapping is called for.  If h, i,
# j and j are not co-linear then the quadrilateral is definitely
# convex whence swapping is OK.  So let's say swap.
# case 5:
if(ijk==5) {
	shdswp = .true.
	return
}

# If i is ideal we'd increase the minimum angle ``from 0 to more than
# 2*0'' by swapping, so just check for convexity:
# case 4:
if(ijk==4) {
	call acchk(j,k,h,shdswp,x,y,ntot,eps)
	return
}

# If j and k are ideal, this is like unto case 6.
# case 3:
if(ijk==3) {
	xi = x(i)
	yi = y(i)
	xh = x(h)
	yh = y(h)
	ss = 1 - 2*mod(-j,2)
	test = (xh*yi+xi*yh-xh*yh-xi*yi)*ss
	if(test>0.d0) shdswp = .true.
	else shdswp = .false.
# Check for convexity:
	if(shdswp) call acchk(h,i,j,shdswp,x,y,ntot,eps)
	return
}

# If j is ideal we'd decrease the minimum angle ``from more than 2*0
# to 0'', by swapping; so don't swap.
# case 2:
if(ijk==2) {
	shdswp = .false.
	return
}

# If k is ideal, this is like unto case 4.
# case 1:
if(ijk==1) {
	call acchk(h,i,j,shdswp,x,y,ntot,eps) # This checks
                                              # for convexity.
                                              # (Was i,j,h,...)
	return
}

# If none of the `other' three corners are ideal, do the Lee-Schacter
# test for the LOP.
# case 0:
if(ijk==0) {
	call qtest1(h,i,j,k,x,y,ntot,eps,shdswp,nerror)
	return
}

# default:  # This CAN'T happen.
nerror = 7
return

end

subroutine delet(i,j,nadj,madj,ntot)
! Delete i and j from each other's adjacency lists.
! Called by initad, swap.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj)
logical :: adj

! First check that they're IN each other's lists.
call adjchk(i,j,adj,nadj,madj,ntot)

! Then do the actual deletion if they are.
if(adj) then
    call delet1(i,j,nadj,madj,ntot)
    call delet1(j,i,nadj,madj,ntot)
endif

return
end

C Output from Public domain Ratfor, version 1.03
      subroutine trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,ntri)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot), xt(3), yt(
     *3)
      dimension ndi(1)
      integer tau(3)
      logical adjace, anticl
      if(j.eq.1)then
      call intpr("No triangles to find.",-1,ndi,0)
      call rexit("Bailing out of trifnd.")
      endif
      j1 = j-1
      tau(1) = j1
      tau(3) = nadj(j1,1)
      call pred(tau(2),j1,tau(3),nadj,madj,ntot)
      call adjchk(tau(2),tau(3),adjace,nadj,madj,ntot)
      if(.not.adjace)then
      tau(3) = tau(2)
      call pred(tau(2),j1,tau(3),nadj,madj,ntot)
      endif
      ktri = 0
1     continue
      call acchk(tau(1),tau(2),tau(3),anticl,x,y,ntot,eps)
      if(.not.anticl)then
      call acchk(tau(3),tau(2),tau(1),anticl,x,y,ntot,eps)
      if(.not.anticl)then
      ndi(1) = j
      call intpr("Point number =",-1,ndi,1)
      call intpr("Previous triangle:",-1,tau,3)
      call intpr("Both vertex orderings are clockwise.",-1,ndi,0)
      call intpr("See help for deldir.",-1,ndi,0)
      call rexit("Bailing out of trifnd.")
      else
      ivtmp = tau(3)
      tau(3) = tau(1)
      tau(1) = ivtmp
      endif
      endif
      ntau = 0
      nedge = 0
      do23008 i = 1,3 
      ip = i+1
      if(ip.eq.4)then
      ip = 1
      endif
      xt(1) = x(tau(i))
      yt(1) = y(tau(i))
      xt(2) = x(tau(ip))
      yt(2) = y(tau(ip))
      xt(3) = x(j)
      yt(3) = y(j)
      if(tau(i).le.0)then
      i1 = 1
      else
      i1 = 0
      endif
      if(tau(ip).le.0)then
      j1 = 1
      else
      j1 = 0
      endif
      k1 = 0
      ijk = i1*4+j1*2+k1
      call cross(xt,yt,ijk,cprd)
      if(cprd .ge. eps)then
      continue
      else
      if(cprd .gt. -eps)then
      nedge = ip
      else
      ntau = ip
      goto 23009
      endif
      endif
23008 continue
23009 continue
      if(ntau.eq.0)then
      return
      endif
      if(ntau.eq.1)then
      tau(2) = tau(3)
      call succ(tau(3),tau(1),tau(2),nadj,madj,ntot)
      endif
      if(ntau.eq.2)then
      tau(3) = tau(2)
      call pred(tau(2),tau(1),tau(3),nadj,madj,ntot)
      endif
      if(ntau.eq.3)then
      tau(1) = tau(3)
      call succ(tau(3),tau(1),tau(2),nadj,madj,ntot)
      endif
      ktri = ktri + 1
      if(ktri .gt. ntri)then
      ndi(1) = j
      call intpr("Point being added:",-1,ndi,1)
      call intpr("Cannot find an enclosing triangle.",-1,ndi,0)
      call intpr("See help for deldir.",-1,ndi,0)
      call rexit("Bailing out of trifnd.")
      endif
      go to 1
      end

subroutine dirseg(dirsgs,ndir,nadj,madj,nn,x,y,ntot,rw,eps,ntri,incAdj,incSeg)

! Output the endpoints of the segments of boundaries of Dirichlet
! tiles.  (Do it economically; each such segment once and only once.)
! Called by master.

implicit double precision(a-h,o-z)
logical :: collin, adjace, intfnd, bptab, bptcd, goferit, rwu
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension :: dirsgs(10,ndir), rw(4)
dimension :: ndi(1)

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! Initialise incSeg
incSeg = 0

! Add in some dummy corner points, outside the actual window.
! Far enough out so that no resulting tile boundaries intersect the
! window.

! Note that these dummy corners are needed by the routine `dirout'
! but will screw things up for `delseg' and `delout'.  Therefore
! this routine (`dirseg') must be called ***before*** dirout, and
! ***after*** delseg and delout.

! Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

a = xmax-xmin
b = ymax-ymin
c = sqrt(a*a+b*b)

nn  = ntot-4
nstt = nn+1
i = nstt
x(i) = xmin-c
y(i) = ymin-c
i = i+1
x(i) = xmax+c
y(i) = ymin-c
i = i+1
x(i) = xmax+c
y(i) = ymax+c
i = i+1
x(i) = xmin-c
y(i) = ymax+c

do j = nstt,ntot
    call addpt(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)
    if(incAdj==1) return
    ntri = ntri + 3
enddo

! Put the segments into the array dirsgs.

! For each distinct pair of (genuine) data points, find out if they are
! adjacent.  If so, find the circumcentres of the triangles lying on each
! side of the segment joining them.
kseg = 0
do i = 2,nn
    do j = 1,i-1
        call adjchk(i,j,adjace,nadj,madj,ntot)
        if(adjace) then
            call pred(k,i,j,nadj,madj,ntot)
            call circen(i,k,j,a,b,x,y,ntot,eps,collin)
            if(collin) then
                call intpr("Vertices of triangle are collinear.",-1,ndi,0)
                call rexit("Bailing out of dirseg.")
            endif
            call succ(l,i,j,nadj,madj,ntot)
            call circen(i,j,l,c,d,x,y,ntot,eps,collin)
            if(collin) then
                call intpr("Vertices of triangle are collinear.",-1,ndi,0)
                call rexit("Bailing out of dirseg.")
            endif
! If a circumcentre is outside the rectangular window
! of interest, draw a line joining it to the other
! circumcentre.  Find the intersection of this line with
! the boundary of the window; for (a,b) and call the point
! of intersection (ai,bi).  For (c,d), call it (ci,di).
! Note: rwu = "right way up".
            xi = x(i)
            xj = x(j)
            yi = y(i)
            yj = y(j)
            if(yi .ne. yj) then
                slope = (xi - xj)/(yj - yi)
                rwu   = .true.
            else
                slope = 0.d0
                rwu   = .false.
            endif
            call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab,nedgeab)
            if(.not.intfnd) then
                call intpr("Line from midpoint to circumcenter",-1,ndi,0)
                call intpr("does not intersect rectangle boundary!",-1,ndi,0)
                call intpr("But it HAS to!!!",-1,ndi,0)
                call rexit("Bailing out of dirseg.")
            endif
            call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd,nedgecd)
            if(.not.intfnd) then
                call intpr("Line from midpoint to circumcenter",-1,ndi,0)
                call intpr("does not intersect rectangle boundary!",-1,ndi,0)
                call intpr("But it HAS to!!!",-1,ndi,0)
                call rexit("Bailing out of dirseg.")
            endif
            goferit = .false.
            if(bptab .and. bptcd) then
                xm = 0.5*(ai+ci)
                ym = 0.5*(bi+di)
                if(xmin<xm.and.xm<xmax.and.ymin<ym.and.ym<ymax) then
                    goferit = .true.
                endif
            endif
            if((.not.bptab) .or. (.not.bptcd)) goferit = .true.
            if(goferit) then
                kseg = kseg + 1
                if(kseg > ndir) then
                    incSeg = 1
                    return
                endif
                dirsgs(1,kseg) = ai
                dirsgs(2,kseg) = bi
                dirsgs(3,kseg) = ci
                dirsgs(4,kseg) = di
                dirsgs(5,kseg) = i
                dirsgs(6,kseg) = j
                if(bptab) then
                     dirsgs(7,kseg) = 1.d0
                else
                     dirsgs(7,kseg) = 0.d0
                endif
                if(bptcd) then
                    dirsgs(8,kseg) = 1.d0
                else
                    dirsgs(8,kseg) = 0.d0
                endif
                if(bptab) then
                    dirsgs(9,kseg) = -nedgeab
                else
                    dirsgs(9,kseg) = k
                endif
                if(bptcd) then
                    dirsgs(10,kseg) = -nedgecd
                else
                    dirsgs(10,kseg) = l
                endif
            endif
        endif
    enddo
enddo
ndir = kseg

end subroutine dirseg

C Output from Public domain Ratfor, version 1.0
      subroutine dirout(dirsum,nadj,madj,x,y,ntot,npd,rw,ind,eps,nerror)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
      dimension dirsum(npd,3), ind(npd), rw(4)
      logical collin, intfnd, bptab, bptcd, rwu
      xmin = rw(1)
      xmax = rw(2)
      ymin = rw(3)
      ymax = rw(4)
      do23000 i1 = 1,npd 
      area = 0.
      nbpt = 0
      npt = 0
      i = ind(i1)
      np = nadj(i,0)
      do23002 j1 = 1,np 
      j = nadj(i,j1)
      call pred(k,i,j,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call succ(l,i,j,nadj,madj,ntot,nerror)
      if(nerror .gt. 0)then
      return
      endif
      call circen(i,k,j,a,b,x,y,ntot,eps,collin,nerror)
      if(nerror.gt.0)then
      return
      endif
      if(collin)then
      nerror = 13
      return
      endif
      call circen(i,j,l,c,d,x,y,ntot,eps,collin,nerror)
      if(nerror.gt.0)then
      return
      endif
      if(collin)then
      nerror = 13
      return
      endif
      call stoke(a,b,c,d,rw,tmp,sn,eps,nerror)
      if(nerror .gt. 0)then
      return
      endif
      area = area+sn*tmp
      xi = x(i)
      xj = x(j)
      yi = y(i)
      yj = y(j)
      if(yi.ne.yj)then
      slope = (xi - xj)/(yj - yi)
      rwu = .true.
      else
      slope = 0.d0
      rwu = .false.
      endif
      call dldins(a,b,slope,rwu,ai,bi,rw,intfnd,bptab)
      if(intfnd)then
      call dldins(c,d,slope,rwu,ci,di,rw,intfnd,bptcd)
      if(.not.intfnd)then
      nerror = 17
      return
      endif
      if(bptab .and. bptcd)then
      xm = 0.5*(ai+ci)
      ym = 0.5*(bi+di)
      if(xmin.lt.xm.and.xm.lt.xmax.and.ymin.lt.ym.and.ym.lt.ymax)then
      nbpt = nbpt+2
      npt = npt+1
      endif
      else
      npt = npt + 1
      if(bptab .or. bptcd)then
      nbpt = nbpt+1
      endif
      endif
      endif
23002 continue
23003 continue
      dirsum(i1,1) = npt
      dirsum(i1,2) = nbpt
      dirsum(i1,3) = area
23000 continue
23001 continue
      return
      end

mnndR <- function(x,y) {
#
# Function mnnd to calculate the mean nearest neighbour distance
# between the points whose coordinates are stored in x and y.
#

n <- length(x)
if(n!=length(y)) stop('data lengths do not match')
dmb <- (max(x)-min(x))**2 + (max(y)-min(y))**2

.Fortran(
	"mnnd",
	x=as.double(x),
	y=as.double(y),
	n=as.integer(n),
	dmb=as.double(dmb),
	d=double(1),
	PACKAGE='deldir'
	)$d
}

deldir <- local({

digOutz <- function(z1,znm,x) {
    if(inherits(z1,"try-error")) { # z not found, so the call can't
                                   # have been z=NULL!
        if(inherits(x,"matrix")) {
            if(znm %in% colnames(x)) return(x[,znm])
        }
        if(znm %in% names(x)) return(x[[znm]])
        whinge <- paste0("Object z = ",znm," not found.\n")
        stop(whinge)
    }
    if(is.null(z1)) return(NULL)
# Here z1 is explicit vector, or a text string, equal to znm.
# If the former return it; if the latter look for the
# object named by that text string.
    if(!isTRUE(identical(z1,znm))) return(z1)
    z <- try(get(znm,pos=1),silent=TRUE)
    if(inherits(z,"try-error")) {
        if(inherits(x,"matrix")) {
            if(znm %in% colnames(x)) return(x[,znm])
        }
        if(znm %in% names(x)) return(x[[znm]])
        whinge <- paste0("Object z = ",znm," not found.\n")
        stop(whinge)
    }
    return(z)
}

digOutxy <- function(x,y,znm) {
if(inherits(x,c("data.frame","matrix"))) {
    whatsit <- if(inherits(x,"data.frame")) "data frame" else "matrix"
    jj   <- 1:ncol(x)
    vnms <- if(inherits(x,"data.frame")) names(x) else colnames(x)
    if(is.null(vnms)) vnms <- paste0("V",jj)
    jt <- jj[!(vnms %in% c("y",znm))]
    if(length(jt)==0) {
        whinge <- paste0("Argument \"x\" is a ",whatsit," but does not appear\n",
                         "  to contain the x-coordinates.\n")
        stop(whinge)
    }
    nomx <- min(jt)
    jx <- match("x",vnms,nomatch=nomx)
    vnms[jx] <- "x"
    y1 <- try(y,silent=TRUE)
    if(inherits(y1,"try-error") || is.null(y1)) {
        jy <- match("y",vnms)
        if(is.na(jy)) {
            jt <- jj[!(vnms %in% c("x",znm))]
            if(length(jt)==0) {
                whinge <- paste0("Argument \"x\" is a ",whatsit," but does not appear\n",
                                 "  to contain the y-coordinates, nor is \"y\" to be\n",
                                 "  found in the global environment.\n")
                stop(whinge)
            }
            jy <- min(jt)
        }
        return(list(x=x[,jx],y=x[,jy]))
    }
    return(list(x=x[,jx],y=y1))
}
if(inherits(x,"list")) {
    if(!("x" %in% names(x))) {
        whinge <- paste0("When argument \"x\" is a generic list, it must have\n",
                         "  a component named \"x\". \n")
        stop(whinge)
    }
    y1 <- try(y,silent=TRUE)
    if(inherits(y1,"try-error") || is.null(y)) {
        y1 <- x[["y"]]
    }
    if(!is.null(y1)) return(list(x=x[["x"]],y=y1))
    stop("Argument \"y\" not found.\n")
}
list(x=x,y=y)
}

function(x,y=NULL,z=NULL,rw=NULL,eps=1e-9,sort=TRUE,plot=FALSE,
                   round=TRUE,digits=6,id=NULL,...) {
# Function deldir to compute the Delaunay Triangulation (and hence
# the Dirichlet Tesselation) of a planar point set according to the
# second (iterative) algorithm of Lee and Schacter, International
# Journal of Computer and Information Sciences, Vol. 9, No. 3, 1980,
# pages 219 to 242.
#
# ORIGINALLY PROGRAMMED BY: Rolf Turner in 1987/88, while with the
# Division of Mathematics and Statistics, CSIRO, Sydney, Australia.
# Re-programmed by Rolf Turner to adapt the implementation from a
# stand-alone Fortran program to an S function, while visiting the
# University of Western Australia, May 1995.  Further revised
# December 1996.
# 

# The triangulation is made to be with respect to the whole plane by
# `suspending' it from `ideal' points
# (-R,-R), (R,-R) (R,R), and (-R,R), where R --> infinity.

# It is also enclosed in a finite rectangle (whose boundaries truncate any
# infinite Dirichlet tiles) with corners (xmin,ymin) etc.  This rectangle
# is referred to elsewhere as `the' rectangular window.

#cat("Fuck fuck fuck!!!\n")

# Organise the x, y and possibly z arguments.

if(inherits(x,"ppp")) {
# If the first argument is an object of class "ppp", extract the x
# and y coordinates from this object. If this object is "marked"
# and if the marks are atomic (a vector or a factor) and z is NULL,
# then set z equal to the marks.
    y1 <- try(y,silent=TRUE)
    if(!is.null(y1))
         warning("Since \"x\" is of class \"ppp\", argument \"y\" is ignored.\n")
    if(is.null(z)) {
        marx <- x$marks
        ok   <- !is.null(marx) & is.atomic(marx)
        if(ok) z <- marx
    }
    if(is.null(rw)) rw <- c(x$window$xrange, x$window$yrange)
    y <- x$y
    x <- x$x
} else {
    z1  <- try(z,silent=TRUE)
    if(inherits(z1,"character") & length(z1)==1) {
        znm <- z1
    } else {
        znm <- deparse(substitute(z))
    }
    xyTemp <- digOutxy(x,y,znm)
    z      <- digOutz(z1,znm,x)
    x      <- xyTemp$x
    y      <- xyTemp$y
}
haveZ <- !is.null(z)
# Check that x and y are numeric.
if(!is.numeric(x))
    stop("The x-coordinates must be numeric.\n")
if(!is.numeric(y))
    stop("The y-coordinates must be numeric.\n")

# Check that lengths match.
n <- length(x)
if(n!=length(y)) stop("Lengths of \"x\" and \"y\" do not match.\n")
if(haveZ) {
    if(n!=length(z))
        stop("Length of \"z\" does not match lengths of \"x\" and \"y\".\n")
}

# Check on the "id" argument.
haveId <- !is.null(id)
if(haveId) {
    if(any(duplicated(id)))
        stop("Argument \"id\", if supplied, must contain no duplicate values.\n")
    if(n!=length(id))
        stop("Length of \"id\" does not match lengths of \"x\" and \"y\".\n")
    id <- as.character(id)
}

# If a data window is specified, turn it into a 4-tuple (if necessary).
if(!is.null(rw)) {
   if(inherits(rw,"owin")) {
       xr <- rw$xrange
       yr <- rw$yrange
       rw <- c(xr,yr)

# Apparently --- according to Michael Chirico 24/09/2015 --- the
# following will accommodate the bounding box of a collection of
# polygons as structured in the "sp" package.
    } else if(is.matrix(rw)) {
        rw <- as.vector(t(rw))
    }
# Check that rw is an appropriate 4-tuple.
    ok <- length(rw)==4 && (rw[1] < rw[2] & rw[3] < rw[4])
    if(!ok)
        stop("The rectangula window rw is not of the appropriate form.\n")
}

# If a data window now exists, get its corner coordinates
# and truncate the data by this window.
if(!is.null(rw)) {
    xmin <- rw[1]
    xmax <- rw[2]
    ymin <- rw[3]
    ymax <- rw[4]
    ind.orig <- 1:n
    drop     <- ind.orig[x<xmin|x>xmax|y<ymin|y>ymax]
    if(length(drop)>0) {
        x  <- x[-drop]
        y  <- y[-drop]
        if(haveZ) z <- z[-drop]
        if(haveId) id <- id[-drop]
        ind.orig <- ind.orig[-drop]
    }
}
nn <- length(x) # Could be different from "n" if the data were
                # clipped to rw.

# If the rectangular window is (still) not specified, form its corners
# from the minimum and maximum of the data +/- 10%:
if(is.null(rw)) {
    if(length(x)==0)
        stop("No points nor any rectangular window specified.\n")
    xmin <- min(x)
    xmax <- max(x)
    ymin <- min(y)
    ymax <- max(y)
    xdff <- xmax-xmin
    ydff <- ymax-ymin
# Check for the setting in which all points lie on a vertical
# or horizontal straight line.
    if(isTRUE(all.equal(xdff,0))) {
        whinge <- paste0("The x-range of the points is zero, whence a",
                         " rectangular window\n  cannot be inferred from",
                         " the data.  You must specify the rectangular\n",
                         "  window explicitly.\n")
        stop(whinge)
    }
    if(isTRUE(all.equal(ydff,0))) {
        whinge <- paste0("The y-range of the points is zero, whence a",
                         " rectangular window\n  cannot be inferred from",
                         " the data.  You must specify the rectangular\n",
                         "  window explicitly.\n")
        stop(whinge)
    }
    xmin <- xmin-0.1*xdff
    xmax <- xmax+0.1*xdff
    ymin <- ymin-0.1*ydff
    ymax <- ymax+0.1*ydff
    rw   <- c(xmin,xmax,ymin,ymax)
    ind.orig <- 1:n
}

# Eliminate duplicate points:
iii <- duplicatedxy(x,y)
if(any(iii)) {
    kkk <- !iii
    nn  <- sum(kkk)
    if(haveZ) {
        jjj <- duplicated(data.frame(x=x,y=y,z=z))
        if(sum(jjj) < sum(iii)) {
            whinge <- paste("There were different tags corresponding to\n",
                            "duplicated points.\n",sep="")
            warning(whinge)
        }
        z   <- z[kkk]
    }
    x   <- x[kkk]
    y   <- y[kkk]
    ind.orig <- ind.orig[!iii]
}

# Check there are sufficiently many points to triangulate/tessellate.
if(nn <= 1) {
    whinge <- paste("There is at most one point inside the given\n",
                    " rectangular window. Thus there are insufficiently\n",
                    " many points to triangulate/tessellate.\n")
    stop(whinge)
}

# Sort the coordinates into "bins".  There are approximately
# sqrt(nn) such bins.  The vector "ind" (index) keeps track of the
# re-ordering; if ind[i] == j then i is the index of a point in
# the original sequence of points and j is the index of the same
# point in the bin sorted sequence.  The vector "rind" (reverse
# index) does the opposite; if rind[i] == j then i is the position
# of a point in the bin sorted sequence and j is its position in
# the original sequence.  Thus ind[rind[k]] = k and rind[ind[k]] = k
# for all k.  So xs[ind] (where xs is the bin sorted sequence of
# x's) is equal to x, the original sequence of x's.  Likewise ys[ind]
# (where ys is the bin sorted sequence of y's) is equal to y, the
# original sequence of y's. Conversely x[rind] = xs and y[rind] = ys.
#
# Added 20/03/2017:  I think I rather made a meal of this.  The
# vector of indices "rind" is just order(ind); ind is a permutation
# of 1, 2, ..., nn.  Thus rind[ind] = ind[rind] = 1, 2, ..., nn.
# However there's no real harm done, so I won't change the shaganappi
# code at this stage.
if(sort) {
    xy   <- binsrtR(x,y,rw)
    x    <- xy$x
    y    <- xy$y
    ind  <- xy$ind
    rind <- xy$rind
} else {
    ind  <- 1:nn
    rind <- 1:nn
}

# Make space for the total number of points as well as 4
# ideal points and 4 extra corner points which get used (only) by
# subroutines dirseg and dirout in the ``output'' process (returning
# a description of the triangulation after it has been calculated):
ntot <- nn + 4               # ntot includes the 4 ideal points but
                             # but NOT the 4 extra corners
x <- c(rep(0,4),x,rep(0,4))
y <- c(rep(0,4),y,rep(0,4))

# Set up fixed dimensioning constants:
ntdel  <- 4*nn
ntdir  <- 3*nn

# Set up dimensioning constants which might need to be increased:
madj <- max(20,ceiling(3*sqrt(ntot)))
tadj <- (madj+1)*(ntot+4)
ndel <- madj*(madj+1)/2
tdel <- 6*ndel
ndir <- ndel
tdir <- 10*ndir

# Call the master subroutine to do the work:
repeat {
    tmp <- .Fortran(
            'master',
            x=as.double(x),
            y=as.double(y),
            rw=as.double(rw),
            nn=as.integer(nn),
            ntot=as.integer(ntot),
            nadj=integer(tadj),
            madj=as.integer(madj),
            eps=as.double(eps),
            delsgs=double(tdel),
            ndel=as.integer(ndel),
            delsum=double(ntdel),
            dirsgs=double(tdir),
            ndir=as.integer(ndir),
            dirsum=double(ntdir),
            incAdj=integer(1),
            incSeg=integer(1),
            PACKAGE='deldir'
        )

# Check for problems with insufficient storage:
    incAdj <- tmp$incAdj
    incSeg <- tmp$incSeg
    if(incAdj==0 & incSeg==0) break
    if(incAdj==1) {
        nmadj <- ceiling(1.2*madj)
        wrds <- paste('Increasing madj from',madj,'to',nmadj,
                      'and trying again.')
        message(wrds)
        madj <- nmadj
        tadj <- (madj+1)*(ntot+4)
        ndel <- max(ndel,madj*(madj+1)/2)
        tdel <- 6*ndel
        ndir <- ndel
        tdir <- 10*ndir
    }
    if(incSeg==1) {
        nndel <- ceiling(1.2*ndel)
        wrds <-paste('Increasing ndel and ndir from',ndel,
                     'to',nndel,'and trying again.')
        message(wrds)
        ndel <- nndel
        tdel <- 6*ndel
        ndir <- ndel
        tdir <- 10*ndir
    }
}

# Collect up the results for return:
ndel             <- tmp$ndel
delsgs           <- if(round) {
                        round(t(as.matrix(matrix(tmp$delsgs,nrow=6)[,1:ndel])),digits)
                    } else {
                        t(as.matrix(matrix(tmp$delsgs,nrow=6)[,1:ndel]))
                    }
delsgs           <- as.data.frame(delsgs)
names(delsgs)    <- c('x1','y1','x2','y2','ind1','ind2')
delsum           <- matrix(tmp$delsum,ncol=4)
del.area         <- sum(delsum[,4])
delsum           <- if(round) {
                        round(cbind(delsum,delsum[,4]/del.area),digits)
                    } else {
                        cbind(delsum,delsum[,4]/del.area)
                    }
del.area         <- if(round) round(del.area,digits) else del.area
ndir             <- tmp$ndir
dirsgs           <- if(round) {
                        round(t(as.matrix(matrix(tmp$dirsgs,nrow=10)[,1:ndir])),digits)
                    } else {
                        t(as.matrix(matrix(tmp$dirsgs,nrow=10)[,1:ndir]))
                    }
dirsgs           <- as.data.frame(dirsgs)
dirsum           <- matrix(tmp$dirsum,ncol=3)
dir.area         <- sum(dirsum[,3])
dirsum           <- if(round) {
                        round(cbind(dirsum,dirsum[,3]/dir.area),digits)
                    } else {
                        cbind(dirsum,dirsum[,3]/dir.area)
                    }
dir.area         <- if(round) round(dir.area,digits) else dir.area
names(dirsgs)    <- c('x1','y1','x2','y2','ind1','ind2','bp1','bp2',
                      'thirdv1','thirdv2')
mode(dirsgs$bp1) <- 'logical'
mode(dirsgs$bp2) <- 'logical'
allsum           <- as.data.frame(cbind(delsum,dirsum))
names(allsum)    <- c('x','y','n.tri','del.area','del.wts',
                              'n.tside','nbpt','dir.area','dir.wts')

# The foregoing results are in terms of the indices of the bin sorted coordinates.
# Put things in terms of the indices of the original coordinates.
delsgs$ind1 <- rind[delsgs$ind1]
delsgs$ind2 <- rind[delsgs$ind2]
dirsgs$ind1 <- rind[dirsgs$ind1]
dirsgs$ind2 <- rind[dirsgs$ind2]
dirsgs$thirdv1  <- with(dirsgs,ifelse(thirdv1<0,thirdv1,rind[abs(thirdv1)]))
dirsgs$thirdv2  <- with(dirsgs,ifelse(thirdv2<0,thirdv2,rind[abs(thirdv2)]))

# If "id" was supplied, change the entries of "ind1", "ind2", "thirdv1",
# and "thirdv2" to be the corresponding entries of "id".
if(haveId) {
    delsgs$ind1 <- id[delsgs$ind1]
    delsgs$ind2 <- id[delsgs$ind2]
    dirsgs$ind1 <- id[dirsgs$ind1]
    dirsgs$ind2 <- id[dirsgs$ind2]
    dirsgs$thirdv1  <- with(dirsgs,ifelse(thirdv1<0,as.character(thirdv1),
                                          id[abs(thirdv1)]))
    dirsgs$thirdv2  <- with(dirsgs,ifelse(thirdv2<0,as.character(thirdv2),
                                          id[abs(thirdv2)]))
}

# The points in "allsum" appear in bin-sorted order; rearrange
# the rows of "allsum" so that the points appear in the original order.
allsum          <- allsum[ind,]

# The following is a furphy --- it just makes the rownames into
# 1, 2, ..., n.  At this point the rownames of "allsum" were
# (1:n)[ind].  So we're getting (1:n)[ind][rind] = ind[rind]
# = 1:n !!!
# rownames(allsum) <- rownames(allsum)[rind]
# So we could just set rownames(allsum) <- 1:nrow(allsum) and
# get the same effect.  However that does not take account of
# *duplicated* points.  So it is better to use ind.orig.  Note that
# the resulting rowname corresponding to a point is the index (in
# the original sequence of points) of the *first* in its sequence
# of duplicated points.

rownames(allsum) <- ind.orig

# Arrange for the tags and id to be in the summary, given
# that they were supplied.
dfz <- if(haveZ) {
    data.frame(z=z)
} else {
    as.data.frame(matrix(nrow=nn,ncol=0))
}
dfid <- if(haveId) {
    data.frame(id=id)
} else {
    as.data.frame(matrix(nrow=nn,ncol=0))
}

allsum <- cbind(allsum[,1:2],dfid,dfz,allsum[,3:9])
rw     <- if(round) round(rw,digits) else rw

# Aw' done!!!
rslt <- list(delsgs=delsgs,dirsgs=dirsgs,summary=allsum,n.data=nn,
             del.area=del.area,dir.area=dir.area,rw=rw,
             ind.orig=ind.orig)
attr(rslt,"round") <- round
attr(rslt,"digits") <- if(round) digits else NA
class(rslt) <- 'deldir'
if(plot) {
    plot(rslt,...)
    return(invisible(rslt))
} else return(rslt)
}
})

subroutine initad(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)

! Initial adding-in of a new point j.
! Called by addpt.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
integer :: tau(3)

! Find the triangle containing vertex j.
call trifnd(j,tau,nedge,nadj,madj,x,y,ntot,eps,ntri)

! If the new point is on the edge of a triangle, detach the two
! vertices of that edge from each other.  Also join j to the vertex
! of the triangle on the reverse side of that edge from the `found'
! triangle (defined by tau) -- given that there ***is*** such a triangle.
if(nedge .ne. 0) then
    ip = nedge
    i  = ip-1
    if(i==0) i = 3 ! Arithmetic modulo 3.
    call pred(k,tau(i),tau(ip),nadj,madj,ntot)
    call succ(kk,tau(ip),tau(i),nadj,madj,ntot)
    call delet(tau(i),tau(ip),nadj,madj,ntot)
    if(k==kk) call insrt(j,k,nadj,madj,x,y,ntot,eps,incAdj)
    if(incAdj==1) return
endif

! Join the new point to each of the three vertices.
do i = 1,3
    call insrt(j,tau(i),nadj,madj,x,y,ntot,eps,incAdj)
enddo
end subroutine initad

subroutine pred(kpr,i,j,nadj,madj,ntot)

! Find the predecessor of j in the adjacency list of i.
! Called by initad, trifnd, swap, dirseg, dirout.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj)
dimension :: ndi(1)

! Set dummy integer for call to intpr(...).
ndi(1) = 0

n = nadj(i,0)

! If the adjacency list of i is empty, then clearly j has no predecessor
! in this adjacency list. Something's wrong; stop.
if(n==0) then
    call intpr("Adjacency list of i is empty, and so cannot contain j.",-1,ndi,0)
    call rexit("Bailing out of pred.")
endif

! The adjacency list of i is non-empty; search through it until j is found;
! subtract 1 from the location of j, and find the contents of this new location
do k = 1,n
    if(j==nadj(i,k)) then
        km = k-1
        if(km<1) km = n         ! Take km modulo n. (The adjacency list
        kpr = nadj(i,km)        ! is circular.)
        return
    endif
enddo

! The adjacency list for i doesn't contain j.  Something's wrong; stop.
    call intpr("Adjacency list of i does not contain j.",-1,ndi,0)
    call rexit("Bailing out of pred.")
end subroutine pred

subroutine qtest(h,i,j,k,shdswp,x,y,ntot,eps)

! Test whether the LOP is satisified; i.e. whether vertex j
! is outside the circumcircle of vertices h, i, and k of the
! quadrilateral.  Vertex h is the vertex being added; i and k are
! the vertices of the quadrilateral which are currently joined;
! j is the vertex which is ``opposite'' the vertex being added.
! If the LOP is not satisfied, then shdswp ("should-swap") is true,
! i.e. h and j should be joined, rather than i and k.  I.e. if j
! is outside the circumcircle of h, i, and k then all is well as-is;
! *don't* swap ik for hj.  If j is inside the circumcircle of h,
! i, and k then change is needed so swap ik for hj.
! Called by swap.

implicit double precision(a-h,o-z)
dimension :: x(-3:ntot), y(-3:ntot)
dimension :: ndi(1)
integer :: h
logical :: shdswp

! Set dummy integer for call to intpr(...).
ndi(1) = 0

! Look for ideal points.
if(i<=0) then
    ii = 1
else
    ii = 0
endif

if(j<=0) then
    jj = 1
else
    jj = 0
endif

if(k<=0) then
    kk = 1
else
    kk = 0
endif
ijk = ii*4+jj*2+kk

! All three corners other than h (the point currently being
! added) are ideal --- so h, i, and k are co-linear; so 
! i and k shouldn't be joined, and h should be joined to j.
! So swap.  (But this can't happen, anyway!!!)
! case 7:
if(ijk==7) then
    shdswp = .true.
    return
endif

! If i and j are ideal, find out which of h and k is closer to the
! intersection point of the two diagonals, and choose the diagonal
! emanating from that vertex.  (I.e. if h is closer, swap.)
! Unless swapping yields a non-convex quadrilateral!!!
! case 6:
if(ijk==6) then
    xh = x(h)
    yh = y(h)
    xk = x(k)
    yk = y(k)
    ss = 1 - 2*mod(-j,2)
    test = (xh*yk+xk*yh-xh*yh-xk*yk)*ss
    if(test>0.d0) then
        shdswp = .true.
    else
        shdswp = .false.
    endif
! Check for convexity:
    if(shdswp) call acchk(j,k,h,shdswp,x,y,ntot,eps)
    return
endif

! Vertices i and k are ideal --- can't happen, but if it did, we'd
! increase the minimum angle ``from 0 to more than 2*0'' by swapping ...
!
! 24/7/2011 --- I now think that the forgoing comment is misleading,
! although it doesn't matter since it can't happen anyway.  The
! ``2*0'' is wrong.  The ``new minimum angle would be min(alpha,beta)
! where alpha and beta are the angles made by the line joining h
! to j with (any) line with slope = -1.  This will be greater than
! 0 unless the line from h to j has slope = - 1.  In this case h,
! i, j, and k are all co-linear, so i and k should not be joined
! (and h and j should be) so swapping is called for.  If h, i,
! j and j are not co-linear then the quadrilateral is definitely
! convex whence swapping is OK.  So let's say swap.
! case 5:
if(ijk==5) then
    shdswp = .true.
    return
endif

! If i is ideal we'd increase the minimum angle ``from 0 to more than
! 2*0'' by swapping, so just check for convexity:
! case 4:
if(ijk==4) then
    call acchk(j,k,h,shdswp,x,y,ntot,eps)
    return
endif

! If j and k are ideal, this is like unto case 6.
! case 3:
if(ijk==3) then
    xi = x(i)
    yi = y(i)
    xh = x(h)
    yh = y(h)
    ss = 1 - 2*mod(-j,2)
    test = (xh*yi+xi*yh-xh*yh-xi*yi)*ss
    if(test>0.d0) then
        shdswp = .true.
    else
        shdswp = .false.
    endif
! Check for convexity:
    if(shdswp) call acchk(h,i,j,shdswp,x,y,ntot,eps)
    return
endif

! If j is ideal we'd decrease the minimum angle ``from more than 2*0
! to 0'', by swapping; so don't swap.
! case 2:
if(ijk==2) then
    shdswp = .false.
    return
endif

! If k is ideal, this is like unto case 4.
! case 1:
if(ijk==1) then
    call acchk(h,i,j,shdswp,x,y,ntot,eps) ! This checks
                                          ! for convexity.
                                          ! (Was i,j,h,...)
    return
endif

! If none of the `other' three corners are ideal, do the Lee-Schacter
! test for the LOP.
! case 0:
if(ijk==0) then
    call qtest1(h,i,j,k,x,y,ntot,eps,shdswp)
    return
endif

! default:  ! This CAN'T happen!
call intpr("Indicator ijk is out of range.",-1,ndi,0)
call intpr("This CAN'T happen!",-1,ndi,0)
call rexit("Bailing out of qtest.")
end subroutine qtest

subroutine addpt(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)
! Add point j to the triangulation.
! Called by master, dirseg.

implicit double precision(a-h,o-z)
dimension :: nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
logical :: didswp

! Put the new point in, joined to the vertices of its
! enclosing triangle.
call initad(j,nadj,madj,x,y,ntot,eps,ntri,incAdj)

! Look at each `gap', i.e. pair of adjacent segments
! emanating from the new point; they form two sides of a
! quadrilateral; see whether the extant diagonal of this
! quadrilateral should be swapped with its alternative
! (according to the LOP: local optimality principle).
now = nadj(j,1)
nxt = nadj(j,2)
ngap = 0

do
    call swap(j,now,nxt,didswp,nadj,madj,x,y,ntot,eps,incAdj)
    n = nadj(j,0)
    if(.not.didswp) then  ! If no swap of diagonals
        now  = nxt    ! move to the next gap.
        ngap = ngap+1
    endif
    call succ(nxt,j,now,nadj,madj,ntot)
    if(ngap==n) exit
enddo
end subroutine addpt

prelimtlist <- function(object) {
#
# prelimtlist <--> "preliminary triangle list"
# The ("preliminary") matrix produced by this function may contain
# rows which are indices of the vertices of triangles which are
# formed by the union of three contiguous Delaunay triangles and
# which are not themselves Delaunay triangles.
#
stopifnot(inherits(object, "deldir"))
    a <- object$delsgs[, 5]
    b <- object$delsgs[, 6]
    prelist <- matrix(integer(0), 0, 3)
    for (i in seq(length.out=nrow(object$summary))) {
        jj <- c(b[a == i], a[b == i])
        jj <- sort(unique(jj))
        jj <- jj[jj > i]
        if (length(jj) > 0) {
            for (j in jj) {
                kk <- c(b[a == j], a[b == j])
                kk <- kk[(kk %in% jj) & (kk > j)]
                if (length(kk) > 0) {
                    for (k in kk) {
                        prelist <- rbind(prelist, c(i, j, k))
                    }
                }
            }
        }
    }
    prelist
}

subroutine adjchk(i,j,adj,nadj,madj,ntot)
# Check if vertices i and j are adjacent.
# Called by insrt, delet, trifnd, swap, delseg, dirseg.

dimension nadj(-3:ntot,0:madj)
logical adj
dimension ndi(1)

# Set dummy integer for call to intpr(...).
ndi(1) = 0

# Check if j is in the adjacency list of i.
adj = .false.
ni  = nadj(i,0)
if(ni>0) {
    do k = 1,ni {
        if(j==nadj(i,k)) {
            adj = .true.
            break
        }
    }
}

# Check if i is in the adjacency list of j.
nj = nadj(j,0)
if(nj>0) {
    do k = 1,nj {
        if(i==nadj(j,k)) {
            if(adj) {
                return # Have j in i's list and i in j's.
            } else {
                call intpr("Contradictory adjacency lists.",-1,ndi,0)
                call rexit("Bailing out of adjchk.")
            }
        }
    }
}

# If we get to here i is not in j's list.
if(adj) { # If adj is true, then j IS in i's list.
    call intpr("Contradictory adjacency lists.",-1,ndi,0)
    call rexit("Bailing out of adjchk.")
}

return
end

C Output from Public domain Ratfor, version 1.03
      subroutine master(x,y,rw,npd,ntot,nadj,madj,eps,delsgs,ndel,delsum
     *, dirsgs,ndir,dirsum,incadj,incseg)
      implicit double precision(a-h,o-z)
      dimension x(-3:ntot), y(-3:ntot)
      dimension nadj(-3:ntot,0:madj)
      dimension rw(4)
      dimension delsgs(6,ndel), dirsgs(10,ndir)
      dimension delsum(npd,4), dirsum(npd,3)
      one = 1.d0
      do23000 i = -3,ntot 
      nadj(i,0) = 0
      do23002 j = 1,madj 
      nadj(i,j) = -99
23002 continue
23003 continue
23000 continue
23001 continue
      x(-3) = -one
      y(-3) = one
      x(-2) = one
      y(-2) = one
      x(-1) = one
      y(-1) = -one
      x(0) = -one
      y(0) = -one
      do23004 i = 1,4 
      j = i-4
      k = j+1
      if(k.gt.0)then
      k = -3
      endif
      call insrt(j,k,nadj,madj,x,y,ntot,eps,incadj)
      if(incadj.eq.1)then
      return
      endif
23004 continue
23005 continue
      do23010 i = 1,4 
      j = i-4
      call insrt(1,j,nadj,madj,x,y,ntot,eps,incadj)
      if(incadj.eq.1)then
      return
      endif
23010 continue
23011 continue
      ntri = 4
      do23014 j = 2,npd 
      call addpt(j,nadj,madj,x,y,ntot,eps,ntri,incadj)
      if(incadj.eq.1)then
      return
      endif
      ntri = ntri + 3
23014 continue
23015 continue
      call delseg(delsgs,ndel,nadj,madj,npd,x,y,ntot,incseg)
      if(incseg.eq.1)then
      return
      endif
      call delout(delsum,nadj,madj,x,y,ntot,npd)
      call dirseg(dirsgs,ndir,nadj,madj,npd,x,y,ntot,rw,eps,ntri,incadj,
     *incseg)
      if(incadj.eq.1 .or. incseg.eq.1)then
      return
      endif
      call dirout(dirsum,nadj,madj,x,y,ntot,npd,rw,eps)
      return
      end

subroutine crossutil(i,j,k,x,y,ntot,eps,collin)
implicit double precision(a-h,o-z)
dimension x(-3:ntot), y(-3:ntot)
dimension xt(3), yt(3)
logical collin

xt(1) = x(i)
yt(1) = y(i)
xt(2) = x(j)
yt(2) = y(j)
xt(3) = x(k)
yt(3) = y(k)

# Create indicator telling which of i, j, and k are ideal points.
# The point being added, i, is never ideal.
i1 = 0
if(j<=0) j1 = 1
else j1 = 0
if(k<=0) k1 = 1
else k1 = 0
ijk = i1*4+j1*2+k1

call cross(xt,yt,ijk,cprd)
collin = (abs(cprd) < eps)
return
end

subroutine delout(delsum,nadj,madj,x,y,ntot,npd)

# Put a summary of the Delaunay triangles with a vertex at point i,
# for i = 1, ..., npd, into the array delsum.  Do this in the original
# order of the points, not the order into which they have been
# bin-sorted.
# Called by master.

implicit double precision(a-h,o-z)
dimension nadj(-3:ntot,0:madj), x(-3:ntot), y(-3:ntot)
dimension delsum(npd,4)

do i = 1,npd {
    area = 0.   # Initialize area of polygon consisting of triangles
                # with a vertex at point i.
# Get the coordinates of the point and the number of
# (real) triangles emanating from it.
    np = nadj(i,0)
    xi = x(i)
    yi = y(i)
    npt = np
    do k = 1,np {
        kp = k+1
        if(kp>np) kp = 1
        if(nadj(i,k)<=0|nadj(i,kp)<=0) npt = npt-1
    }

# For each point in the adjacency list of point i, find its
# successor, and the area of the triangle determined by these
# three points.
    do j1 = 1,np {
        j = nadj(i,j1)
        if(j<=0) next
        xj = x(j)
        yj = y(j)
        call succ(k,i,j,nadj,madj,ntot)
        if(k<=0) next
        xk = x(k)
        yk = y(k)
        call triar(xi,yi,xj,yj,xk,yk,tmp)
# Downweight the area by 1/3, since each
# triangle eventually appears 3 times over.
        area = area+tmp/3.
    }
    delsum(i,1) = xi
    delsum(i,2) = yi
    delsum(i,3) = npt
    delsum(i,4) = area
}

return
end

C Output from Public domain Ratfor, version 1.03
      subroutine succ(ksc,i,j,nadj,madj,ntot)
      implicit double precision(a-h,o-z)
      dimension nadj(-3:ntot,0:madj)
      dimension ndi(1)
      ndi(1) = 0
      n = nadj(i,0)
      if(n.eq.0)then
      call intpr("Adjacency list of i is empty, and so cannot contain j.
     *",-1,ndi,0)
      call rexit("Bailing out of succ.")
      endif
      do23002 k = 1,n 
      if(j.eq.nadj(i,k))then
      kp = k+1
      if(kp.gt.n)then
      kp = 1
      endif
      ksc = nadj(i,kp)
      return
      endif
23002 continue
23003 continue
      ndi(1) = i
      call intpr("i =",-1,ndi,1)
      ndi(1) = j
      call intpr("j =",-1,ndi,1)
      call intpr("Adjacency list of i does not contain j.",-1,ndi,0)
      call rexit("Bailing out of succ.")
      end

subroutine binsrt(x,y,rw,npd,ind,rind,tx,ty,ilst)
# Sort the data points into bins.
# Called by master.

implicit double precision(a-h,o-z)
dimension x(npd), y(npd), tx(npd), ty(npd)
integer rind(npd)
dimension ind(npd), ilst(npd)
dimension rw(4)
dimension ndi(1)

# Set dummy integer for call to intpr(...).
ndi(1) = 0

kdiv   = int(1+dble(npd)**0.25) # Round high.
xkdiv  = dble(kdiv)

# Dig out the corners of the rectangular window.
xmin = rw(1)
xmax = rw(2)
ymin = rw(3)
ymax = rw(4)

w = xmax-xmin
h = ymax-ymin

# Number of bins is to be approx. sqrt(npd); thus number of subdivisions
# on each side of rectangle is approx. npd**(1/4).
dw  = w/xkdiv
dh  = h/xkdiv

# The width of each bin is dw; the height is dh.  We shall move across
# the rectangle from left to right, then up, then back from right to
# left, then up, ....  Note that kx counts the divisions from the left,
# ky counts the divisions from the bottom; kx is incremented by ink, which
# is +/- 1 and switches sign when ky is incremented; ky is always
# incremented by 1.
kx   = 1
ky   = 1
ink  = 1
k    = 0
do i = 1,npd { ilst(i) = 0 } # Keeps a list of those points already added
while(ky<=kdiv) {            # to the new list.
    do i = 1,npd {
        if(ilst(i)==1) next  # The i-th point has already been added
                             # to the new list.
# If the i-th point is in the current bin, add it to the list.
        xt = x(i)
        yt = y(i)
        ix = int(1+(xt-xmin)/dw)
        if(ix>kdiv) ix = kdiv
        jy = int(1+(yt-ymin)/dh)
        if(jy>kdiv) jy = kdiv
        if(ix==kx&jy==ky) {
            k = k+1
            ind(i)  = k  # Index i is the pos'n. of (x,y) in the
            rind(k) = i  # old list; k is its pos'n. in the new one.
            tx(k)   = xt
            ty(k)   = yt
            ilst(i) = 1  # Cross the i-th point off the old list.
        }
    }
# Move to the next bin.
    kc = kx+ink
    if((1<=kc)&(kc<=kdiv)) kx = kc
    else {
        ky  = ky+1
        ink = -ink
    }
}

# Check that all points from old list have been added to the new,
# with no spurious additions.
if(k!=npd) {
    call intpr("Mismatch between number of points",-1,ndi,0)
    call intpr("and number of sorted points.",-1,ndi,0)
    call rexit("Bailing out of binsrt.")
}

# Copy the new sorted vectors back on top of the old ones.
do i = 1,npd {
    x(i)   = tx(i)
    y(i)   = ty(i)
}

return
end

\name{niProperties}
\alias{niProperties}
\docType{data}
\title{
    Northern Ireland properties.
}
\description{
    The locations (in longitude and latitude) of a number of properties
    (land holdings) in Northern Ireland.
}
\usage{data("niProperties")}
\format{
  A data frame with 240 observations on the following 2 variables.
  \describe{
    \item{\code{x}}{A numeric vector of longitudes.}
    \item{\code{y}}{A numeric vector of latitudes.}
  }
}
\source{
   These data were kindly provided by Adam Dadvar of the
   \emph{Cartesian Limited} consulting service.\cr
    URL: \code{http://www.cartesian.com}.
}
\examples{
# data(niProperties)
# It is unnecessary to use \code{data} since \code{niProperties} is
# a "first class object".  It is "lazily loaded".
plot(niProperties)
}
\keyword{datasets}

\name{triang.list}
\alias{triang.list}
\title{
  Create a list of Delaunay triangles
}
\description{
  From an object of class \dQuote{deldir} produces a list
  of the Delaunay triangles in the triangulation of a set
  of points in the plane.
}
\usage{
triang.list(object)
}
\arguments{
  \item{object}{
  An object of class \dQuote{deldir} as produced by \code{\link{deldir}()}.
}
}
\value{
  A list each of whose components is a \eqn{3 \times 3}{3 x 3} or
  \eqn{3 \times 4}{3 x 4} data frame corresponding to one of the
  Delaunay triangles specified by \dQuote{object}.  The rows of each
  such data frame correspond to the vertices of the corresponding
  Delaunay triangle. The columns are:
  \itemize{
  \item \code{ptNum} (the index of the point in the original sequence
  of points that is being triangulated.  Note that if a point is
  one of a set of \emph{duplicated} points then \code{ptNum} is
  the \emph{first} of the indices of the points in this set.)
  \item \code{x} (the \eqn{x}-coordinate of the vertex)
  \item \code{y} (the \eqn{y}-coordinate of the vertex)
  \item \code{z} (the \dQuote{auxiliary value} or \dQuote{tag}
  \code{z} associated with the vertex; present only if such values
  were supplied in the call to \code{deldir()})
  }

  The returned value has an attribute \dQuote{rw} consisting of the
  enclosing rectangle of the triangulation.
}
\author{\rolf}
\section{Warning}{
  There may not actually \bold{be} any triangles determined by
  \code{object}, in which case this function returns an empty
  list with an \code{"rw"} attribute.  See \bold{Examples}. 
}
\note{
   The code of this function was taken more-or-less directly
   from code written by Adrian Baddeley for the \dQuote{delaunay()}
   function in the \dQuote{spatstat} package.
}
\seealso{ \code{\link{deldir}()}, \code{\link{plot.triang.list}()},
          \code{\link{tile.list}()}, \code{\link{plot.tile.list}()} }

\examples{
set.seed(42)
x  <- runif(20)
y  <- runif(20)
z  <- sample(1:100,20)
d1 <- deldir(x,y,z=z)
t1 <- triang.list(d1)
# A "triangulation" with no triangles!
d2 <- deldir(x=1:10,y=11:20)
plot(d2)
t2 <- triang.list(d2)
plot(t2,showrect=TRUE,rectcol="blue") # Pretty boring!
}
\keyword{spatial}

\name{tileArea}
\alias{tileArea}
\title{
    Area of a Dirichlet tile.
}
\description{
    Calculates the area of a Dirichlet tile, applying a discrete
    version of Stoke's theorem.
}
\usage{
tileArea(x, y, rw)
}
\arguments{
  \item{x}{
  The \code{x}-coordinates of the vertices of the tile, in
  \bold{anticlockwise} direction.   The last coordinate should
  \bold{not} repeat the first.
}
  \item{y}{
  The \code{y}-coordinates of the vertices of the tile, in
  \bold{anticlockwise} direction.   The last coordinate should
  \bold{not} repeat the first.
}
  \item{rw}{
  A vector of length 4 specifying the rectangular window in
  which the relevant tessellation was constructed.  See
  \code{\link{deldir}()} for more detail.  Actually this
  can be any rectangle containing the tile in question.
}
}
\details{
  The heavy lifting is done by the Fortran subroutine \code{stoke()}
  which is called by the \code{.Fortran()} function.
}
\value{
  A positive scalar.
}
\author{\rolf}

\seealso{
  \code{\link{deldir}()}
  \code{\link{tilePerim}()}
}
\examples{
set.seed(42)
x <- runif(20)
y <- runif(20)
z <- deldir(x,y,rw=c(0,1,0,1))
w <- tile.list(z)
with(w[[1]],tileArea(x,y,rw=z$rw))
sapply(w,function(x,rw){tileArea(x$x,x$y,attr(w,"rw"))})
x <- c(0.613102,0.429294,0.386023,0.271880,0.387249,0.455900,0.486101)
y <- c(0.531978,0.609665,0.597780,0.421738,0.270596,0.262953,0.271532)
# The vertices of the Dirichlet tile for point 6.
tileArea(x,y,rw=c(0,1,0,1))
tileArea(x,y,rw=c(-1,2,-3,4)) # Same as above.
}

\keyword{ utilities }

\name{grapherXmpl}
\alias{grapherXmpl}
\docType{data}
\title{
    grapherXmpl
}
\description{
    A data set taken from an example in the grapherator package.
    This data set demonstrates handling a data set with duplicated
    points.
}
\usage{grapherXmpl}
\format{
  A data frame with 250 observations on the following 2 variables.
  \describe{
    \item{\code{x}}{a numeric vector}
    \item{\code{y}}{a numeric vector}
  }
}
\details{
    There are 25 duplicated points, so the net number of
    observations is 225.  These data constitute a structure (named
    \code{coordinates}) generated internally in the function
    \code{addEdgesDelaunay}.  The call is to be found in the
    examples in the help file for the \code{plot.grapherator()}
    in the \code{grapherator} package.  The relevant example
    initially threw an error, revealing a bug in \code{deldir()}
    that was triggered when there were duplicated points in the data.
}
\source{
    The \code{grapherator} package,
    \url{https://CRAN.R-project.org/package=grapherator}
}
\examples{
dgX <- deldir(grapherXmpl) # Now works!!!`
}
\keyword{datasets}

\name{deldir-internal}
\alias{[.tile.list}
\alias{[.triang.list}
\alias{acw}
\alias{binsrtR}
\alias{doClip}
\alias{findNewInOld}
\alias{get.cnrind}
\alias{getCol}
\alias{insidePoly}
\alias{insideRect}
\alias{mid.in}
\alias{mnndR}
\alias{prelimtlist}
\alias{tilePerim0}
\alias{verGetter}
\title{Internal deldir functions}
\description{
  Internal deldir functions.
}
\usage{
\method{[}{tile.list}(x,i,\dots)
\method{[}{triang.list}(x,i,\dots)
acw(xxx)
doClip(object,clipp,rw)
binsrtR(x,y,rw)
findNewInOld(xnew,xold,ynew,yold,tolerance=sqrt(.Machine$double.eps))
get.cnrind(x,y,rw)
getCol(x,warn=FALSE)
insidePoly(x,y,pgon,sanityCheck=FALSE,tolerance=sqrt(.Machine$double.eps))
insideRect(x,y,rect,rw)
mid.in(x,y,rx,ry)
mnndR(x,y)
prelimtlist(object)
tilePerim0(object,inclbdry=TRUE)
verGetter()
}
\details{
  These functions are auxiliary and are not intended to be called by
  the user.
}
\keyword{internal}

\name{plot.divchain}
\alias{plot.divchain}
\title{
   Plot a dividing chain.
}
\description{
   Plot the dividing chain of a Dirichlet tessellation.
   The tessellation must have been created from a set of points
   having associated categorical \dQuote{tags}.  The dividing
   chain consists of those edges of Dirichlet tiles which separate
   points having different values of the given tags.
}
\usage{
   \method{plot}{divchain}(x, add = FALSE, ...)
}
\arguments{
  \item{x}{
     An object of class \dQuote{divchain}.  See \code{\link{divchain.deldir}()}
     for details.
}
  \item{add}{
     Logical scalar.  It \code{add=TRUE} the plot of the dividing chain
     is added to an existing plot.
}
  \item{\dots}{
     Graphical parameters such as \code{main}, \code{xlab}, \code{col.main},
     \code{col.lab}.  In particular if \code{bty} is supplied
     (as a value other than \code{n}) a \dQuote{box} will be drawn
     around the plot that is formed when \code{add=FALSE}.
     Also a non-standard graphical parameter \code{boxcol} may be supplied
     which will be taken to be the colour with which the box is drawn.
     If a \code{col} argument is supplied, this determines the colour
     for plotting the segments constituting the dividing chain.
}
}
\value{
   None.
}
\author{\rolf}
\note{
  This function was created in response to a question asked
  on \code{stackoverflow.com} by a user named \dQuote{Dan}.
}

\seealso{
  \code{\link{divchain}()} \code{\link{divchain.default}()}
  \code{\link{divchain.deldir}()} \code{\link{deldir}()}
}
\examples{
   set.seed(42)
   x   <- runif(50)
   y   <- runif(50)
   z   <- factor(kmeans(cbind(x,y),centers=4)$cluster)
   dc  <- divchain(x,y,z,rw=c(0,1,0,1))
   plot(dc,lwd=2,col="blue",bty="o")
}
\keyword{ spatial }

\name{toyPattern}
\alias{toyPattern}
\docType{data}
\title{
    A toy marked point pattern object, with 59 points.
}
\description{
    A simulated object of class \code{"ppp"} provided for use
    in an example illustrating the application of \code{deldir()}
    to point pattern objects. 
}
\usage{toyPattern}
\format{
  An object of class \code{"ppp"} consisting of a simulated marked
  point pattern.  Entries include
  \tabular{ll}{
    \code{x} \tab Cartesian \eqn{x}-coordinates \cr
    \code{y} \tab Cartesian \eqn{y}-coordinates \cr
    \code{marks} \tab factor with levels \code{"a","b","c","d"}
    }
}
\source{ Simulated.  }
\examples{
dtoy    <- deldir(toyPattern) # "Tags" are the marks of the pattern.
set.seed(42)
dtoy.nt <- deldir(toyPattern,z=round(runif(59),2)) # Tags are numeric.
}
\keyword{datasets}

\name{getNbrs}
\alias{getNbrs}
\title{
   List Delaunay neighbours.
}
\description{
   Lists the indices (or identifiers if these are provided) of the
   Delaunay neighbours of each point in the set of points being
   triangulated/tessellated.
}
\usage{
getNbrs(object, interior = NULL)
}
\arguments{
  \item{object}{
  An object of class \code{"deldir"}, as returned by the function
  \code{deldir()}.
}
  \item{interior}{
  Either a rectangle, i.e. a numeric vector of length 4,
  \code{(xmin,xmax,ymin,ymax)}, or a polygon (a list with components
  named \code{"x"} and \code{"y"}, which are numeric vectors
  of equal length, say \code{n}.  The pairs \code{(x[i],y[i])}
  specify the vertices of the polygon and should be presented in
  \emph{anticlockwise} order.  The last vertex should \bold{NOT}
  repeat the first.

  If \code{interior} is given as a rectangle, its entries must
  satisfy \code{xmin < xmax} and \code{ymin < ymax}.  Moreover,
  in this case, \code{interior} must be a subset of the rectangular
  window \code{rw} (see \code{\link{deldir}()}) with respect to
  which the points in question are being triangulated/tessellated.
  That is, its entries must satisfy \code{rw[1] <= xmin}, \code{xmax <= rw[2]},
  \code{rw[3] <= ymin} and \code{ymax <= rw[4]}.
}
}
\details{
  If \code{interior} is specified then Delaunay neighbours are listed
  only for those points which lie in \code{interior}.  Note that
  these \emph{neighbours} need not themselves lie in \code{interior}.

  Note also that it is possible for points \code{i} and \code{j} to
  be neighbours even though the \dQuote{clipped} versions of the tiles
  are discontiguous.
}

\value{
  A (named) list of length equal to the number points in the set
  being triangulated/tessellated, or to the number of such points that
  lie in \code{interior} if that argument was specified.  The names
  of the list are the identifiers of the points as specified by
  \code{id} if \code{id} was specified in the call to \code{deldir()}
  that produced \code{object}.  If \code{id} was not specified, then
  the names are the indices of the points, coerced to character mode.

  The entries of this list are vectors of the identifiers or
  indices of the Delaunay neighbours of the point corresponding to
  that entry.
}
\references{
  See \code{\link{deldir}()} for references.
}
\author{\rolf}
\section{Warning}{
Be careful about addressing the entries of the list returned
by this function.  If \code{id} was not specified in the call
to \code{deldir()} that produced \code{object}, then the names
of this list are the point indices coerced to character mode.
If \code{interior} was specified then the name of \eqn{i}-th entry
of the list will not in general be \code{i}.  E.g. given that
\code{xxx} is the list returned by this function, \code{xxx[[14]]}
will \bold{not} in general give the Delaunay neighbours of point 14.
Instead, specify \code{xxx[["14"]]} or \code{xxx[[id[14]]]} where
\code{id} is the vector of identifiers supplied in the call to
\code{deldir()}.
}

\examples{
set.seed(42)
x <- runif(60)
y <- runif(60)
dxy <- deldir(x,y,rw=c(0,1,0,1))
nbrs <- getNbrs(dxy,interior=c(0.2,0.8,0.2,0.8))
nbrs[["14"]] # Correct.
nbrs[[14]]   # Incorrect.
names(nbrs)[14] # The result is 42.
# Thus nbrs[[14]] actually gives the Delaunay neighbours of point 42.

# Demonstrate that neighbours can have discontiguous clipped tiles.
if(require(polyclip)) {
    x <- c(0.38,0.44,0.04,0.97,0.43,0.96,0.89,0.64,0.97,0.62,0.33,0.35,
           0.40,0.78,0.04,0.75,0.68,0.17,0.26,0.51)
    y <- c(0.68,0.98,0.76,0.57,0.85,0.19,0.27,0.83,0.69,0.24,0.04,0.14,
           0.22,0.48,0.20,0.72,0.01,0.38,0.51,0.00)
    CP <- list(x=c(0.72,0.93,0.76,0.61,-0.03,-0.04,0.41),
               y=c(0.46,0.76,0.94,1.03,1.01,0.37,0.31))
    dxy <- deldir(x,y,rw=c(0,1,0,1))
    TL <- tile.list(dxy)
    plot(TL,labelPts=TRUE)
    plot(TL[16],clipp=CP,fillcol="orange",labelPts=TRUE,add=TRUE)
    polygon(CP,border="red")
    nbrs <- getNbrs(dxy,interior=CP) # Tiles are clipped to CP.
# Note that point 14 is a neighbour of point 16, even though their
# clipped tiles do not meet.
}
}
\keyword{ spatial }

\name{triMat}
\alias{triMat}
\title{
  Produce matrix of triangle vertex indices.
}
\description{
  Lists the indices of the vertices of each Delaunay triangle in
  the triangulation of a planar point set.  The indices are listed
  (in increasing numeric order) as the rows of an \eqn{n \times 3}{n x 3}
  matrix where \eqn{n} is the number of Delaunay triangles in the
  triangulation.
}

\usage{
triMat(object)
}
\arguments{
  \item{object}{
  An object of class \code{deldir} (as produced by the function
  \code{\link{deldir}()}) specifying the Delaunay triangulation
  and Dirichlet (Voronoi) tessellation of a planar point set.
}
}
\details{
  This function was suggested by Robin Hankin of the School of
  Mathematical and Computing Sciences at Auckland University of
  Technology.
}
\value{
  An \eqn{n \times 3}{n x 3} matrix where \eqn{n} is the number
  of Delaunay triangles in the triangulation specified by \code{object}.
  The \eqn{i^{th}}{i-th} row consists of the indices (in the original
  list of points being triangulated) of vertices of the \eqn{i^{th}}{i-th}
  Delaunay triangle.  The indices are listed in increasing numeric
  order in each row.
}
\section{Note}{
  Earlier versions of this function (prior to release 0.1-14
  of \bold{deldir}) could sometimes give incorrect results.
  This happened if the union of three contiguous Delaunay triangles
  happened to constitute another triangle.  This latter triangle
  would appear in the list of triangles produced by \code{triMat()}
  but is \emph{not} itself a Delaunay triangle.  The updated version
  of \code{triMat()} now checks for this possibility and gives
  (\emph{I think!}) correct results.

  Many thanks to Jay Call, who pointed out this bug to me.
}

\author{\rolf}
\seealso{ \code{\link{deldir}()}
          \code{\link{triang.list}()}
	  \code{\link{plot.triang.list}()}
}
\examples{
# These are the data used by Jay Call to illustrate the bug
# that appeared in a previous incarnation of triMat.
xy <- data.frame(
          x = c(0.048,0.412,0.174,0.472,0.607,0.565,0.005,0.237,0.810,0.023),
          y = c(0.512,0.928,0.955,0.739,0.946,0.134,0.468,0.965,0.631,0.782)
      )
dxy <- deldir(xy)
M   <- triMat(dxy)
plot(dxy,wlines="triang",num=TRUE,axes=FALSE,cmpnt_col=c(1,1,1,1,2,1))
# The triangle with vertices {4,5,8} was listed in the output of
# the previous (buggy) version of triMat().  It is NOT a Delaunay
# triangle and hence should NOT be listed.
}
\keyword{spatial}

\name{tilePerim}
\alias{tilePerim}
\title{
   Calculate tile perimeters.
}
\description{
   Calculates the perimeters of all of the Dirichlet (Voronoi)
   tiles in a tessellation of a set of planar points.  Also
   calculates the sum and the mean of these perimeters.
}
\usage{
tilePerim(object,inclbdry=TRUE)
}
\arguments{
  \item{object}{
  An object of class \code{tile.list} (as produced by
  \code{\link{tile.list}()} specifying the Dirichlet (Voronoi)
  tiles in a tessellation of a set of planar points.
}
  \item{inclbdry}{
  Logical scalar.  Should boundary segments (edges of tiles
  at least one of whose endpoints lies on the enclosing
  rectangle \code{rw} (see \code{\link{deldir}()}) be included
  in the perimeter?
}
}
\value{
   A list with components
   \item{perimeters}{
   A vector consisting of the values of the perimeters of
   the Dirichlet tiles in the tessellation.
   }
   \item{totalPerim}{
   The sum of \code{perimeters}.
   }
   \item{meanPerim}{
   The mean of \code{perimeters}.
   }
   \item{perComps}{
   A list whose entries are vectors consisting of the \dQuote{components} of the
   perimeters of each tile.  If/when the tiles are clipped, some
   tiles may be subdivided by the clipping into discontiguous parts.  The
   components referred to above are the perimeters of this parts.  If no
   subdivision has occurred then the vector in question has a single entry
   equal to the perimeter of the corresponding tile.  If subdivision has
   occurred then the perimeter of the tile is the sum of the perimeters
   of the components.
}
}
\author{\rolf}
\note{
   Function added at the request of Haozhe Zhang.
}

\seealso{
  \code{\link{tile.list}()}, \code{\link{plot.tile.list}()}
}
\examples{
    x <- runif(20)
    y <- runif(20)
    z <- deldir(x,y,rw=c(0,1,0,1))
    w <- tile.list(z)
    p1 <- tilePerim(w)
    p0 <- tilePerim(w,inclbdry=FALSE)
    p1$totalPerim - p0$totalPerim # Get 4 = the perimeter of rw.
    ss <- apply(as.matrix(z$dirsgs[,1:4]),1,
                function(x){(x[1]-x[3])^2 + (x[2]-x[4])^2})
    2*sum(sqrt(ss)) - p0$totalPerim # Get 0; in tilePerim() each interior
                                    # edge is counted twice.
    if(require(polyclip)) {
        CP <- list(x=c(0.49,0.35,0.15,0.20,0.35,0.42,
                       0.43,0.62,0.46,0.63,0.82,0.79),
                   y=c(0.78,0.86,0.79,0.54,0.58,0.70,
                       0.51,0.46,0.31,0.20,0.37,0.54))
        wc <- tile.list(z,clipp=CP)
        p2 <- tilePerim(wc) # Doesn't matter here if inclbdry is TRUE or FALSE.
        p2$perComps[["pt.6"]] # The tile for point 6 has got subdivided into
                              # two parts, a tetrahedron and a triangle.
        cul <- rainbow(10)[c(1,7,3:6,2,8:10)] # Rearranging colours to improve
                                              # the contrast between contiguous tiles.
        plot(wc,labelPts=TRUE,fillcol=cul)
    }
}
\keyword{spatial}

\name{plot.deldir}
\alias{plot.deldir}
\title{
Plot objects produced by deldir
}
\description{
This is a method for plot.
}
\usage{
\method{plot}{deldir}(x,add=FALSE,wlines=c("both","triang","tess"),
                      showpoints=TRUE,labelPts=FALSE,cex=1,lex=1,
                      cmpnt_col=NULL,cmpnt_lty=NULL,pch=1,xlim=NULL,
                      ylim=NULL,axes=FALSE,xlab=if(axes) "x" else "",
                      ylab=if(axes) "y" else"",showrect=FALSE,asp=1,...)
}
\arguments{
\item{x}{
An object of class "deldir" as returned by the function deldir.
}
\item{add}{
logical argument; should the plot be added to an existing plot?
}
\item{wlines}{
"which lines?".  I.e.  should the Delaunay triangulation be plotted
(wlines="triang"), should the Dirichlet tessellation be plotted
(wlines="tess"), or should both be plotted (wlines="both", the
default) ?
}
\item{showpoints}{
Logical scalar; should the points being triangulated/tessellated
be plotted?
}
\item{labelPts}{
Logical argument, defaulting to \code{FALSE}; if \code{TRUE} then the
points plotted will be labelled with their identifiers (as specified
by the optional argument \code{id} of \code{deldir()}.  If \code{id}
was not specified to \code{deldir()}, then the identifiers default
to the indices of the points, which correspond to the row numbers
of the matrix "summary" in the output of \code{deldir()}).
}
\item{cex}{
The value of the character expansion argument cex to be used
with the plotting symbols for plotting the points.
}
\item{lex}{
The value of the character expansion argument cex to be used by the
text function when labelling the points with their identifiers.  Used only
if \code{labelPts} is \code{TRUE}.
}
\item{cmpnt_col}{
A vector or list specifying the colours to be used for plotting
the (up to five) different components of the graphic, explicitly the
triangulation, the tessellation, the data points,
the point labels and the enclosing rectangle (\code{x$rw}) in that
order.  The components of this vector or list may be named, with the
names chosen from \code{"tri","tess","points","labels","rect".}
The default is \code{c(tri=1,tess=1,points=1,labels=1,rect=1)}.
If the vector or list is not named, the component names are assumed
to be from the default list of names in the given order.

Colours may be specified as positive integers, corresponding to
the entries of the current \code{\link{palette}()}, or as names of
colours (from the list given by \code{\link{colors}()}), or  in terms
of their RGB components with strings of the form \code{"#RRGGBB"}.
(See \bold{Color Specification} in \code{\link{par}()}.)

If fewer than five colours are given, the missing components are
filled in with \code{1} or \code{palette()[1]} as is appropriate.
If \code{cmpnt_col} does not have names then the components are
simply recycled.  If more than five colours are given, the redundant
ones are ignored (i.e. only the first five are used).
}
\item{cmpnt_lty}{
A vector or list (of length two) of line types for plotting
the two components of the graphic that consist of lines,
i.e. the triangulation and the tessellation.  The types may
consist of integers between 1 and 6, or of approriate text
strings ("solid", "dashed", "dotted", "dotdash", "longdash" or
"twodash"; see the discussion of \code{lty} in \code{\link{par}()}).
The components of \code{cmpnt_lty} (vector or list) may have names
(\code{"tri","tess"}).  The default is c(tri=1,tess=2).  If a
single value is given, the missing one is filled in as \code{1} or
\code{"solid"} as is appropriate.  If more than two values are given,
the redundant ones are ignored, i.e. only the first two are used.
}
\item{pch}{
The plotting symbol for plotting the points.  May be either
integer or character.
}
\item{xlim}{
The limits on the x-axis.  Defaults to \code{rw[1:2]} where \code{rw} is the
rectangular window specification returned by deldir().
}
\item{ylim}{
The limits on the y-axis.  Defaults to \code{rw[3:4]} where \code{rw} is the
rectangular window specification returned by deldir().
}
\item{axes}{
Logical scalar.  Should axes be drawn on the plot?
}
\item{xlab}{
Label for the x-axis.  Defaults to \code{x} if \code{axes} is
\code{TRUE} and to the empty string if \code{axes} is \code{FALSE}.
Ignored if \code{add=TRUE}.
}
\item{ylab}{
Label for the y-axis.  Defaults to \code{y} if \code{axes} is
\code{TRUE} and to the empty string if \code{axes} is \code{FALSE}.
Ignored if \code{add=TRUE}.
}
\item{showrect}{
Logical scalar; show the enclosing rectangle \code{rw} (see
\code{\link{deldir}()}) be plotted? }
\item{asp}{
The aspect ratio of the plot; integer scalar or \code{NA}.  Set this
argument equal to \code{NA} to allow the data to determine the aspect
ratio and hence to make the plot occupy the complete plotting region
in both \code{x} and \code{y} directions.  This is inadvisable;
see the \bold{Warning}.  The \code{asp} argument is ignored if
\code{add} is \code{TRUE}.
}
\item{...}{
Further plotting parameters (e.g. \code{lw}, \code{col}) to be passed
to \code{segments()}.  (Conceivably one might also use \code{...}
to supply additional arguments to be passed to \code{points()}
or \code{text()} but this is unlikely.)  Note that if \code{col}
is specified as one of the \code{...} arguments then this is used
as the \code{col} argument of \code{segments} (and the values of
\code{cmpnt_col[1:2]} are ignored.
}
}
\section{Side Effects}{
A plot of the edges of the Delaunay triangles and/or of the Dirichlet
tiles is produced or added to an existing plot.  By default the
triangles are plotted with solid lines (lty=1) and the tiles with
dotted lines (lty=2).  In addition the points
being triangulated may be plotted.
}
\section{Warnings}{
\itemize{
  \item As of release 1.0-8 the argument \code{number} of
  \code{\link{plot.deldir}()} and \code{\link{plot.tile.list}()}
  was changed to \code{labelPts}.  As a consequence the argument
  \code{nex} of this function has had its name changed to
  \code{lex}.

  \item In previous versions of the \code{deldir} package, the aspect
  ratio was not set.  Instead, the shape of the plotting region was
  set to be square (\code{pty="s"}).  This practice was suboptimal.
  To reproduce previous behaviour set \code{asp=NA} (and possibly
  \code{pty="s"}) in the call to \code{plot.deldir()}.  Users, unless
  they \emph{really} understand what they are doing and why they are
  doing it, are now \emph{strongly advised} not to set the value of
  \code{asp} but rather to leave \code{asp} equal to its default value
  of \code{1}.  Any other value may distort the tessellation and destroy
  the perpendicular appearance of lines which are indeed perpendicular.
  (And conversely may cause lines which are not perpendicular to
  appear as if they are.)
}
}
\seealso{ \code{\link{deldir}()} }
\author{\rolf}
\examples{
x <- c(2.3,3.0,7.0,1.0,3.0,8.0) + 0.5
y <- c(2.3,3.0,2.0,5.0,8.0,9.0) + 0.5
x <- c(x,1,10,10,1)
y <- c(y,1,1,10,10)
dxy <- deldir(x,y,rw=c(0,11,0,11))
plot(dxy)

# Plots the tessellation, but does not save the results:
deldir(x,y,rw=c(0,11,0,11),plot=TRUE,
       wl="tess",cmpnt_col=c(1,1,2,3,4),labelPts=TRUE)

# Plots the triangulation, but not the tessellation or the points,
# and saves the returned structure:

dxy <- deldir(x,y,rw=c(0,11,0,11),plot=TRUE,wl="triang",wp="none")

# Plot everything:
plot(dxy,cmpnt_col=c("orange","green","red","blue","black"),cmpnt_lty=1,
     labelPts=TRUE,lex=1.5,pch=c(19,9),showrect=TRUE,axes=TRUE)

# Complicated example from He Huang:
# "Linguistic distances".
vldm <- c(308.298557,592.555483,284.256926,141.421356,449.719913,
          733.976839,591.141269,282.842712,1.414214,732.562625)
ldm <- matrix(nrow=5,ncol=5)
ldm[row(ldm) > col(ldm)]  <- vldm
ldm[row(ldm) <= col(ldm)] <- 0
ldm <- (ldm + t(ldm))/2
rownames(ldm) <- LETTERS[1:5]
colnames(ldm) <- LETTERS[1:5]

# Data to be triangulated.
id <- c("A","B","C","D","E")
x  <- c(0.5,1,1,1.5,2)
y  <- c(5.5,3,7,6.5,5)
dat_Huang <- data.frame(id = id, x = x, y = y)

# Form the triangulation/tessellation.
dH <- deldir(dat_Huang)

# Plot the triangulation with line widths proportional
# to "linguistic distances".
all_col <- rainbow(100)
i       <- pmax(1,round(100*vldm/max(vldm)))
use_col <- all_col[i]
ind     <- as.matrix(dH$delsgs[,c("ind1","ind2")])
lwv <- ldm[ind]
lwv <- 10*lwv/max(lwv)
plot(dH,wlines="triang",col=use_col,showpoints=FALSE,
     lw=lwv,asp=NA)
with(dH,text(x,y,id,cex=1.5))
}
\keyword{ hplot }

\encoding{UTF-8}
\name{cvt}
\alias{cvt}
\title{
    Centroidal Voronoi (Dirichlet) tessellation.
}
\description{
    Calculates the centroidal Voronoi (Dirichlet) tessellation using
    Lloyd's algorithm.
}
\usage{
    cvt(object, stopcrit = c("change", "maxit"), tol = NULL,
       maxit = 100, verbose = FALSE)
}
\arguments{
  \item{object}{
  An object of class either \code{"deldir"} (as returned by \code{\link{deldir}()})
  or \code{"tile.list"} (as returned by \code{\link{tile.list}()}).
}
  \item{stopcrit}{
  Text string specifying the stopping criterion for the algorithm. If
  this is \code{"change"} then the algorithm halts when the maximum
  change in in the distances between corresponding centroids,
  between iterations, is less than \code{tol} (see below).
  It \code{stopcrit} is \code{"maxit"} then the algorithm halts
  after a specified number of iterations (\code{maxit}; see below)
  have been completed.  This argument may be abbreviated, e.g. to
  \code{"c"} or \code{"m"}.
}
  \item{tol}{
  The tolerance used when the stopping criterion is \code{"change"}.
  Defaults to \code{.Machine$double.eps}.
}
  \item{maxit}{
  The maximum number of iterations to perform when the stopping criterion
  is \code{"maxit"}.
}
  \item{verbose}{
  Logical scalar.  If \code{verbose} is \code{TRUE} then rudimentary
  \dQuote{progress reports} are printed out, every 10 iterations if
  the stopping criterion is \code{"change"} or every iteration if the
  stopping criterion is \code{"maxit"}.
}
}
\section{Note}{
This function was added to the \code{deldir} package at the
suggestion of Dr. Michaël Aupetit, Senior Scientist at the
Qatar Computing Research Institute, Hamad Bin Khalifa University.
}
\details{The algorithm iteratively tessellates a set of points and
  then replaces the points with the centroids of the tiles associated
  with those points.  \dQuote{Eventually} (at convergence) points
  and the centroids of their associated tiles coincide.
}
\value{
  A list with components:
  \item{centroids}{A data frame with columns \code{"x"} and
  \code{"y"} specifying the coordinates of the limiting locations
  of the tile centroids.}
  \item{tiles}{An object of class \code{"tile.list"} specifying
  the Dirichlet (Voronoi) tiles in the tessellation of the points
  whose coordinates are given in \code{centroids}.  Note the tile
  associated with the \eqn{i}th point has centroid \emph{equal}
  to that point.}
}
\references{
\url{https://en.wikipedia.org/wiki/Lloyd's_algorithm}

Lloyd, Stuart P. (1982). Least squares quantization in PCM.
\emph{IEEE Transactions on Information Theory} \bold{28} (2),
pp. 129--137, doi:10.1109/TIT.1982.1056489.
}

\author{\rolf}
\seealso{
\code{\link{deldir}()} \code{\link{tile.list}()}
}
\examples{
\dontrun{ # Takes too long.
    set.seed(42)
    x <- runif(20)
    y <- runif(20)
    dxy <- deldir(x,y,rw=c(0,1,0,1))
    cxy1 <- cvt(dxy,verb=TRUE)
    plot(cxy1$tiles)
    with(cxy1$centroids,points(x,y,pch=20,col="red"))
    cxy2 <- cvt(dxy,stopcrit="m",verb=TRUE)
    plot(cxy2$tiles)
    with(cxy2$centroids,points(x,y,pch=20,col="red"))
# Visually indistinguishable from the cxy1 plot.
# But ...
    all.equal(cxy1$centroids,cxy2$centroids) # Not quite.
    cxy3 <- cvt(dxy,stopcrit="m",verb=TRUE,maxit=250)
    all.equal(cxy1$centroids,cxy3$centroids) # Close, but no cigar.
    cxy4 <- cvt(dxy,verb=TRUE,tol=1e-14)
    cxy5 <- cvt(dxy,stopcrit="m",verb=TRUE,maxit=600)
    all.equal(cxy4$centroids,cxy5$centroids) # TRUE
# Takes a lot of iterations or a really small tolerance
# to get "good" convergence.  But this is almost surely
# of no practical importance.
    txy <- tile.list(dxy)
    cxy6 <- cvt(txy)
    all.equal(cxy6$centroids,cxy1$centroids) # TRUE
}
}
\keyword{spatial}

\name{lawSummary}
\alias{lawSummary}
\title{
  Produce a Lewis-Aboav-Weaire summary of a tessellation.
}
\description{
  Produce a summary of a Dirichlet (Voronoi) tessellation in terms
  of parameters relevant to Lewis's law and Aboav-Weaire's law.
  Note that \dQuote{law} in the function name corresponds to
  \dQuote{Lewis-Aboav-Weaire}.
}

\usage{
lawSummary(object)
}
\arguments{
  \item{object}{
  An object of class \code{"deldir"} as returned by the function
  \code{deldir()}.
}
}
\details{
  Tiles are stripped away from the tessellation in \dQuote{layers}.
  Layer 1 consists of \dQuote{boundary} tiles, i.e. tiles having
  at least one vertex on the enclosing rectangle (determined by the
  \code{rw} argument of \code{\link{deldir}()}).  Layer 2 consists
  of tiles which are neighbours of tiles in layer 1 (i.e. tiles
  determined by points that are Delaunay neighbours of points
  determining the tiles in layer 1).  Layer 3 consists of tiles
  which are neighbours of tiles in layer 2.

  The parameters of interest in respect of the Lewis-Aboav-Weaire summary are
  then calculated in terms of the tiles that remain after the three layers
  have been stripped away, which will be referred to as \dQuote{interior}
  tiles.  These parameters are:
  \itemize{
    \item the areas of each of the interior tiles
    \item the number of edges of each of the interior tiles
    \item the number of edges of all neighbouring tiles of each of
    the interior tiles.
  }
  Note that the neighbouring tiles of the interior tiles may include
  tiles which are \emph{not themselves} interior tiles (i.e. tiles
  which are in layer 3).

  This function was created at the request of Kai Xu
  (Fisheries College, Jimei University, Xiamen, Fujian, China 361021).
}
\value{
  If no tiles remain after the three layers have been stripped
  away, then the returned value is \code{NULL}.  Otherwise the
  returned value is a list with components calculated in terms of
  the remaining (\dQuote{interior}) tiles.  These components are:
  \itemize{
     \item \code{tile.vertices} A list whose entries are data frames
     giving the coordinates of the vertices of the interior tiles.
     \item \code{tile.areas} A vector of the areas of the interior tiles
     in the tessellation in question.
     \item{tile.tags} A vector or factor whose values are the \dQuote{tags}
     of the interior tiles.  The \dQuote{original} of this object (the
     \dQuote{tags} associated with all of the tiles) is provided
     as the \code{z} argument to \code{deldir()}.  The \code{tile.tags}
     component of the value returned by \code{lawSummary()} is present
     only if \code{deldir()} was called with a (non-\code{NULL}) value
     of the \code{z} argument.
     \item \code{num.edges} A vector of the number of edges of each
     such tile.
     \item \code{num.nbr.edges} A list with a component for each
     point, in the set being tessellated, whose corresponding tile
     is an interior tile.  Each component of this
     list is the vector of the number of edges of the interior tiles
     determined by points which are Delaunay neighbours of
     the point corresponding to the list component in question.
     \item \code{totnum.nbr.edges} A vector whose entries consist
     of the sums of the vectors in the foregoing list.
  }
  The returned list also has attributes as follows:
  \itemize{
     \item \code{i1} An integer vector whose entries are in the indices
     of the tiles in layer 1.
     \item \code{i2} An integer vector whose entries are in the indices
     of the tiles in layer 2.
     \item \code{i3} An integer vector whose entries are in the indices
     of the tiles in layer 3.
     \item \code{i.kept} An integer vector whose entries are in the indices
     of the tiles that are kept, i.e. those that remain after the three layers
     have been stripped away.
  }
}

\author{\rolf}

\seealso{ \code{\link{tile.list}()} \code{\link{tile.centroids}()} }

\examples{
# A random pattern:
set.seed(42)
xy1   <- data.frame(x=runif(400,0,20),y=runif(400,0,20))
dxy1  <- deldir(xy1)
ldxy1 <- lawSummary(dxy1)
tl1   <- tile.list(dxy1)
plot(0,0,type="n",xlim=c(-2,35),ylim=c(0,20),asp=1,xlab="x",ylab="y",bty="l")
plot(tl1,showpoints=FALSE,add=TRUE)
points(xy1[attr(ldxy1,"i1"),],pch=20,col="yellow")
points(xy1[attr(ldxy1,"i2"),],pch=20,col="blue")
points(xy1[attr(ldxy1,"i3"),],pch=20,col="green")
points(xy1[attr(ldxy1,"i.kept"),],pch=20,col="red")
legend("right",pch=20,col=c("yellow","blue","green","red"),
       legend=c("layer 1","layer 2","layer 3","interior"))

# A highly structured pattern (example due to Kai Xu):
set.seed(115)
x  <- c(rep(1:20,10),rep((1:20)+0.5,10))
y  <- c(rep(1:10,each=20),rep((1:10)+0.5,each=20))*sqrt(3)
a  <- runif(400,0,2*pi)
b  <- runif(400,-1,1)
x  <- x+0.1*cos(a)*b
y  <- y+0.1*sin(a)*b
xy2 <- data.frame(x,y)
dxy2  <- deldir(xy2)
ldxy2 <- lawSummary(dxy2)
tl2   <- tile.list(dxy2)
plot(0,0,type="n",xlim=c(-2,35),ylim=c(0,20),asp=1,xlab="x",ylab="y",bty="l")
plot(tl2,showpoints=FALSE,add=TRUE)
points(xy2[attr(ldxy2,"i1"),],pch=20,col="yellow")
points(xy2[attr(ldxy2,"i2"),],pch=20,col="blue")
points(xy2[attr(ldxy2,"i3"),],pch=20,col="green")
points(xy2[attr(ldxy2,"i.kept"),],pch=20,col="red")
legend("right",pch=20,col=c("yellow","blue","green","red"),
       legend=c("layer 1","layer 2","layer 3","interior"))

}
\keyword{spatial}

\name{print.deldir}
\alias{print.deldir}
\title{
   Print some information about a tessellation/triangulation.
}
\description{
   Prints a very brief description of an object of class \code{"deldir"}
   as returned by \code{\link{deldir}()}.
}
\usage{
\method{print}{deldir}(x,digits=NULL,...)
}
\arguments{
  \item{x}{
  A Delaunay triangulation and Dirichlet (Voronoi) tessellation
  of a set of points (object of class \code{"deldir"}).
}
  \item{digits}{
  Integer scalar.  The number of digits to which to round the
  numeric information before printing.  Note this may be give
  negative values.  (See \code{\link{round}()}.)
}
   \item{\dots}{
   Not used.
}
}
\details{
   This is a method for the generic \code{\link{print}()} function.
}
\author{\rolf}
\seealso{
   \code{\link{print}()}
}
\examples{
set.seed(42)
x    <- rnorm(200,0,4)
y    <- rnorm(200,0,4)
dxy1 <- deldir(x,y)
dxy2 <- deldir(x,y,rw=c(-12,12,-11,11))
dxy1
dxy2
print(dxy1,digits=4)
}
\keyword{ utilities }

\name{tile.list}
\alias{tile.list}
\title{ Create a list of tiles in a tessellation }
\description{
For each point in the set being tessellated produces a list
entry describing the Dirichlet/Voronoi tile containing that
point.
}
\usage{ tile.list(object,minEdgeLength=NULL,clipp=NULL) }
\arguments{
  \item{object}{ An object of class \code{deldir} as produced
   by the function \code{\link{deldir}()}.}
  \item{minEdgeLength}{
  Positive numeric scalar specifying the minimum length that
  an edge of a tile may have.  It is used to eliminate edges
  that are effectively of zero length, which can cause tiles
  to be \dQuote{invalid}.  This argument defaults to
  \code{sqrt(.Machine$double.eps)} time the diameter (length
  of the diagonal) of the \dQuote{rectangular window}
  associated with the tessellation.  This rectangular window
  is available as the \code{rw} component of \code{object}.
}
  \item{clipp}{An object specifying a polygon to which the
  tessellation, whose tiles are being determined, should be clipped.
  It should consist either of:
  \itemize{
    \item a list containing two components x and y giving the
    coordinates of the vertices of a single polygon. The last vertex
    should not repeat the first vertex. Or:
    \item a list of list(x,y) structures giving the coordinates of
    the vertices of several polygons.
  }
  If this argument is provided then the tiles in the list that
  is produced are \dQuote{clipped} to the polygon specified by
  \code{clipp}.  Empty tiles (those which do not intersect the
  polygon specified by \code{clipp}) are omitted.  The clipping
  process may subdivide some of the tiles into two or more
  discontiguous parts.
}
}
\value{
A list with one entry for each of the points in the set being
tessellated, or for each of the tiles that are retained after clipping
if \code{clipp} is not \code{NULL}.  Each entry is in turn a list
with a number of components.  These components always include:

\item{ptNum}{The index of the point in the original sequence of points
that is being tessellated.  Note that if a point is one of a set
of \emph{duplicated} points then \code{ptNum} is the \emph{first} of the
indices of the points in this set.}
\item{pt}{The coordinates of the point whose tile is being described.}
\item{area}{The area of the tile.}

If the tile in question has \emph{not} been subdivided by the
clipping process then the list components also include:

\item{x}{The \code{x} coordinates of the vertices of the tile, in
anticlockwise order.}
\item{y}{The \code{y} coordinates of the vertices of the tile, in
anticlockwise order.}
\item{bp}{Vector of logicals indicating whether the tile vertex is a
``real'' vertex, or a \emph{boundary point}, i.e. a point where the
tile edge intersects the boundary of the enclosing rectangle.}

If the tile in question \emph{has} been subdivided then the list
does not have the foregoing three components but rather has a
component \code{tileParts} which is in turn a list of length equal
to the number of parts into which the tile was subdivided.  Each
component of \code{tileParts} is yet another list with four
components \code{x}, \code{y}, \code{bp} and \code{area} as described above
and as are appropriate for the part in question. 

\item{z}{The \dQuote{auxiliary value} or \dQuote{tag} associated
with the \code{pt}; present only if such values were supplied in
the call to \code{deldir()}.}
}
\author{\rolf}
\section{Acknowledgement}{
The author expresses sincere thanks to Majid Yazdani who found and
pointed out a serious bug in \code{tile.list} in a previous version
(0.0-5) of the \code{deldir} package.
}

\section{Warning}{
The set of vertices of each tile may be ``incomplete''.  Only
vertices which lie within the enclosing rectangle, and ``boundary
points'' are listed.

Note that the enclosing rectangle may be specified by the user
in the call to \code{\link{deldir}()}.

In contrast to some earlier versions of \code{deldir}, the corners
of the enclosing rectangle are now included as vertices of tiles.
I.e. a tile which in fact extends beyond the rectangular window
and contains a corner of that window will have that corner added
to its list of vertices.  Thus the corresponding polygon is the
intersection of the tile with the enclosing rectangle.
}

\seealso{ \code{\link{deldir}()}, \code{\link{plot.tile.list}()}
          \code{\link{triang.list}()} \code{\link{plot.triang.list}()} }

\examples{
    set.seed(42)
    x <- runif(20)
    y <- runif(20)
    z <- deldir(x,y)
    w <- tile.list(z)

    z <- deldir(x,y,rw=c(0,1,0,1))
    w <- tile.list(z)

    z <- deldir(x,y,rw=c(0,1,0,1),dpl=list(ndx=2,ndy=2))
    w <- tile.list(z)
    if(require(polyclip)) {
        CP <- list(x=c(0.49,0.35,0.15,0.20,0.35,0.42,
                       0.43,0.62,0.46,0.63,0.82,0.79),
                   y=c(0.78,0.86,0.79,0.54,0.58,0.70,
                       0.51,0.46,0.31,0.20,0.37,0.54)) 
        wc <- tile.list(z,clipp=CP) # 10 tiles are retained; the third tile,
                                    # corresponding to point 6, is
                                    # subdivided into two parts.
    # Determine the tiles on the border of a clipping region.
    # Example due to Huimin Wang.
    set.seed(112)
    x      <- runif(100)
    y      <- runif(100)
    dxy    <- deldir(x,y)
    txy    <- tile.list(dxy)
    chind  <- chull(x,y)
    bdry   <- list(x=x[chind],y=y[chind])
    ctxy   <- tile.list(dxy,clipp=bdry)
    inside <- lapply(ctxy,function(tile,bdry){insidePoly(tile$x,tile$y,bdry)},
                                            bdry=bdry)
    border <- sapply(inside,function(x){any(!x) | any(attr(x,"on.boundary"))})
    plot(ctxy[border],main="Border tiles")
    }
}
\keyword{spatial}

\name{divchain.default}
\alias{divchain.default}
\title{
   Dividing chain; default method.
}
\description{
   Create the \dQuote{dividing chain} of the Dirchlet tesselation
   of a given set of points having distinguishing (categorical)
   \dQuote{weights}.  This dividing chain consists of those edges
   of Dirichlet tiles which separate points having different values
   of the given weights.
}

\usage{
  \method{divchain}{default}(x, y, z, ...)
}

\arguments{
\item{x,y}{
   These provide the coordinates of the set of points being
   tesselated.  Argument \code{x} may be a data frame or a
   list, in particular one of class \code{ppp}.  (See the
   \code{spatstat} package.)
   For a full description see the discussion of these arguments in the
   help for \code{\link{deldir}()}.
}
\item{z}{
   A \emph{factor} specifying \dQuote{auxiliary} values or
   \dQuote{weights} If this argument is left \code{NULL} then it
   is extracted, if possible, from the components of \code{x}.
   See \code{\link{deldir}()} for further details.
}
   
  \item{\dots}{
      Other arguments to be passed to \code{deldir}.
}
}
\value{
   An object of class \code{divchain}.  See
   \code{\link{divchain.deldir}()} for details.
}

\author{Rolf Turner
  \email{r.turner@auckland.ac.nz}
% \url{https://www.stat.auckland.ac.nz/~rolf}
}
\note{
   This function was created in response to a question asked
   on \code{stackoverflow.com} by a user named \dQuote{Dan}.
}

\seealso{
\code{\link{divchain.deldir}()} \code{\link{deldir}()}
\code{\link{plot.divchain}()}
}
\examples{
   set.seed(42)
   x    <- runif(50)
   y    <- runif(50)
   z    <- factor(kmeans(cbind(x,y),centers=4)$cluster)
   dcxy <- divchain(x,y,z,rw=c(0,1,0,1))
}

\keyword{ spatial }

\name{print.tileInfo}
\alias{print.tileInfo}
\title{
   Print a summary of tile information.
}
\description{
   Print a reasonably readable summary of an object of class
   \code{tileInfo} as produced by the \code{tileInfo()} function.
}
\usage{
\method{print}{tileInfo}(x, digits = 4, npl = 6, ...)
}
\arguments{
  \item{x}{An object of class \code{tileInfo} as produced by the
  \code{tileInfo()} function.
}
  \item{digits}{
  Integer scalar.  The (maximum) number of decimal digits to which
  the output is to be printed.
}
  \item{npl}{
  Integer scalar.  \dQuote{Number per line}. It specifies the
  (maximum) number of values per line.  Used (only) when printing
  the edge lengths component of \code{x}.  It effects a tidy
  \dQuote{folding} of the printed vector of edge lengths of the
  tile associated with a given point.  If you increase the value of
  \code{digits} you may wish to decrease the value of \code{npl},
  and vice versa.
}
  \item{\dots}{
  Not used.  Present for compatibility with the generic
  \code{print()} function.
}
}
\details{
  The list produced by \code{tileInfo()} is a bit messy and
  hard to comprehend, especially if there is a large number
  of tiles.  This print method produces a screen display which
  is somewhat more perspicuous.
 
  There are four components to the display:

  \itemize{
  \item A list, each entry of which is the vector of edge lengths
  of the tile.  Each edge length is formatted to have a number
  of digits specified by the \code{digits} argument.  Each list
  entry may be displayed over a number of lines. The first of these
  lines is prefixed by an \dQuote{informative} string indicating
  the point that determines the tile whose edge lengths are being
  printed.  The string is formed from the identifier of the point.
  See \code{\link{deldir}()}, \code{\link{plot.deldir}()} and
  \code{\link{getNbrs}()}.  The identifier may consist essentially
  of the index of the point in the sequence of points that is
  being tessellated.

  Succeeding lines, corresponding to the same list entry, are
  prefixed with a number of blanks so as to produce an aesthetically
  pleasing alignment.

  \item A table of the edge counts of the tiles.

  \item A simple print out of the areas of the tiles (rounded
  to a maximum of \code{digits} decimal digits).

  \item A simple print out of the perimeters of the tiles (rounded
  to a maximum of \code{digits} decimal digits).
  }

  This screen display is for \dQuote{looking at} only.  In order
  to do further calculations on the output of \code{tileInfo} it
  is necessary to delve into the bowels of \code{x} and extract
  the relevant bits.
}
\value{
  None.
}
\author{\rolf}

\seealso{
  \code{\link{tileInfo}()}
}
\examples{
set.seed(179)
x    <- runif(100)
y    <- runif(100)
dxy  <- deldir(x,y,rw=c(0,1,0,1))
ixy1 <- tileInfo(dxy)
print(ixy1)
ixy2 <- tileInfo(dxy,bndry=TRUE)
print(ixy2)
if(require(polyclip)) {
    CP <- list(x=c(0.49,0.35,0.15,0.20,0.35,0.42,
                   0.43,0.62,0.46,0.63,0.82,0.79),
               y=c(0.78,0.86,0.79,0.54,0.58,0.70,
                   0.51,0.46,0.31,0.20,0.37,0.54))
    ixy3 <- tileInfo(dxy,clipp=CP)
    options(width=120) # And enlarge the console window.
    print(ixy3) # 33 tiles are retained.
    print(ixy3$perimeters$perComps) # The tiles for points 9 and 94 have
                                    # been split into two components.
}
}
\keyword{ utilities }

\name{volTriPoints}
\alias{volTriPoints}
\docType{data}
\title{
   Solute plume concentration data set.
}
\description{
Example solute plume concentration data set
associated with the GWSDAT (\dQuote{GroundWater
Spatiotemporal Data Analysis Tool}) project
\url{https://protect-au.mimecast.com/s/demRC91WzLH6qo3TorzN7?domain=gwsdat.net}.
The \code{deldir} package is used in this project as part of a
numerical routine to estimate plume quantities (mass, average
concentration and centre of mass).
}
\usage{volTriPoints}
\format{
  A data frame with 232 observations on the following 3 variables.
  \describe{
    \item{\code{x}}{The \code{x}-coordinates of the centres of mass
          of the plumes.}
    \item{\code{y}}{The \code{y}-coordinates of the centres of mass
          of the plumes.}
    \item{\code{z}}{The plume concentrations.}
  }
}
\details{
  This data set played a critical role in revealing a bug in the
  Fortran code underlying the \code{deldir()} function.
}
\source{
  These data were kindly provided by Wayne W. Jones of the GWSDAT
  project.  The data set was originally named \code{Vol.Tri.Points};
  the name was changed so as to be more consistent with my usual
  naming conventions.
}
\references{
Jones, W. R., Spence, M. J., Bowman, A. W., Evers, L. and Molinari,
D. A.  (2014). A software tool for the spatiotemporal analysis
and reporting of groundwater monitoring data. \emph{Environmental
Modelling & Software} \bold{55}, pp. 242--249.
}
\examples{
dvtp <- deldir(volTriPoints)
plot(dvtp)
}
\keyword{datasets}

\name{seaweed}
\alias{seaweed}
\docType{data}
\title{
    seaweed
}
\description{
   A data frame whose columns are the coordinates of the centroids
   of the cells in a seaweed frond. The points are estimates-by-eye
   of where the centroids of the cells occur.
}

\usage{data("seaweed")}

\format{
  A data frame with 266 observations on the following 2 variables.
  \describe{
    \item{\code{x}}{The \eqn{x}-coordinates of the cell centroids.}
    \item{\code{y}}{The \eqn{y}-coordinates of the cell centroids.}
  }
}

\source{
  These data were kindly supplied by Dr. John Bothwell of the
  Department of Biosciences, Durham University.  The data were
  collected by Kevin Yun and Georgia Campbell, members of Dr.
  Bothwell's research group.
}
\examples{
# data(seaweed)
# It is unnecessary to use \code{data} since \code{seaweed} is
# a "first class object".  It is "lazily loaded".

dsw <- deldir(seaweed)
isw <- tileInfo(dsw)
# Expand the width of the terminal window.
options(width=120)
isw
tsw <- tile.list(dsw)
plot(tsw,labelPts=TRUE,col.lbls="red",cex=0.5,adj=0.5)
}

\keyword{datasets}

\name{tileInfo}
\alias{tileInfo}
\title{
   Extract information from a tile list.
}
\description{
   Produces a summary of information about the tiles in an
   object of class \code{deldir} as produced by the function
   \code{deldir()}.
}
\usage{
tileInfo(object, bndry = FALSE, clipp=NULL)
}
\arguments{
  \item{object}{ An object of class \code{deldir} as produced
  by the function \code{deldir()}.
}
  \item{bndry}{
  Logical scalar.  If \code{TRUE} then the \dQuote{boundary} tiles
  (those tiles having edges forming part of the \dQuote{rectangular
  window} enclosing the tessellation) are included in the summary.
  Otherwise they are excluded.  Note that if all tiles are
  boundary tiles and \code{bndry} is \code{FALSE}, then the list of
  included tiles is empty.  In this setting the information summary
  would be vacuous and hence an error is thrown.

}
  \item{clipp}{An object specifying a polygon to which the tiles of
  the tessellation should be clipped.  See \code{link{tile.list}()}
  for more information.  Note that tiles which were originally
  boundary tiles may no longer be boundary tiles after being clipped.
}
}
\section{Remark}{
There is a \code{print()} method for class \code{"tileInfo"} which
produces a convenient display of the information returned by this
function.
}
\section{Acknowledgement}{
Thanks to Krisztina Konya of Ruhr-University Bochum, who provided
an example illustrating the need for an error trap in the setting
in which all tiles are boundary tiles.
}
\value{An object of class \code{"tileInfo"} which consists of a
list with components:
  \item{indivTiles}{This is itself a list. If \code{clipp}
  is \code{NULL} then this list has one entry for each tile in
  \dQuote{object}.  If \code{clipp} is not \code{NULL} then tiles
  are retained only if they have non-empty intersection with the
  polygon specified by \code{clipp}.  The list \code{indivTiles} is
  in fact a \emph{named} list, the names being of form \code{pt.n},
  where \code{n} is equal to the value of \code{ptNum} (see below)
  corresponding to the tile.

  The entries of \code{indivTiles} are themselves in turn lists with
  entries
  \itemize{
  \item \code{edges}:  a matrix whose rows consists of the \code{x}
  and \code{y} coordinates of the endpoints of each edge of the tile
  \item \code{edgeLengths}: a vector of the lengths of the edges
  of the tile
  \item \code{area}: a positive number equal to the area of the tile
  \item \code{ptNum} an integer equal to the number of the point
  determining the tile.  Note that this is the number of the point
  in the \emph{original} sequence of points that were tessellated.
  }
  }
  \item{allEdgeCounts}{An integer vector of the number of
  edges for each of the tiles.}
  \item{tabEdgeCounts}{A table of \code{allEdgeCounts}.}
  \item{allEdgeLengths}{A vector of all of the tile edge lengths;
  a catenation of the \code{edgeLengths} components of the entries
  of \code{indivTiles}.  Note that there will be many duplicate
  lengths since each tile edge is, in general, an edge of \emph{two}
  tiles.}
  \item{Areas}{A vector of the areas of the tiles.}
  \item{uniqueEdgeLengths}{A vector of the lengths of the tiles edges
  with the duplicates (which occur in \code{allEdgeLengths}) being
  eliminated. Each tile edge is represented only once.}
  \item{perimeters}{A list, as returned by \code{\link{tilePerim}()}
  containing the perimeters of the tiles, as well as the total and
  the mean of these perimeters.  In addition \code{perimeters} has
  a component \code{perComps} giving the breakdown of the perimeters
  into the perimeters of the parts into which tiles may have been
  subdivided by the clipping process.}
}
\author{\rolf}

\seealso{
 \code{\link{deldir}()} \code{\link{tile.list}()} \code{\link{print.tileInfo}()}
 \code{\link{tilePerim}()}
}
\examples{
set.seed(42)
x    <- runif(20)
y    <- runif(20)
dxy  <- deldir(x,y,rw=c(0,1,0,1))
ixy1 <- tileInfo(dxy)
ixy2 <- tileInfo(dxy,bndry=TRUE)
if(require(polyclip)) {
    CP <- list(x=c(0.49,0.35,0.15,0.20,0.35,0.42,
                   0.43,0.62,0.46,0.63,0.82,0.79),
               y=c(0.78,0.86,0.79,0.54,0.58,0.70,
                   0.51,0.46,0.31,0.20,0.37,0.54))
    ixy3 <- tileInfo(dxy,clipp=CP) # 10 tiles are retained; the third tile,
                                   # corresponding to point 6, is
                                   # subdivided into two parts.
}
}
\keyword{ spatial }

\name{divchain.deldir}
\alias{divchain.deldir}
\title{
    Dividing chain; \dQuote{deldir} method.
}
\description{
   Create the \dQuote{dividing chain} of a Dirchlet tesselation.
   The tessellation must have been created from a set of points
   having associated categorical \dQuote{weights}.  The dividing
   chain consists of those edges of Dirichlet tiles which separate
   points having different values of the given weights.
}

\usage{
   \method{divchain}{deldir}(x, ...)
}

\arguments{
  \item{x}{
      An object of class \dQuote{deldir}.  This object must have
      been created in such a way that the points of the set being
      tessellated have associate categorical \dQuote{weights}.  That is,
      \code{\link{deldir}()} must have been called with a \emph{factor}
      valued \code{z} argument or the \code{x} argument to  \code{deldir()}
      must have had an appropriate component which could be taken to
      be \code{z}.
  }
  \item{\dots}{
      Not used.
  }
}
\value{
  An object of class \dQuote{divchain} consisting of a
  data frame with columns named \dQuote{x0}, \dQuote{y0},
  \dQuote{x1},\dQuote{y1}, \dQuote{v01}, \dQuote{v02}, \dQuote{v03},
  \dQuote{v11}, \dQuote{v12} and \dQuote{v13}.

  The columns named \dQuote{x0} and \dQuote{y0} consist of the
  coordinates of one endpoint of an edge of a Dirichlet tile and
  the columns named \dQuote{x1} and \dQuote{y1} consist of the
  coordinates of the other endpoint.

  The columns named \dQuote{vij}, i = 0, 1, j = 1, 2, 3, consist
  of the indices of the vertices of the Delaunay triangles
  whose circumcentres constitute the respective endpoints of the
  corresponding edge of a Dirichlet tile.  The entries of column
  \dQuote{vi3} may (also) take the values $-1, -2, -3$, and $-4$.
  This will be the case if the circumcentre in question lay outside
  of the rectangular window \code{rw} (see \code{\link{deldir}()})
  enclosing the points being tessellated.  In these circumstances the
  corresponding endpoint of the tile edge is the intersection of the
  line joining the two circumcentres with the boundary of \code{rw},
  and the numeric value of the entry of column \dQuote{vi3} indicates
  which side.  The numbering follows the convention for numbering
  the sides of a plot region in \code{R}: 1 for the bottom side,
  2 for the left side, 3 for the top side and 4 for the right side.

  Note that the triple of vertices uniquely identify the endpoint
  of the tile edge.

  The object has an attribute \code{rw} which is equal to the
  specification of the rectangular window within which the
  class \dQuote{deldir} object \code{x} was constructed.
  (See \code{\link{deldir}()}.)
}

\author{
  Rolf Turner
  \email{r.turner@auckland.ac.nz}
% \url{https://www.stat.auckland.ac.nz/~rolf}
}
\note{
  This function was created in response to a question asked
  on \code{stackoverflow.com} by a user named \dQuote{Dan}.
}

\seealso{
  \code{\link{divchain.default}()} \code{\link{deldir}()}
  \code{\link{plot.divchain}()}
}
\examples{
   set.seed(42)
   x   <- runif(50)
   y   <- runif(50)
   z   <- factor(kmeans(cbind(x,y),centers=4)$cluster)
   dxy <- deldir(x,y,z=z,rw=c(0,1,0,1))
   dc  <- divchain(dxy)
}

\keyword{ spatial }

\name{plot.tile.list}
\alias{plot.tile.list}
\title{ Plot Dirichlet (Voronoi) tiles }
\description{ A method for \code{plot}.  Plots (sequentially)
the tiles associated with each point in the set being tessellated. }
\usage{
\method{plot}{tile.list}(x, verbose = FALSE, close = FALSE, pch = 1,
                         fillcol = getCol(x,warn=warn), col.pts=NULL,
                         col.lbls=NULL,border=NULL, showpoints = !labelPts,
                         add = FALSE, asp = 1, clipp=NULL, xlab = "x",
                         ylab = "y", main = "", axes=TRUE,warn=TRUE,
                         labelPts=FALSE,adj=NULL,...) 
}
\arguments{
  \item{x}{
  A list of the tiles in a tessellation, as produced
  the function \code{\link{tile.list}()}.
}
  \item{verbose}{
  Logical scalar; if \code{TRUE} the tiles are
  plotted one at a time (with a \dQuote{Go?} prompt after each)
  so that the process can be watched.
}
  \item{close}{
  Logical scalar; if \code{TRUE} the outer edges of of the tiles
  (i.e. the edges which are constitute parts of the edges of the
  enclosing rectangle) are drawn.  Otherwise tiles on the periphery
  of the tessellation are left \dQuote{open}.
}
  \item{pch}{
  The plotting character (or vector of plotting
  characters) with which to plot the points of the pattern which
  was tessellated.  Ignored if \code{showpoints} is \code{FALSE}.
}
  \item{fillcol}{
  Optional vector (possibly of length 1, i.e. a scalar) whose
  entries can be interpreted as colours by \code{\link{col2rgb}()}.
  The \eqn{i}-th entry indicates with which colour to fill the
  \eqn{i}-th tile.  Note that an \code{NA} entry cause the tile
  to be left unfilled.  This argument will be replicated to have
  length equal to the number of tiles.  The default value is
  created (using the tile \dQuote{tags}, i.e. the \code{z}
  components of the tiles, if these exist) by
  the undocumented function \code{getCol()}.  Note that if
  these \code{z} components are not present, then \code{getCol()}
  returns \code{NA}.
}
  \item{col.pts}{
  Optional vector like unto \code{fillcol} whose entries can be
  interpreted as colours by \code{\link{col2rgb}()}.  The \eqn{i}-th
  entry indicates with which colour to plot the \eqn{i}-th point.
  This argument will be replicated to have length equal to the
  number of tiles.  Ignored if \code{showpoints} is \code{FALSE}.
}
  \item{col.lbls}{
  Optional vector like unto \code{col.pts}. Determines the colours
  in which the point labels (see \code{labelPts} below) are plotted.
  This argument will be replicated to have length equal to the
  number of tiles.  Ignored if \code{labelPts} is \code{FALSE}.
}
  \item{border}{
  A scalar that can be interpreted as a colour by \code{col2rgb()},
  indicating the colour with which to plot the tile boundaries.
  Defaults to black unless all of the fill colours specified by
  \code{fillcol} are black, in which case it defaults to white.
  If \code{length(border) > 1} then only its first entry is used.
}
  \item{showpoints}{Logical scalar; if \code{TRUE} the points of
  the pattern which was triangulated/tessellated are plotted.
  If \code{clipp} is specified, then only those points
  associated with non-empty clipped tiles are shown.  Note that
  some such points will be external to the polygon \code{clipp}
  and that these \dQuote{external} points \emph{are} shown.
}
  \item{add}{
  Logical scalar; should the plot of the tiles be added
  to an existing plot?
}
  \item{asp}{The aspect ratio of the plot; integer scalar or
  \code{NA}.  Set this argument equal to \code{NA} to allow the data
  to determine the aspect ratio and hence to make the plot occupy the
  complete plotting region in both \code{x} and \code{y} directions.
  This is inadvisable; see the \bold{Warnings}.
}
  \item{clipp}{An object specifying a polygon to which the tessellation
  being plotted should be clipped.  It should consist either of:
  \itemize{
    \item a list containing two components x and y giving the
    coordinates of the vertices of a single polygon. The last vertex
    should not repeat the first vertex. Or:
    \item a list of list(x,y) structures giving the coordinates of
    the vertices of several polygons.
  }
  If this argument is provided then the plot of the tessellation
  is \dQuote{clipped} to the polygon specified by \code{clipp}.
}
  \item{xlab}{
   Label for the \code{x}-axis (used only if \code{add} is \code{FALSE}).
}
  \item{ylab}{
   Label for the \code{y}-axis (used only if \code{add} is \code{FALSE}).
}
  \item{main}{
   A title for the plot (used only if \code{add} is \code{FALSE}).
}
  \item{axes}{
   Logical scalar.  Should axes (with a marked numeric scale)
   be plotted?  This argument is used only if \code{add} is
   \code{FALSE}.  It allows the plotting of such axes to be
   suppressed.  The argument was added at the request of Damon
   Tutunjian.  To suppress the plotting of axis \emph{labels}
   set \code{xlab=""} and/or \code{ylab=""}.
}
  \item{warn}{Logical scalar passed to the internal function \code{getCol()}.
  Should a warning be issued if the \code{z} components of the entries
  of \code{x} cannot all be interpreted as colours?  (See \bold{Notes}.)
}
  \item{labelPts}{Logical scalar; if \code{TRUE} the labels of the
  points determining the tiles are plotted in the tiles.  Note
  that if \code{labelPts} is \code{TRUE} then \code{showpoints}
  defaults to \code{FALSE}
}
  \item{adj}{The \dQuote{adjustment} argument to \code{text()}.
  If \code{labelPts} and \code{showpoints} are both \code{TRUE} it
  defaults to \code{-1} (so that the labels and point symbols
  are not superimposed).  If \code{labelPts} is \code{TRUE} and
  \code{showpoints} is \code{FALSE} it defaults to \code{0}.
  If \code{labelPts} is \code{FALSE} it is ignored.
}
  \item{...}{Optional arguments; may be passed to \code{points()}
  and \code{text()}.
}
}
  \section{Warnings}{
  \itemize{
  \item As of release 1.0-8 the argument \code{number} of
  \code{\link{plot.deldir}()} and \code{\link{plot.tile.list}()}
  was changed to \code{labelPts}.  As a consequence the argument
  \code{col.num} of this function has had its name changed to
  \code{col.lbls}.

  \item The behaviour of this function with respect to
  \dQuote{clipping} has changed substantially since the previous
  release of \code{deldir}, i.e. 1.1-0.  The argument \code{clipwin}
  has been re-named \code{clipp} (\dQuote{p} for \dQuote{polygon}).
  Clipping is now effected via the new package \code{polyclip}.
  The \code{spatstat} package is no longer used.  The argument
  \code{use.gpclib} has been eliminated, since \code{gpclib} (which
  used to be called upon by \code{spatstat} has been superseded by
  \code{polyclip} which has an unrestrictive license.

  \item As of release 0.1-1 of the \code{deldir} package, the
  argument \code{fillcol} to this function \emph{replaces} the old
  argument \code{polycol}, but behaves somewhat differently.

  \item The argument \code{showrect} which was present in versions
  of this function prior to release 0.1-1 has been eliminated.
  It was redundant.

  \item As of release 0.1-1 the \code{col.pts} argument \emph{might}
  behave somewhat differently from how it behaved in the past.

  \item The arguments \code{border}, \code{clipp}, and \code{warn}
  are new as of release 0.1-1.

  \item Users, unless they \emph{really} understand what they are
  doing and why they are doing it, are \emph{strongly advised}
  not to set the value of \code{asp} but rather to leave \code{asp}
  equal to its default value of \code{1}.  Any other value distorts
  the tesselation and destroys the perpendicular appearance of
  lines which are indeed perpendicular.  (And conversely can cause
  lines which are not perpendicular to appear as if they are.)
  The argument \code{asp} was added at the request of Zubin Dowlaty
  (who presumably knows what he's doing!).
  }
}
\section{Notes}{
  \itemize{
  \item If \code{clipp} is not \code{NULL} and \code{showpoints}
  is \code{TRUE} then it is possible that some of the points
  \dQuote{shown} will not fall inside any of the plotted tiles.
  (This will happen if the parts of the tiles in which they fall
  have been \dQuote{clipped} out.)  If a tile is clipped out
  \emph{completely} then the point which determines that tile is
  \emph{not} plotted irrespective of the value of \code{showpoints}.

  \item If the \code{z} components of the entries of \code{x}
  exist but cannot all be interpreted as colours then the internal
  function \code{getCol()} returns \code{NA}.  If \code{warn} is
  \code{TRUE} then a warning is issued.  The function \code{getCol()}
  will also return \code{NA} (no warning is issued in this case)
  if there \emph{aren't} any \code{z} components. This circumstance
  will arise if no \code{z} argument was supplied in the call to
  \code{deldir()}.  An \code{NA} value of \code{fillcol} results
  (as is indicated by the argument list entry for \code{fillcol})
  in (all of) the tiles being left unfilled.

  \item The change from argument \code{polycol} to argument
  \code{fillcol}, and the resulting change in the way in which
  plotted tiles are filled with colours, was made as a result of
  a request from Chris Triggs.  Likewise the argument \code{clipp}
  was added due to a request from Chris Triggs.
  }
}

\value{The list of tiles being plotted.  This will be the input
list of  tiles specified by argument \code{x}, or this list
clipped to the polygon \code{clipp} if the latter was specified.
}

\author{\rolf}
\seealso{ \code{\link{deldir}()}, \code{\link{tile.list}()},
          \code{\link{triang.list}()}, \code{\link{plot.triang.list}()} }
\examples{
  set.seed(42)
  x <- runif(20)
  y <- runif(20)
  z <- deldir(x,y,rw=c(0,1,0,1))
  w <- tile.list(z)
  plot(w)
  ccc <- heat.colors(20) # Or topo.colors(20), or terrain.colors(20)
                         # or cm.colors(20), or rainbow(20).
  plot(w,fillcol=ccc,close=TRUE)
  if(require(polyclip)) {
     CP  <- list(x=c(0.49,0.35,0.15,0.20,0.35,0.42,
                     0.43,0.62,0.46,0.63,0.82,0.79),
                 y=c(0.78,0.86,0.79,0.54,0.58,0.70,
                     0.51,0.46,0.31,0.20,0.37,0.54))
     cul <- rainbow(10)[c(1,7,3:6,2,8:10)] # Rearranging colours to improve
                                           # the contrast between contiguous tiles.
     plot(w,clipp=CP,showpoints=FALSE,fillcol=cul)
  }
  plot(w,labelPts=TRUE,col.lbls="red")
  plot(w,labelPts=TRUE,col.lbls="red",cex=0.5)
  plot(w,showpoints=TRUE,labelPts=TRUE,col.pts="green",col.lbls="red")
  plot(w,axes=FALSE,xlab="",ylab="",close=TRUE)
}
\keyword{ hplot }

\name{tile.centroids}
\alias{tile.centroids}
\title{
Compute centroids of Dirichlet (Voronoi) tiles
}
\description{
Given a list of Dirichlet tiles, as produced by \code{tile.list()},
produces a data frame consisting of the centroids of those tiles.
}
\usage{
tile.centroids(tl)
}
\arguments{
  \item{tl}{A list of the tiles (produced by \code{tile.list()})
  in a Dirichlet tessellation of a set of planar points.}
}
\value{
  A data frame with two columns named \code{x} and \code{y}.
  Each row of this data frame constitutes the centroid of one
  of the Dirichlet tiles.
}
\references{
URL http://en.wikipedia.org/wiki/Centroid
}
\author{\rolf}

\seealso{ \code{\link{tile.list}()} }
\examples{
set.seed(42)
x <- runif(20)
y <- runif(20)
d <- deldir(x,y)
l <- tile.list(d)
g <- tile.centroids(l)
plot(l,close=TRUE)
points(g,pch=20,col="red")
}
\keyword{ spatial }

\name{plot.triang.list}
\alias{plot.triang.list}
\title{ Plot Delaunay triangles }
\description{ A method for \code{plot}.  Plots the triangles of
a Delaunay triangulation of a set of points in the plane.}
\usage{
\method{plot}{triang.list}(x, showrect = FALSE, add = FALSE,
              xlab = "x", ylab = "y", main = "", asp = 1,
              rectcol="black", ...)
}
\arguments{
  \item{x}{
   An object of class \dQuote{triang.list} as produced by
   \code{\link{triang.list}()}.
}
  \item{showrect}{
   Logical scalar; show the enclosing rectangle \code{rw} (see
   \code{\link{deldir}()}) be plotted?
}
  \item{add}{
   Logical scalar; should the plot of the triangles be added
   to an existing plot?
}
  \item{xlab}{
   Label for the \code{x}-axis.
}
  \item{ylab}{
   Label for the \code{y}-axis.
}
  \item{main}{
   A title for the plot (used only if \code{add} is \code{FALSE}).
}
  \item{asp}{The aspect ratio of the plot; integer scalar or
  \code{NA}.  Set this argument equal to \code{NA} to allow the data
  to determine the aspect ratio and hence to make the plot occupy the
  complete plotting region in both \code{x} and \code{y} directions.
  This is inadvisable; see the \bold{Warnings}.
}
  \item{rectcol}{
  Text string or integer specifying the colour in which the enclosing
  rectangle should be plotted.  Ignored unless \code{showrect} is
  \code{TRUE}.
}
  \item{\dots}{
  Arguments passed to \code{\link{polygon}()} which does the actual
  plotting of the triangles.
}
}
\section{Warnings}{
  Users are \emph{strongly advised} not to set the value of
  \code{asp} (unless they really know what they are doing) but rather
  to leave \code{asp} equal to its default value of \code{1}.
  Any other value distorts the tesselation and destroys the
  perpendicular appearance of lines which are indeed perpendicular.
  (And conversely can cause lines which are not perpendicular to
  appear as if they are.)

  The argument \code{asp} was added at the request of Zubin
  Dowlaty (who presumably knows what he is doing!).
}
\value{
   None.  This function has the side effect of producing (or
   adding to) a plot.
}
\author{\rolf}

\seealso{ \code{\link{deldir}()}, \code{\link{plot.triang.list}()},
          \code{\link{tile.list}()}, \code{\link{plot.tile.list}()} }
\examples{
set.seed(42)
x <- runif(20)
y <- runif(20)
d <- deldir(x,y)
ttt <- triang.list(d)
plot(ttt,border="red",showrect=TRUE,rectcol="green")
sss <- tile.list(d)
plot(sss)
plot(ttt,add=TRUE,border="blue",showrect=TRUE,rectcol="red")
}
\keyword{ spatial }

\name{which.tile}
\alias{which.tile}
\title{
  Determine the tile containing a given point.
}
\description{
  Finds the Dirichlet/Voronoi tile, of a tessellation produced
  by \code{deldir()}, that contains a given point.
}
\usage{
which.tile(x, y, tl)
}
\arguments{
  \item{x}{
  The \code{x} coordinate of the point in question.
}
  \item{y}{
  The \code{y} coordinate of the point in question.
}
  \item{tl}{
  A tile list, as produced by the function \code{\link{tile.list}()}
  from a tessellation produced by \code{\link{deldir}()}.
}
}
\details{
  Just minimises the distance from the point in question to the
  points of the pattern determining the tiles.
}
\value{
  An integer equal to the index of the tile in which the given
  point lies.
}
\author{\rolf}

\seealso{
\code{\link{tile.list}()} \code{\link{deldir}()}.
}
\examples{
set.seed(42)
x   <- runif(20,0,100)
y   <- runif(20,0,100)
dxy <- deldir(x,y)
txy <- tile.list(dxy)
i   <- which.tile(30,50,txy) # The value of i here is 14.
plot(txy,showpoints=FALSE)
text(x,y,labels=1:length(txy),col="red")
points(30,50,pch=20,col="blue")
}
\keyword{ spatial }

\name{duplicatedxy}
\alias{duplicatedxy}
\title{
   Determine duplicated points.
}
\description{
    Find which points among a given set are duplicates of others.
}
\usage{
duplicatedxy(x, y)
}
\arguments{
  \item{x}{
  Either a vector of \code{x} coordinates of a set of (two
  dimensional) points, or a list (or data frame) with columns
  \code{x} and \code{y} giving the coordinates of a set of such
  points.
}
  \item{y}{
  A vector of \code{y} coordinates of a set of (two
  dimensional) points.  Ignored if \code{x} is a list or data
  frame.
}
}
\details{
   Often it is of interest to associate each Dirichlet tile in a
   tessellation of a planar point set with the point determining
   the tile.  This becomes problematic if there are \emph{duplicate}
   points in the set being tessellated/triangulated.  Duplicated
   points are automatically eliminated \dQuote{internally} by
   \code{deldir()}.  The association between tiles and the indices
   of the original set of points is now preserved by the component
   \code{ind.orig} of the object returned by \code{deldir()}.
   However confusion could still arise.

   If it is of interest to associate Dirichlet tiles with the
   points determining them, then it is better to proceed by
   eliminating duplicate points to start with.  This function
   (\code{duplicatedxy()}) provides a convenient way of doing so.
}
\value{
   A logical vector of length equal to the (original) number
   of points being considered, with entries \code{TRUE} if the
   corresponding point is a duplicate of a point with a smaller
   index, and \code{FALSE} otherwise.
}
\author{\rolf}
\note{
  The real work is done by the base \bold{R} function \code{\link{duplicated}()}.
}

\section{Warning}{
   Which indices will be considered to be indices of duplicated
   points (i.e. get \code{TRUE} values) will of course depend on
   the order in which the points are presented.
}

\seealso{
\code{\link{duplicated}()}, \code{\link{deldir}()}
}
\examples{
   set.seed(42)
   xy  <- data.frame(x=runif(20),y=runif(20))
   # Lots of duplicated points.
   xy  <- rbind(xy,xy[sample(1:20,20,TRUE),])
   # Scramble.
   ii  <- sample(1:40,40)
   x   <- xy$x[ii]
   y   <- xy$y[ii]
   # Unduplicate!
   iii <- !duplicatedxy(x,y)
   xu  <- x[iii]
   yu  <- y[iii]
   # The i-th tile is determined by (xu[i],yu[i]):
   dxy <- deldir(xu,yu)
}
\keyword{ utilities }

\name{divchain}
\alias{divchain}
\alias{divchain.default}
\alias{divchain.deldir}
\title{
   Dividing chain.
}
\description{
   Create the \dQuote{dividing chain} of a Dirichlet tessellation.
   The tessellation must have been created from a set of points
   having associated \dQuote{tags}.  The dividing chain consists
   of those edges of Dirichlet tiles which separate points having
   different values of the given tags.
}

\usage{
   divchain(x, ...)
   \method{divchain}{default}(x, y, z, ...)
   \method{divchain}{deldir}(x, ...)
}
\arguments{
  \item{x}{
   Either an object specifying coordinates (in the case of the
   \code{"default"} method; see \code{\link{deldir}()} for details)
   or an object of class \dQuote{deldir}.  In the latter case this
   object must have been created in such a way that the points of the
   set being tessellated have associate categorical \dQuote{tags}.
   That is, \code{\link{deldir}()} must have been called with a
   \code{z} argument or the \code{x} argument to  \code{deldir()}
   must have had an appropriate component which could be taken to
   be \code{z}.  Note that if the value of \code{z} that was used
   was not a factor, it is coerced to one.
}
  \item{y}{
   A numeric vector constituting the \eqn{y}-coordinates of the
   set of points being tessellated.  See \code{\link{deldir}()}
   for details.  Not used by the \code{"deldir"} method.
}
  \item{z}{
   A vector or factor specifying \dQuote{auxiliary} values or
   \dQuote{tags}.  If this argument is left \code{NULL} then it
   is extracted, if possible, from the components of \code{x}.
   See \code{\link{deldir}()} for further details.  If \code{z} is
   not a factor it is coerced to one.  See \code{\link{deldir}()}
   for details.  Not used by the \code{"deldir"} method.
}
  \item{\dots}{
  Arguments to be passed to \code{deldir()}.  Not used by
  the \code{"deldir"} method.
}
}
\value{
  An object of class \dQuote{divchain} consisting of a data frame
  with columns named \dQuote{x0}, \dQuote{y0}, \dQuote{x1},
  \dQuote{y1}, \dQuote{v01}, \dQuote{v02}, \dQuote{v03},
  \dQuote{v11}, \dQuote{v12} and \dQuote{v13}.

  The columns named \dQuote{x0} and \dQuote{y0} consist of the
  coordinates of one endpoint of an edge of a Dirichlet tile and
  the columns named \dQuote{x1} and \dQuote{y1} consist of the
  coordinates of the other endpoint.

  The columns named \dQuote{vij}, i = 0, 1, j = 1, 2, 3, consist
  of the indices of the vertices of the Delaunay triangles
  whose circumcentres constitute the respective endpoints of the
  corresponding edge of a Dirichlet tile.  The entries of column
  \dQuote{vi3} may (also) take the values $-1, -2, -3$, and $-4$.
  This will be the case if the circumcentre in question lay outside
  of the rectangular window \code{rw} (see \code{\link{deldir}()})
  enclosing the points being tessellated.  In these circumstances the
  corresponding endpoint of the tile edge is the intersection of the
  line joining the two circumcentres with the boundary of \code{rw},
  and the numeric value of the entry of column \dQuote{vi3} indicates
  which side.  The numbering follows the convention for numbering
  the sides of a plot region in \code{R}: 1 for the bottom side,
  2 for the left side, 3 for the top side and 4 for the right side.

  Note that the triple of vertices uniquely identify the endpoint
  of the tile edge.

  The object has an attribute \code{rw} which is equal to
  the specification of the rectangular window within which
  the triangulation/tessellation in question was constructed.
  (See \code{\link{deldir}()}.)
}
\author{\rolf}

\note{
   This function was created in response to a question asked
   on \code{stackoverflow.com} by a user named \dQuote{Dan}.
}

\seealso{
\code{\link{deldir}()} \code{\link{plot.divchain}()}
}
\examples{
   set.seed(42)
   x   <- runif(50)
   y   <- runif(50)
   z   <- factor(kmeans(cbind(x,y),centers=4)$cluster)
   dc1 <- divchain(x,y,z,rw=c(0,1,0,1))
   dxy <- deldir(x,y,z=z,rw=c(0,1,0,1))
   dc2 <- divchain(dxy)
}
\keyword{ spatial }

\name{deldir}
\alias{deldir}
\title{
   Delaunay triangulation and Dirichlet tessellation
}
\description{
This function computes the Delaunay triangulation (and hence the
Dirichlet or Voronoi tessellation) of a planar point set according
to the second (iterative) algorithm of Lee and Schacter --- see
\bold{References}.  The triangulation is made to be with respect to
the whole plane by \dQuote{suspending} it from so-called ideal points
(-Inf,-Inf), (Inf,-Inf) (Inf,Inf), and (-Inf,Inf).  The triangulation
is also enclosed in a finite rectangular window.
}
\usage{
deldir(x, y, z=NULL, rw=NULL, eps=1e-09, sort=TRUE, plot=FALSE,
       round=TRUE,digits=6, id=NULL, \dots)
}
\arguments{
\item{x,y}{
These arguments specify the coordinates of the point set being
triangulated/tessellated.  Argument \code{x} may be a numeric
vector or it may be a data structure consisting of a matrix, a
data frame, a generic list, or an object of class \code{"ppp"}.
(See package \code{spatstat}.)  Argument \code{y}, if specified, is
always a numeric vector.  The \code{"x"} and \code{"y"} coordinates
are extracted from arguments \code{x} and \code{y}  according to
(what can be, in some instances) a rather complicated protocol.
See \bold{Notes on extracting the coordinates} for details of
this protocol.
}
\item{z}{
Optional argument specifying \dQuote{auxiliary} values or
\dQuote{tags} associated with the respective points.  (See
\bold{Notes on \dQuote{tags}}.) This argument may be a vector or
factor whose entries constitute these tags, or it may be a text
string naming such a vector or factor.  If \code{z}, or the object
named by \code{z} is a vector (rather than a factor) it may be
of any mode (numeric, character, logical, etc.).  See \bold{Notes
on extracting \code{z}} for how \code{z} is handled when argument
\code{x} is a data structure (rather than a numeric vector).
}
\item{rw}{
The coordinates of the corners of the rectangular window enclosing
the triangulation, in the order (xmin, xmax, ymin, ymax).  Any data
points outside this window are discarded.  If this argument is
omitted, it defaults to values given by the range of the data,
plus and minus 10 percent.
}
\item{eps}{
A value of epsilon used in testing whether a quantity is zero, mainly
in the context of whether points are collinear.  If anomalous errors
arise, it is possible that these may averted by adjusting the value
of eps upward or downward.
}
\item{sort}{
Logical argument; if \code{TRUE} (the default) the data are sorted
into a sequence of \dQuote{bins} prior to triangulation; this makes
the algorithm slightly more efficient.  Normally one would set
\code{sort} equal to \code{FALSE} only if one wished to observe
some of the fine detail of the way in which adding a point to a
data set affected the triangulation, and therefore wished to make
sure that the point in question was added last.  Essentially this
argument would get used only in a debugging process.
}
\item{plot}{
Logical argument; if \code{TRUE} a plot is produced.  The nature
of the plot may be controlled by using the \code{\dots} argument
to pass appropriate arguments to \code{plot.deldir()}.  Without
\dQuote{further instruction} a plot of the points being triangulated
and of both the triangulation and the tessellation is produced;
}
\item{round}{
Logical scalar.  Should the data stored in the returned value
be rounded to \code{digits} decimal digits?  This is essentially
for cosmetic purposes.  This argument is a \dQuote{new addition}
to \code{deldir()}, as of version 0.1-26.  Previously rounding
was done willy-nilly.  The change was undertaken when Kodi
Arfer pointed out that the rounding might have unwanted effects
upon \dQuote{downstream} operations.
}
\item{digits}{
The number of decimal places to which all numeric values in the
returned list should be rounded.  Defaults to 6. Ignored if
\code{round} (see above) is set to \code{FALSE}.
}
\item{id}{
Optional vector of the same length as \code{x} and
\code{y}, providing identifiers for the points that are being
triangulated/tessellated.  This vector will be coerced to mode
\code{"character"} internally.  If \code{id} is not specified,
it defaults to the sequence of indices of the points.  Note that
\code{id} must specify identifiers for \emph{all} points, even
though some of these points may be dropped from consideration if
they do not lie inside the \dQuote{rectangular window} \code{rw}.
Note also that \code{id} must contain no duplicate values.

The \code{id} argument should not be confused with the \code{z}
argument.  The two are entirely different and serve entirely different
purposes.
}

\item{...}{
Auxiliary arguments \code{add}, \code{wlines},
\code{labelPts}, \code{lex}, \code{col}, \code{lty}, \code{pch},
\code{xlim}, and \code{ylim} (and possibly other plotting parameters)
may be passed to \code{\link{plot.deldir}()} through \code{\dots}
if \code{plot=TRUE}.
}
}
\value{
A list (of class \code{deldir}), invisible if \code{plot=TRUE}, with components:

\item{delsgs}{
A data frame with 6 columns.  The first 4 entries of each row are the
coordinates of the points joined by an edge of a Delaunay triangle,
in the order \code{(x1,y1,x2,y2)}.  The last two entries are the
identifiers (defaulting to the indices, if \code{id} is not supplied)
of the two points which are joined.
}
\item{dirsgs}{
A data frame with 10 columns.  The first 4 entries of each
row are the coordinates of the endpoints of one the edges of a
Dirichlet tile, in the order \code{(x1,y1,x2,y2)}.  The fifth and
sixth entries, in the columns named \code{ind1} and \code{ind2},
are the identifiers (defaulting to the indices, if \code{id} is
not supplied)  of the two points, in the set being triangulated,
which are separated by that edge. The seventh and eighth entries,
in the columns named \code{bp1} and \code{bp2} are logical values.
The entry in column \code{bp1} indicates whether the first endpoint
of the corresponding edge of a Dirichlet tile is a boundary point
(a point on the boundary of the rectangular window).  Likewise for
the entry in column \code{bp2} and the second endpoint of the edge.

The ninth and tenth entries, in columns named \code{thirdv1}
and \code{thirdv2} are the identifiers of the respective third
vertices of the Delaunay triangles whose circumcentres constitute
the corresponding endpoints of the edge under consideration.
(The other two vertices of the triangle in question are identified by
the entries of columns \code{ind1} and \code{ind2}.)

The entries of columns \code{thirdv1} and \code{thirdv2} may (also)
take the values $-1, -2, -3$, and $-4$. (These will be coerced to
mode character if \code{id} was supplied.)  This will be the case
if the circumcentre in question lies outside of the rectangular
window \code{rw}.  In these circumstances the corresponding
endpoint of the tile edge is the intersection of the line joining
the two circumcentres with the boundary of \code{rw}, and the
numeric value of the entry of column \dQuote{thirdv1} (respectively
\dQuote{thirdv2}) indicates which side.  The numbering follows the
convention for numbering the sides of a plot region in \code{R}:
1 for the bottom side, 2 for the left hand side, 3 for the top side
and 4 for the right hand side.

Note that the entry in column \code{thirdv1} will be negative if and
only if the corresponding entry in column \code{bp1} is \code{TRUE}.
Similarly for columns \code{thirdv2} and \code{bp2}.
}

\item{summary}{
a data frame with 9, 10 or 11 columns and \code{n.data} rows
(see below).  The rows correspond to the points in the set being
triangulated.  Note that the row names are the indices of the points
in the original sequence of points being triangulated/tessellated.
Usually these will be the sequence 1, 2, ..., n.  However if there
were \emph{duplicated} points then the row name corresponding to a
point is the \emph{first} of the indices of the set of duplicated
points in which the given point appears.  The columns are:

\itemize{
\item \code{x} (the \eqn{x}-coordinate of the point)
\item \code{y} (the \eqn{y}-coordinate of the point)
\item \code{id} (the identifers of the points; present only if
\code{id} was specified)
\item \code{z} (the auxiliary values or \dQuote{tags}; present
only if these were specified)
\item \code{n.tri} (the number of Delaunay triangles emanating from
the point)
\item \code{del.area} (1/3 of the total area of all the Delaunay
triangles emanating from the point)
\item \code{del.wts} (the corresponding entry of the \code{del.area}
column divided by the sum of this column)
\item \code{n.tside} (the number of sides --- within the rectangular
window --- of the Dirichlet tile surrounding the point)
\item \code{nbpt} (the number of points in which the Dirichlet tile
intersects the boundary of the rectangular window)
\item \code{dir.area} (the area of the Dirichlet tile surrounding
the point)
\item \code{dir.wts} (the corresponding entry of the \code{dir.area}
column divided by the sum of this column).
}

Note that the factor of 1/3 associated with the del.area column
arises because each triangle occurs three times --- once for
each corner.
}
\item{n.data}{
the number of points in the set which was triangulated, with any
duplicate points eliminated.  It is the same as the number of rows
of \code{summary}.
}
\item{del.area}{
the area of the convex hull of the set of points being triangulated,
as formed by summing the \code{del.area} column of \code{summary}.
}
\item{dir.area}{
the area of the rectangular window enclosing the points being triangulated,
as formed by summing the \code{dir.area} column of \code{summary}.
}
\item{rw}{
the specification of the corners of the rectangular window enclosing
the data, in the order (xmin, xmax, ymin, ymax).
}
\item{ind.orig}{A vector of the indices of the points (x,y) in the
set of coordinates initially supplied to \code{deldir()} before
duplicate points (if any) were removed.  These indices are used
by \code{\link{triang.list}()}.
}}
\section{Side Effects}{
If \code{plot=TRUE} a plot of the triangulation and/or tessellation
is produced or added to an existing plot.
}

\details{
This package had its origins (way back in the mists of time!)  as an
Splus library section named \dQuote{delaunay}.  That library section
in turn was a re-write of a stand-alone Fortran program written
in 1987/88 while the author was with the Division of Mathematics
and Statistics, CSIRO, Sydney, Australia.  This program was an
implementation of the second (iterative) Lee-Schacter algorithm.
The stand-alone Fortran program was re-written as an Splus function
(which called upon dynamically loaded Fortran code) while the author
was visiting the University of Western Australia, May, 1995.

Further revisions were made December 1996. The author gratefully
acknowledges the contributions, assistance, and guidance of Mark
Berman, of D.M.S., CSIRO, in collaboration with whom this project
was originally undertaken.  The author also acknowledges much useful
advice from Adrian Baddeley, formerly of D.M.S., CSIRO (now
Professor of Statistics at Curtin University).
Daryl Tingley of the Department of Mathematics
and Statistics, University of New Brunswick, provided some helpful
insight.  Special thanks are extended to Alan Johnson, of the
Alaska Fisheries Science Centre, who supplied two data sets which
were extremely valuable in tracking down some errors in the code.

Don MacQueen, of Lawrence Livermore National Lab, wrote an Splus
driver function for the old stand-alone version of this software.
That driver, which was available on Statlib, was deprecated in favour
of the Statlib package \dQuote{delaunay}.  Don also collaborated
in the preparation of the latter package.  It is not clear to me
whether the \dQuote{delaunay} package, or indeed Statlib (or indeed
Splus!) still exist.

See the \code{ChangeLog} for information about further revisions
and bug-fixes.
}

\section{Notes on extracting the coordinates}{
The protocol for extracting the \eqn{x} and \eqn{y} coordinates
from the arguments \code{x} and \code{y} is a bit complicated
and confusing.  It is designed to handle a number of different
desiderata and to accommodate various feature-requests that users
have made over the years.  Basically the protocol is:
\itemize{
   \item If \code{x} is a numeric vector and \code{y} is a numeric
   vector then \code{x} is used as the \eqn{x}-coordinates and
   \code{y} is used as the \eqn{y}-coordinates.

   \item If \code{x} is a matrix, a data frame, or a generic list),
   and \code{y} is a numeric vector, then the \eqn{x}-coordinates
   are sought amongst the components of \code{x} and \code{y}
   is used as the \eqn{y}-coordinates.

   \item If \code{x} is a matrix, a data frame, or a generic list
   and \code{y} is not specified or cannot be found, then both the
   \eqn{x}-coordinates and \eqn{y}-coordinates are sought amongst
   the components of \code{x}.

   \item If \code{x} an object of class \code{"ppp"} then both the
   \eqn{x}-coordinates and \eqn{y}-coordinates are taken from the
   components of \code{x}.   If \code{y} is specified, it is ignored
   (with a warning).

   \item If \code{x} is a numeric vector and \code{y} is not specified
   or cannot be found, then an error is thrown.
}
A few more details:
\itemize{
  \item If \code{x} is of class \code{"ppp"} then it will definitely
  have components named \code{"x"} and \code{"y"}.

  \item If \code{x} is a generic list, it \emph{must} have a
  component named \code{"x"} (otherwise an error is thrown),
  and the \eqn{x}-coordinates are set equal to this component.
  If \code{y} is not specified or cannot be found, then a \code{"y"}
  component of \code{x} is sought.  If such a component exists
  then the \eqn{y}-coordinates are set equal to this component.
  Otherwise an error is thrown).

  \item If \code{x} is a matrix or a data frame, the protocol gets
  a bit more intricate.
  \itemize{
     \item If \code{x} has a column named \code{"x"} then this column
     is taken to be the \eqn{x}-coordinates.
     \item Otherwise the \eqn{x}-coordinates are taken to be the
     \emph{first} column of \code{x} that is not named \code{"y"} or
     \code{znm} (where \code{znm} is the name of the object providing
     the \dQuote{tags}, if \dQuote{tags} have been specified).
     \item If there is no such first column (e.g. if there are only
     two columns and these have names \code{"y"} and \code{znm})
     then an error is thrown.
     \item If \code{y} is not specified or cannot be found, and
     if \code{x} has a column named \code{"y"} then this column is
     taken to be the \eqn{y}-coordinates.
     \item Otherwise, in this situation, the \eqn{y}-coordinates
     are taken to be the \emph{first} column of \code{x} that is
     not named \code{"x"} or \code{znm} and is not equal to the
     column previously selected to be the \code{x}-coordinates.
     \item If there is no such first column (e.g. if there are only
     two columns and these have names \code{"x"} and \code{znm}),
     then an error is thrown.
  }
}

Got all that? \code{:-) } If these instructions seem rather
bewildering (and indeed they are!) just keep things simple and make
calls like \code{deldir(x,y)} where \code{x} and \code{y} are numeric
vectors that have been previously assigned in the global environment.
}

\section{Notes on extracting \code{z}}{
If argument \code{x} is a data structure (rather than a numeric
vector) and is \emph{not} an object of class \code{"ppp"} then
\code{z}, if specified and not found, is searched for in \code{x}.
If \code{x} \emph{is} of class \code{"ppp"} then what happens depends
on whether \code{z} was specified or left to take its default value
of \code{NULL}.  In the former case, \code{z} takes the specified
value.  In the latter case the value of \code{"z"} is taken from
the marks of \code{x} provided that \code{x} is indeed a marked
point pattern and that the marks are \emph{atomic} (essentially
provided that the marks are not a data frame). Otherwise \code{z}
is left \code{NULL}, i.e. there are no \dQuote{tags} associated
with the points.
}

\section{Notes on \dQuote{tags}}{
The \dQuote{tags} are simply values that are associated in some way
with the data points and hence with the tiles of the tessellation
produced.  They \bold{DO NOT} affect the tessellation.  In previous
versions of this package (0.2-10 and earlier) the entries of \code{z}
were referred to as \dQuote{weights}.  This terminology has been
changed since it is misleading.  The tessellation produced when
a \code{z} argument is supplied is the same as is it would be
if there were no \code{z} argument (i.e. no \dQuote{weights}).
The \code{deldir} package \bold{DOES NOT do weighted tessellation}.
}

\section{Notes on Memory Allocation}{
It is difficult-to-impossible to determine \emph{a priori} how much
memory needs to be allocated (in the Fortran code) for storing the
edges of the Delaunay triangles and Dirichlet tiles, and for storing
the \dQuote{adjacency list} used by the Lee-Schacter algorithm.
In the code, an attempt is made to allocate sufficient storage.
If, during the course of running the algorithm, the amount of
storage turns out to be inadequate, the algorithm is halted, the
storage is incremented, and the algorithm is restarted (with an
informative message).  This message may be suppressed by wrapping
the call to \code{deldir()} in \code{\link{suppressMessages}()}.
}

\section{Notes on error messages}{

In previous versions of this package, error traps were set in
the underlying Fortran code for 17 different errors. These were
identified by an error number which was passed back up the call stack
and finally printed out by \code{deldir()} which then invisibly
returned a \code{NULL} value.  A glossary of the meanings of the
values of was provided in a file to be found in a file located in the
\code{inst} directory (\dQuote{folder} if you are a Windoze weenie).

This was a pretty shaganappi system.  Consequently, as of version
1.2-1, conversion to \dQuote{proper} error trapping was implemented.
Such error trapping is effected via the \code{rexit()} subroutine
which is now available in \code{R}.  (See \dQuote{Writing R
Extensions}, section 6.2.1.)

Note that when an error is detected, \code{deldir()} now exits with
a genuine error, rather than returning \code{NULL}.  The glossary
of the meanings of \dQuote{error numbers} is now irrelevant and
has been removed from the \code{inst} directory.

An error trap that merits particular mention was introduced in
version \code{0.1-16} of \code{deldir}.  This error trap relates to
\dQuote{triangle problems}.  It was drawn to my attention by Adam
Dadvar (on 18 December, 2018) that in some data sets collinearity
problems may cause the \dQuote{triangle finding} procedure, used
by the algorithm to successively add new points to a tessellation,
to go into an infinite loop.  A symptom of the collinearity is
that the vertices of a putative triangle appear \emph{not} to be
in anticlockwise order irrespective of whether they are presented
in the order \code{i, j, k} or \code{k, j, i}.  The result of this
anomaly is that the procedure keeps alternating between moving to
\dQuote{triangle} \code{i, j, k} and moving to \dQuote{triangle}
\code{k, j, i}, forever.

The error trap in question is set in \code{trifnd}, the triangle
finding subroutine.  It detects such occurrences of \dQuote{clockwise
in either orientation} vertices.  The trap causes the \code{deldir()}
function to throw an error rather than disappearing into a black
hole.

When an error of the \dQuote{triangle problems} nature occurs, a
\emph{possible} remedy is to increase the value of the \code{eps}
argument of \code{deldir()}. (See the \bold{Examples}.)  There may
conceivably be other problems that lead to infinite loops and so I
put in another error trap to detect whether the procedure has
inspected more triangles than actually exist, and if so to throw
an error.

Note that the strategy of increasing the value of \code{eps}
is \emph{probably} the appropriate response in most (if not all)
of the cases where errors of this nature arise.  Similarly this
strategy is \emph{probably} the appropriate response to the errors
\itemize{
    \item Vertices of \dQuote{triangle} are collinear and vertex 2 is not
          between 1 and 3.  Error in circen.
    \item Vertices of triangle are collinear.  Error in dirseg.
    \item Vertices of triangle are collinear.  Error in dirout.
}

However it is impossible to be sure.  The intricacy and numerical
delicacy of triangulations is too great for anyone to be able to
foresee all the possibilities that could arise.

If there is any doubt as to the appropriateness of the
\dQuote{increase \code{eps}} strategy, users are advised to do
their best to explore the data set, graphically or by other means,
and thereby determine what is actually going on and why problems
are occurring.
}

\section{Warnings}{
\enumerate{
\item The process for determining if points are duplicated
changed between versions 0.1-9 and 0.1-10.  Previously there
was an argument \code{frac} for this function, which defaulted
to 0.0001.  Points were deemed to be duplicates if the difference
in \code{x}-coordinates was less than \code{frac} times the width
of \code{rw} and \code{y}-coordinates was less than \code{frac}
times the height of \code{rw}.  This process has been changed to
one which uses \code{\link{duplicated}()} on the data frame whose
columns are \code{x} and \code{y}.

As a result it may happen that points which were previously
eliminated as duplicates will no longer be eliminated.  (And
possibly vice-versa.)

\item The components \code{delsgs} and \code{summary} of the value
returned by \code{deldir()} are now \emph{data frames} rather than
matrices.  The component \code{summary} was changed to allow the
\dQuote{auxiliary} values \code{z} to be of arbitrary mode (i.e.
not necessarily numeric).  The component \code{delsgs} was then
changed for consistency.  Note that the other \dQuote{matrix-like}
component \code{dirsgs} has been a data frame since time immemorial.
}
}
\section{Acknowledgement}{
I would like to express my most warm and sincere thanks to Duncan
Murdoch (Emeritus Professor of Statistics, Western University) for
helping me, with incredible patience and forbearance, to straighten
out my thinking in respect of adjustments that I recently (October
2021) made to the argument processing protocol in the \code{deldir()}
function.  Duncan provided numerous simple examples to demonstrate
when and how things were going wrong, and patiently explained to
me how I was getting one aspect of the protocol backwards.
}
\author{\rolf}

\references{
Lee, D. T. and Schacter, B. J. (1980). Two algorithms for
constructing a Delaunay triangulation, \emph{International Journal
of Computer and Information Sciences} \bold{9} (3), pp. 219 -- 242.

Ahuja, N. and Schacter, B. J. (1983).  Pattern Models.  New York: Wiley.
}
\seealso{
  \code{\link{plot.deldir}()}, \code{\link{tile.list}()}, \code{\link{triang.list}()}
}
\examples{
x <- c(2.3,3.0,7.0,1.0,3.0,8.0)
y <- c(2.3,3.0,2.0,5.0,8.0,9.0)

# Let deldir() choose the rectangular window.
dxy1 <- deldir(x,y)

# User chooses the rectangular window.
dxy2 <- deldir(x,y,rw=c(0,10,0,10))

# Put "dummy" points at the corners of the rectangular
# window, i.e. at (0,0), (10,0), (10,10), and (0,10)
xx <- c(x,0,10,10,0)
yy <- c(y,0,0,10,10)
dxy3 <- deldir(xx,yy,rw=c(0,10,0,10))

# Plot the triangulation created (but not the tessellation).
dxy2 <- deldir(x,y,rw=c(0,10,0,10),plot=TRUE,wl="tr")

# Example of collinearity error.
\dontrun{
    dniP <- deldir(niProperties) # Throws an error
}
    dniP <- deldir(niProperties,eps=1e-8) # No error.

# Example of using data stored in a data frame.
dsw  <- deldir(seaweed)
# Example where "data" is of class "ppp".
dtoy <- deldir(toyPattern)
# The "tags", in dtoy$summary$z, are the marks of the toy ppp
# object which consists of the letters "a","b","c" and "d".

# Artificial example of tags.
set.seed(42)
trees1  <- sample(c("spruce","birch","poplar","shoe"),20,TRUE)
trees2  <- sample(c("fir","maple","larch","palm"),20,TRUE)
egDat   <- data.frame(x=runif(20),y=runif(20),species=trees1)
tagNm   <- "species"
species <- trees2
dd1     <- deldir(egDat) # No tags.
dd2     <- deldir(egDat,z=species)  # Uses trees1 as the tags.
dd3     <- deldir(egDat,z="species") # Same as dd2.
dd4     <- deldir(egDat,z=tagNm) # Same as dd2 and dd3.
spec    <- species
dd5     <- deldir(egDat,z=spec) # Uses trees2 as the tags.

# Duncan Murdoch's examples.  The deldir() function was not
# handling such examples correctly until Duncan kindly set
# me on the right path.
set.seed(123)
dd6 <- deldir(rnorm(32),rnorm(32),rnorm(32))
#
x <- cbind(x = 1:10, junk = 11:20)
y <- 21:30
z <- 31:40
d7 <- deldir(x=x, y=y, z=z)
#
# print(d7$summary) reveals that x is 1:10, y is 21:30
# and z is 31:40; x[,"junk"] is ignored as it should be.
x <- cbind(x = 1:10, "rnorm(10)" = 11:20)
y <- 21:30
z <- 41:50
d8 <- deldir(x=x, y=y, z=rnorm(10))  
#
# print(d8$summary) reveals that x is 1:10, y is 21:30 and z is a
# vector of standard normal values.  Even though x has a column with
# the name of the z argument i.e. "rnorm(10)" (!!!)  the specified
# value of z takes precedence over this column (and, as per the usual
# R syntax) over the object named "z" in the global environment.

# Artificial example of the use of the "id" argument.
set.seed(42)
x  <- runif(50)
y  <- runif(50)
ll <- expand.grid(a=letters[1:10],b=letters[1:10])
aa <- sample(paste0(ll[["a"]],ll[["b"]]),50)
dxy.wid <- deldir(x,y,id=aa)
}

\keyword{spatial}
